/* Generated automatically with "cito". Do not edit. */
#include <stdlib.h>
#include <string.h>
#include "asap.h"

typedef enum {
	ASAPModuleType_SAP_B,
	ASAPModuleType_SAP_C,
	ASAPModuleType_SAP_D,
	ASAPModuleType_SAP_S,
	ASAPModuleType_CMC,
	ASAPModuleType_CM3,
	ASAPModuleType_CMR,
	ASAPModuleType_CMS,
	ASAPModuleType_DLT,
	ASAPModuleType_MPT,
	ASAPModuleType_RMT,
	ASAPModuleType_TMC,
	ASAPModuleType_TM2,
	ASAPModuleType_FC
}
ASAPModuleType;
typedef struct Cpu6502 Cpu6502;
typedef struct FlashPack FlashPack;
typedef struct FlashPackItem FlashPackItem;

typedef enum {
	FlashPackItemType_LITERAL,
	FlashPackItemType_COPY_TWO_BYTES,
	FlashPackItemType_COPY_THREE_BYTES,
	FlashPackItemType_COPY_MANY_BYTES,
	FlashPackItemType_SET_ADDRESS,
	FlashPackItemType_END_OF_STREAM
}
FlashPackItemType;

typedef enum {
	FlashPackLoadState_START_LOW_BYTE,
	FlashPackLoadState_START_HIGH_BYTE,
	FlashPackLoadState_END_LOW_BYTE,
	FlashPackLoadState_END_HIGH_BYTE,
	FlashPackLoadState_CONTENT
}
FlashPackLoadState;

typedef enum {
	NmiStatus_RESET,
	NmiStatus_ON_V_BLANK,
	NmiStatus_WAS_V_BLANK
}
NmiStatus;
typedef struct Pokey Pokey;
typedef struct PokeyPair PokeyPair;

struct Cpu6502 {
	int a;
	int c;
	int nz;
	int pc;
	int s;
	int vdi;
	int x;
	int y;
};
static void Cpu6502_DoFrame(Cpu6502 *self, ASAP *asap, int cycleLimit);

struct ASAPInfo {
	int channels;
	int covoxAddr;
	int defaultSong;
	int fastplay;
	int headerLen;
	int init;
	int music;
	cibool ntsc;
	int player;
	int songs;
	ASAPModuleType type;
	unsigned char songPos[32];
	char author[128];
	char date[128];
	int durations[32];
	char filename[128];
	cibool loops[32];
	char title[128];
};
static void ASAPInfo_AddSong(ASAPInfo *self, int playerCalls);
static int ASAPInfo_AfterFF(unsigned char const *module, int moduleLen, int currentOffset);
static int ASAPInfo_CheckDate(ASAPInfo const *self);
static cibool ASAPInfo_CheckTwoDateDigits(ASAPInfo const *self, int i);
static cibool ASAPInfo_CheckValidChar(int c);
static cibool ASAPInfo_CheckValidText(const char *s);
static int ASAPInfo_GetPackedExt(const char *filename);
static int ASAPInfo_GetRmtInstrumentFrames(unsigned char const *module, int instrument, int volume, int volumeFrame, cibool onExtraPokey);
static int ASAPInfo_GetRmtSapOffset(ASAPInfo const *self, unsigned char const *module, int moduleLen);
static int ASAPInfo_GetTwoDateDigits(ASAPInfo const *self, int i);
static int ASAPInfo_GetWord(unsigned char const *array, int i);
static int ASAPInfo_GuessPackedExt(unsigned char const *module, int moduleLen);
static cibool ASAPInfo_HasStringAt(unsigned char const *module, int moduleIndex, const char *s);
static cibool ASAPInfo_IsDltPatternEnd(unsigned char const *module, int pos, int i);
static cibool ASAPInfo_IsDltTrackEmpty(unsigned char const *module, int pos);
static cibool ASAPInfo_IsFcSongEnd(unsigned char const *module, int const *trackPos);
static cibool ASAPInfo_IsOurPackedExt(int ext);
static cibool ASAPInfo_IsValidChar(int c);
static cibool ASAPInfo_ParseCmc(ASAPInfo *self, unsigned char const *module, int moduleLen, ASAPModuleType type);
static void ASAPInfo_ParseCmcSong(ASAPInfo *self, unsigned char const *module, int pos);
static int ASAPInfo_ParseDec(unsigned char const *module, int moduleIndex, int maxVal);
static cibool ASAPInfo_ParseDlt(ASAPInfo *self, unsigned char const *module, int moduleLen);
static void ASAPInfo_ParseDltSong(ASAPInfo *self, unsigned char const *module, cibool *seen, int pos);
static cibool ASAPInfo_ParseFc(ASAPInfo *self, unsigned char const *module, int moduleLen);
static int ASAPInfo_ParseHex(unsigned char const *module, int moduleIndex);
static cibool ASAPInfo_ParseModule(ASAPInfo *self, unsigned char const *module, int moduleLen);
static cibool ASAPInfo_ParseMpt(ASAPInfo *self, unsigned char const *module, int moduleLen);
static void ASAPInfo_ParseMptSong(ASAPInfo *self, unsigned char const *module, cibool *globalSeen, int songLen, int pos);
static cibool ASAPInfo_ParseRmt(ASAPInfo *self, unsigned char const *module, int moduleLen);
static void ASAPInfo_ParseRmtSong(ASAPInfo *self, unsigned char const *module, cibool *globalSeen, int songLen, int posShift, int pos);
static cibool ASAPInfo_ParseSap(ASAPInfo *self, unsigned char const *module, int moduleLen);
static int ASAPInfo_ParseText(unsigned char const *module, int moduleIndex);
static cibool ASAPInfo_ParseTm2(ASAPInfo *self, unsigned char const *module, int moduleLen);
static void ASAPInfo_ParseTm2Song(ASAPInfo *self, unsigned char const *module, int pos);
static cibool ASAPInfo_ParseTmc(ASAPInfo *self, unsigned char const *module, int moduleLen);
static void ASAPInfo_ParseTmcSong(ASAPInfo *self, unsigned char const *module, int pos);
static int ASAPInfo_ParseTmcTitle(unsigned char *title, int titleLen, unsigned char const *module, int moduleOffset);
static cibool ASAPInfo_ValidateFc(unsigned char const *module, int moduleLen);
static cibool ASAPInfo_ValidateRmt(unsigned char const *module, int moduleLen);
static cibool ASAPInfo_ValidateSap(unsigned char const *module, int moduleLen);

struct Pokey {
	int audc1;
	int audc2;
	int audc3;
	int audc4;
	int audctl;
	int audf1;
	int audf2;
	int audf3;
	int audf4;
	int delta1;
	int delta2;
	int delta3;
	int delta4;
	int divCycles;
	cibool init;
	int mute1;
	int mute2;
	int mute3;
	int mute4;
	int out1;
	int out2;
	int out3;
	int out4;
	int periodCycles1;
	int periodCycles2;
	int periodCycles3;
	int periodCycles4;
	int polyIndex;
	int reloadCycles1;
	int reloadCycles3;
	int skctl;
	int tickCycle1;
	int tickCycle2;
	int tickCycle3;
	int tickCycle4;
	int deltaBuffer[888];
};
static void Pokey_AddDelta(Pokey *self, PokeyPair const *pokeys, int cycle, int delta);
static void Pokey_EndFrame(Pokey *self, PokeyPair const *pokeys, int cycle);
static void Pokey_GenerateUntilCycle(Pokey *self, PokeyPair const *pokeys, int cycleLimit);
static void Pokey_Initialize(Pokey *self);
static cibool Pokey_IsSilent(Pokey const *self);
static void Pokey_Mute(Pokey *self, int mask);

struct PokeyPair {
	int extraPokeyMask;
	int iirAccLeft;
	int iirAccRight;
	int irqst;
	int readySamplesEnd;
	int readySamplesStart;
	int sampleFactor;
	int sampleOffset;
	int timer1Cycle;
	int timer2Cycle;
	int timer4Cycle;
	unsigned char poly9Lookup[511];
	Pokey basePokey;
	Pokey extraPokey;
	unsigned char poly17Lookup[16385];
};
static void PokeyPair_Construct(PokeyPair *self);
static int PokeyPair_EndFrame(PokeyPair *self, int cycle);
static int PokeyPair_Generate(PokeyPair *self, unsigned char *buffer, int bufferOffset, int blocks, ASAPSampleFormat format);
static int PokeyPair_GetRandom(PokeyPair const *self, int addr, int cycle);
static void PokeyPair_Initialize(PokeyPair *self, cibool ntsc, cibool stereo);
static cibool PokeyPair_IsSilent(PokeyPair const *self);
static void PokeyPair_Poke(PokeyPair *self, int addr, int data, int cycle);
static void PokeyPair_StartFrame(PokeyPair *self);

struct ASAP {
	int blocksPlayed;
	int consol;
	unsigned char covox[4];
	int currentDuration;
	int currentSong;
	int cycle;
	int nextEventCycle;
	int nextPlayerCycle;
	int nextScanlineCycle;
	NmiStatus nmist;
	int silenceCycles;
	int silenceCyclesCounter;
	int tmcPerFrameCounter;
	Cpu6502 cpu;
	ASAPInfo moduleInfo;
	PokeyPair pokeys;
	unsigned char memory[65536];
};
static void ASAP_Construct(ASAP *self);
static void ASAP_Call6502(ASAP *self, int addr);
static void ASAP_Call6502Player(ASAP *self);
static int ASAP_Do6502Frame(ASAP *self);
static cibool ASAP_Do6502Init(ASAP *self, int pc, int a, int x, int y);
static int ASAP_DoFrame(ASAP *self);
static int ASAP_GenerateAt(ASAP *self, unsigned char *buffer, int bufferOffset, int bufferLen, ASAPSampleFormat format);
static void ASAP_HandleEvent(ASAP *self);
static int ASAP_MillisecondsToBlocks(int milliseconds);
static int ASAP_PeekHardware(ASAP const *self, int addr);
static void ASAP_PokeHardware(ASAP *self, int addr, int data);
static void ASAP_PutLittleEndian(unsigned char *buffer, int offset, int value);
static void ASAP_PutLittleEndians(unsigned char *buffer, int offset, int value1, int value2);
static int ASAP_PutWavMetadata(unsigned char *buffer, int offset, int fourCC, const char *value);

static unsigned char const *ASAP6502_GetPlayerRoutine(ASAPInfo const *info);
static const unsigned char CiBinaryResource_cm3_obx[2022] = { 255, 255, 0, 5, 223, 12, 76, 18, 11, 76, 120, 5, 76, 203, 7, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 160, 227, 237, 227, 160, 240, 236, 225,
	249, 229, 242, 160, 246, 160, 178, 174, 177, 160, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255,
	255, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 128, 128, 128, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 110,
	5, 142, 111, 5, 140, 112, 5, 41, 112, 74, 74, 74, 170, 189, 148, 11,
	141, 169, 5, 189, 149, 11, 141, 170, 5, 169, 3, 141, 15, 210, 216, 165,
	254, 72, 165, 255, 72, 172, 112, 5, 174, 111, 5, 173, 110, 5, 32, 178,
	5, 104, 133, 255, 104, 133, 254, 96, 173, 118, 5, 133, 254, 173, 119, 5,
	133, 255, 160, 0, 138, 240, 28, 177, 254, 201, 143, 240, 4, 201, 239, 208,
	12, 202, 208, 9, 200, 192, 84, 176, 9, 152, 170, 16, 6, 200, 192, 84,
	144, 229, 96, 142, 104, 5, 32, 123, 6, 169, 0, 162, 9, 157, 69, 5,
	202, 16, 250, 141, 103, 5, 169, 1, 141, 113, 5, 169, 255, 141, 106, 5,
	173, 114, 5, 133, 254, 173, 115, 5, 133, 255, 160, 19, 177, 254, 170, 173,
	118, 5, 133, 254, 173, 119, 5, 133, 255, 172, 104, 5, 177, 254, 201, 207,
	208, 13, 152, 24, 105, 85, 168, 177, 254, 48, 15, 170, 76, 52, 6, 201,
	143, 240, 7, 201, 239, 240, 3, 136, 16, 226, 142, 108, 5, 142, 109, 5,
	96, 41, 15, 240, 245, 142, 221, 10, 142, 243, 10, 142, 2, 11, 140, 222,
	10, 140, 244, 10, 140, 3, 11, 96, 142, 114, 5, 134, 254, 140, 115, 5,
	132, 255, 24, 138, 105, 20, 141, 116, 5, 152, 105, 0, 141, 117, 5, 142,
	118, 5, 200, 200, 140, 119, 5, 160, 19, 177, 254, 141, 108, 5, 141, 109,
	5, 162, 8, 169, 0, 141, 113, 5, 157, 0, 210, 224, 3, 176, 8, 157,
	9, 5, 169, 255, 157, 57, 5, 202, 16, 233, 169, 128, 162, 3, 157, 75,
	5, 202, 16, 250, 96, 169, 1, 141, 113, 5, 169, 0, 240, 238, 41, 3,
	201, 3, 240, 240, 224, 64, 176, 236, 192, 26, 176, 232, 170, 169, 128, 157,
	75, 5, 169, 0, 157, 57, 5, 157, 60, 5, 157, 63, 5, 173, 111, 5,
	157, 12, 5, 173, 112, 5, 10, 10, 10, 133, 254, 24, 173, 114, 5, 105,
	48, 72, 173, 115, 5, 105, 1, 168, 104, 24, 101, 254, 157, 97, 5, 152,
	105, 0, 157, 100, 5, 24, 173, 114, 5, 105, 148, 133, 254, 173, 115, 5,
	105, 0, 133, 255, 173, 112, 5, 10, 109, 112, 5, 10, 168, 177, 254, 157,
	79, 5, 200, 177, 254, 157, 82, 5, 41, 7, 141, 110, 5, 200, 177, 254,
	157, 85, 5, 200, 177, 254, 157, 88, 5, 200, 177, 254, 157, 91, 5, 200,
	177, 254, 157, 94, 5, 160, 0, 173, 110, 5, 201, 3, 208, 2, 160, 2,
	201, 7, 208, 2, 160, 4, 185, 178, 11, 133, 254, 185, 179, 11, 133, 255,
	189, 85, 5, 74, 74, 74, 74, 24, 109, 111, 5, 141, 111, 5, 141, 194,
	7, 168, 173, 110, 5, 201, 7, 208, 15, 152, 10, 168, 177, 254, 157, 45,
	5, 200, 140, 111, 5, 76, 131, 7, 177, 254, 157, 45, 5, 189, 85, 5,
	41, 15, 24, 109, 111, 5, 141, 111, 5, 172, 111, 5, 173, 110, 5, 201,
	5, 8, 177, 254, 40, 240, 8, 221, 45, 5, 208, 3, 56, 233, 1, 157,
	48, 5, 189, 79, 5, 72, 41, 3, 168, 185, 184, 11, 157, 54, 5, 104,
	74, 74, 74, 74, 160, 62, 201, 15, 240, 16, 160, 55, 201, 14, 240, 10,
	160, 48, 201, 13, 240, 4, 24, 105, 0, 168, 185, 188, 11, 157, 51, 5,
	96, 216, 165, 252, 72, 165, 253, 72, 165, 254, 72, 165, 255, 72, 173, 113,
	5, 208, 3, 76, 5, 11, 173, 78, 5, 240, 3, 76, 110, 9, 173, 108,
	5, 205, 109, 5, 240, 3, 76, 91, 9, 173, 103, 5, 240, 3, 76, 220,
	8, 162, 2, 188, 75, 5, 48, 3, 157, 75, 5, 157, 69, 5, 202, 16,
	242, 173, 118, 5, 133, 252, 173, 119, 5, 133, 253, 172, 104, 5, 132, 254,
	204, 106, 5, 208, 25, 173, 107, 5, 240, 20, 173, 104, 5, 172, 105, 5,
	140, 104, 5, 206, 107, 5, 208, 232, 141, 104, 5, 168, 16, 226, 162, 0,
	177, 252, 201, 254, 208, 14, 172, 104, 5, 200, 196, 254, 240, 67, 140, 104,
	5, 76, 26, 8, 157, 66, 5, 24, 152, 105, 85, 168, 232, 224, 3, 144,
	223, 172, 104, 5, 177, 252, 16, 122, 201, 255, 240, 118, 74, 74, 74, 41,
	14, 170, 189, 164, 11, 141, 126, 8, 189, 165, 11, 141, 127, 8, 173, 67,
	5, 133, 255, 32, 147, 8, 140, 104, 5, 192, 85, 176, 4, 196, 254, 208,
	143, 164, 254, 140, 104, 5, 76, 5, 11, 32, 148, 6, 160, 255, 96, 48,
	251, 168, 96, 48, 247, 56, 152, 229, 255, 168, 96, 48, 239, 24, 152, 101,
	255, 168, 96, 48, 231, 141, 108, 5, 141, 109, 5, 200, 96, 48, 221, 173,
	68, 5, 48, 216, 141, 107, 5, 200, 140, 105, 5, 24, 152, 101, 255, 141,
	106, 5, 96, 136, 48, 10, 177, 252, 201, 143, 240, 4, 201, 239, 208, 243,
	200, 96, 162, 2, 189, 72, 5, 240, 5, 222, 72, 5, 16, 99, 189, 75,
	5, 208, 94, 188, 66, 5, 192, 64, 176, 87, 173, 116, 5, 133, 252, 173,
	117, 5, 133, 253, 177, 252, 133, 254, 24, 152, 105, 64, 168, 177, 252, 133,
	255, 37, 254, 201, 255, 240, 58, 188, 69, 5, 177, 254, 41, 192, 208, 12,
	177, 254, 41, 63, 157, 15, 5, 254, 69, 5, 16, 235, 201, 64, 208, 19,
	177, 254, 41, 63, 141, 111, 5, 189, 15, 5, 141, 112, 5, 32, 188, 6,
	76, 72, 9, 201, 128, 208, 10, 177, 254, 41, 63, 157, 72, 5, 254, 69,
	5, 202, 16, 144, 174, 103, 5, 232, 224, 48, 144, 2, 162, 0, 142, 103,
	5, 206, 109, 5, 208, 14, 173, 108, 5, 141, 109, 5, 173, 103, 5, 208,
	3, 238, 104, 5, 172, 48, 5, 173, 82, 5, 41, 7, 201, 5, 240, 4,
	201, 6, 208, 1, 136, 140, 39, 5, 160, 0, 201, 5, 240, 4, 201, 6,
	208, 2, 160, 2, 201, 7, 208, 2, 160, 40, 140, 44, 5, 162, 2, 189,
	82, 5, 41, 224, 157, 40, 5, 189, 97, 5, 133, 252, 189, 100, 5, 133,
	253, 189, 57, 5, 201, 255, 240, 54, 201, 15, 208, 32, 189, 63, 5, 240,
	45, 222, 63, 5, 189, 63, 5, 208, 37, 188, 9, 5, 240, 1, 136, 152,
	157, 9, 5, 189, 88, 5, 157, 63, 5, 76, 232, 9, 189, 57, 5, 74,
	168, 177, 252, 144, 4, 74, 74, 74, 74, 41, 15, 157, 9, 5, 188, 45,
	5, 189, 82, 5, 41, 7, 201, 1, 208, 31, 136, 152, 200, 221, 48, 5,
	8, 169, 1, 40, 208, 2, 10, 10, 61, 60, 5, 240, 12, 188, 48, 5,
	192, 255, 208, 5, 169, 0, 157, 9, 5, 152, 157, 36, 5, 169, 1, 141,
	110, 5, 189, 57, 5, 201, 15, 240, 56, 41, 7, 168, 185, 208, 12, 133,
	254, 189, 57, 5, 41, 8, 8, 138, 40, 24, 240, 2, 105, 3, 168, 185,
	91, 5, 37, 254, 240, 27, 189, 51, 5, 157, 36, 5, 142, 110, 5, 202,
	16, 8, 141, 39, 5, 169, 0, 141, 44, 5, 232, 189, 54, 5, 157, 40,
	5, 189, 57, 5, 41, 15, 201, 15, 240, 16, 254, 57, 5, 189, 57, 5,
	201, 15, 208, 6, 189, 88, 5, 157, 63, 5, 189, 75, 5, 16, 10, 189,
	9, 5, 208, 5, 169, 64, 157, 75, 5, 254, 60, 5, 160, 0, 189, 82,
	5, 74, 74, 74, 74, 144, 1, 136, 74, 144, 1, 200, 24, 152, 125, 45,
	5, 157, 45, 5, 189, 48, 5, 201, 255, 208, 2, 160, 0, 24, 152, 125,
	48, 5, 157, 48, 5, 202, 48, 3, 76, 153, 9, 173, 40, 5, 141, 43,
	5, 173, 82, 5, 41, 7, 170, 160, 3, 173, 110, 5, 240, 3, 188, 216,
	12, 152, 72, 185, 188, 12, 8, 41, 127, 170, 152, 41, 3, 10, 168, 189,
	36, 5, 153, 0, 210, 200, 189, 9, 5, 224, 3, 208, 3, 173, 9, 5,
	29, 40, 5, 40, 16, 2, 169, 0, 153, 0, 210, 104, 168, 136, 41, 3,
	208, 207, 160, 8, 173, 44, 5, 153, 0, 210, 24, 104, 133, 255, 104, 133,
	254, 104, 133, 253, 104, 133, 252, 96, 104, 170, 240, 78, 201, 2, 240, 6,
	104, 104, 202, 208, 251, 96, 165, 20, 197, 20, 240, 252, 173, 36, 2, 201,
	137, 208, 7, 173, 37, 2, 201, 11, 240, 230, 173, 36, 2, 141, 146, 11,
	173, 37, 2, 141, 147, 11, 169, 137, 141, 36, 2, 169, 11, 141, 37, 2,
	104, 104, 240, 3, 56, 233, 1, 141, 96, 11, 104, 168, 104, 170, 169, 112,
	32, 120, 5, 169, 0, 162, 0, 76, 120, 5, 165, 20, 197, 20, 240, 252,
	173, 36, 2, 201, 137, 208, 174, 173, 37, 2, 201, 11, 208, 167, 173, 146,
	11, 141, 36, 2, 173, 147, 11, 141, 37, 2, 169, 64, 76, 120, 5, 32,
	203, 7, 144, 3, 32, 120, 11, 76, 255, 255, 178, 5, 221, 5, 168, 6,
	59, 6, 123, 6, 148, 6, 159, 6, 82, 6, 147, 8, 153, 8, 157, 8,
	165, 8, 173, 8, 183, 8, 205, 8, 188, 11, 253, 11, 62, 12, 128, 160,
	32, 64, 255, 241, 228, 215, 203, 192, 181, 170, 161, 152, 143, 135, 127, 120,
	114, 107, 101, 95, 90, 85, 80, 75, 71, 67, 63, 60, 56, 53, 50, 47,
	44, 42, 39, 37, 35, 33, 31, 29, 28, 26, 24, 23, 22, 20, 19, 18,
	17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2,
	1, 0, 0, 0, 0, 0, 0, 242, 233, 218, 206, 191, 182, 170, 161, 152,
	143, 137, 128, 122, 113, 107, 101, 95, 0, 86, 80, 103, 96, 90, 85, 81,
	76, 72, 67, 63, 61, 57, 52, 51, 57, 45, 42, 40, 37, 36, 33, 31,
	30, 0, 0, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3,
	2, 1, 0, 0, 56, 11, 140, 10, 0, 10, 106, 9, 232, 8, 106, 8,
	239, 7, 128, 7, 8, 7, 174, 6, 70, 6, 230, 5, 149, 5, 65, 5,
	246, 4, 176, 4, 110, 4, 48, 4, 246, 3, 187, 3, 132, 3, 82, 3,
	34, 3, 244, 2, 200, 2, 160, 2, 122, 2, 85, 2, 52, 2, 20, 2,
	245, 1, 216, 1, 189, 1, 164, 1, 141, 1, 119, 1, 96, 1, 78, 1,
	56, 1, 39, 1, 21, 1, 6, 1, 247, 0, 232, 0, 219, 0, 207, 0,
	195, 0, 184, 0, 172, 0, 162, 0, 154, 0, 144, 0, 136, 0, 127, 0,
	120, 0, 112, 0, 106, 0, 100, 0, 94, 0, 87, 0, 82, 0, 50, 0,
	10, 0, 0, 1, 2, 131, 0, 1, 2, 3, 1, 0, 2, 131, 1, 0,
	2, 3, 1, 2, 128, 3, 128, 64, 32, 16, 8, 4, 2, 1, 3, 3,
	3, 3, 7, 11, 15, 19 };
static const unsigned char CiBinaryResource_cmc_obx[2019] = { 255, 255, 0, 5, 220, 12, 76, 15, 11, 76, 120, 5, 76, 203, 7, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 160, 227, 237, 227, 160, 240, 236, 225,
	249, 229, 242, 160, 246, 160, 178, 174, 177, 160, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255,
	255, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 128, 128, 128, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 110,
	5, 142, 111, 5, 140, 112, 5, 41, 112, 74, 74, 74, 170, 189, 145, 11,
	141, 169, 5, 189, 146, 11, 141, 170, 5, 169, 3, 141, 15, 210, 216, 165,
	254, 72, 165, 255, 72, 172, 112, 5, 174, 111, 5, 173, 110, 5, 32, 178,
	5, 104, 133, 255, 104, 133, 254, 96, 173, 118, 5, 133, 254, 173, 119, 5,
	133, 255, 160, 0, 138, 240, 28, 177, 254, 201, 143, 240, 4, 201, 239, 208,
	12, 202, 208, 9, 200, 192, 84, 176, 9, 152, 170, 16, 6, 200, 192, 84,
	144, 229, 96, 142, 104, 5, 32, 123, 6, 169, 0, 162, 9, 157, 69, 5,
	202, 16, 250, 141, 103, 5, 169, 1, 141, 113, 5, 169, 255, 141, 106, 5,
	173, 114, 5, 133, 254, 173, 115, 5, 133, 255, 160, 19, 177, 254, 170, 173,
	118, 5, 133, 254, 173, 119, 5, 133, 255, 172, 104, 5, 177, 254, 201, 207,
	208, 13, 152, 24, 105, 85, 168, 177, 254, 48, 15, 170, 76, 52, 6, 201,
	143, 240, 7, 201, 239, 240, 3, 136, 16, 226, 142, 108, 5, 142, 109, 5,
	96, 41, 15, 240, 245, 142, 218, 10, 142, 240, 10, 142, 255, 10, 140, 219,
	10, 140, 241, 10, 140, 0, 11, 96, 142, 114, 5, 134, 254, 140, 115, 5,
	132, 255, 24, 138, 105, 20, 141, 116, 5, 152, 105, 0, 141, 117, 5, 142,
	118, 5, 200, 200, 140, 119, 5, 160, 19, 177, 254, 141, 108, 5, 141, 109,
	5, 162, 8, 169, 0, 141, 113, 5, 157, 0, 210, 224, 3, 176, 8, 157,
	9, 5, 169, 255, 157, 57, 5, 202, 16, 233, 169, 128, 162, 3, 157, 75,
	5, 202, 16, 250, 96, 169, 1, 141, 113, 5, 169, 0, 240, 238, 41, 3,
	201, 3, 240, 240, 224, 64, 176, 236, 192, 26, 176, 232, 170, 169, 128, 157,
	75, 5, 169, 0, 157, 57, 5, 157, 60, 5, 157, 63, 5, 173, 111, 5,
	157, 12, 5, 173, 112, 5, 10, 10, 10, 133, 254, 24, 173, 114, 5, 105,
	48, 72, 173, 115, 5, 105, 1, 168, 104, 24, 101, 254, 157, 97, 5, 152,
	105, 0, 157, 100, 5, 24, 173, 114, 5, 105, 148, 133, 254, 173, 115, 5,
	105, 0, 133, 255, 173, 112, 5, 10, 109, 112, 5, 10, 168, 177, 254, 157,
	79, 5, 200, 177, 254, 157, 82, 5, 41, 7, 141, 110, 5, 200, 177, 254,
	157, 85, 5, 200, 177, 254, 157, 88, 5, 200, 177, 254, 157, 91, 5, 200,
	177, 254, 157, 94, 5, 160, 0, 173, 110, 5, 201, 3, 208, 2, 160, 2,
	201, 7, 208, 2, 160, 4, 185, 175, 11, 133, 254, 185, 176, 11, 133, 255,
	189, 85, 5, 74, 74, 74, 74, 24, 109, 111, 5, 141, 111, 5, 141, 194,
	7, 168, 173, 110, 5, 201, 7, 208, 15, 152, 10, 168, 177, 254, 157, 45,
	5, 200, 140, 111, 5, 76, 131, 7, 177, 254, 157, 45, 5, 189, 85, 5,
	41, 15, 24, 109, 111, 5, 141, 111, 5, 172, 111, 5, 173, 110, 5, 201,
	5, 8, 177, 254, 40, 240, 8, 221, 45, 5, 208, 3, 56, 233, 1, 157,
	48, 5, 189, 79, 5, 72, 41, 3, 168, 185, 181, 11, 157, 54, 5, 104,
	74, 74, 74, 74, 160, 62, 201, 15, 240, 16, 160, 55, 201, 14, 240, 10,
	160, 48, 201, 13, 240, 4, 24, 105, 0, 168, 185, 185, 11, 157, 51, 5,
	96, 216, 165, 252, 72, 165, 253, 72, 165, 254, 72, 165, 255, 72, 173, 113,
	5, 208, 3, 76, 2, 11, 173, 78, 5, 240, 3, 76, 107, 9, 173, 108,
	5, 205, 109, 5, 240, 3, 76, 88, 9, 173, 103, 5, 240, 3, 76, 220,
	8, 162, 2, 188, 75, 5, 48, 3, 157, 75, 5, 157, 69, 5, 202, 16,
	242, 173, 118, 5, 133, 252, 173, 119, 5, 133, 253, 172, 104, 5, 132, 254,
	204, 106, 5, 208, 25, 173, 107, 5, 240, 20, 173, 104, 5, 172, 105, 5,
	140, 104, 5, 206, 107, 5, 208, 232, 141, 104, 5, 168, 16, 226, 162, 0,
	177, 252, 201, 254, 208, 14, 172, 104, 5, 200, 196, 254, 240, 67, 140, 104,
	5, 76, 26, 8, 157, 66, 5, 24, 152, 105, 85, 168, 232, 224, 3, 144,
	223, 172, 104, 5, 177, 252, 16, 122, 201, 255, 240, 118, 74, 74, 74, 41,
	14, 170, 189, 161, 11, 141, 126, 8, 189, 162, 11, 141, 127, 8, 173, 67,
	5, 133, 255, 32, 147, 8, 140, 104, 5, 192, 85, 176, 4, 196, 254, 208,
	143, 164, 254, 140, 104, 5, 76, 2, 11, 32, 148, 6, 160, 255, 96, 48,
	251, 168, 96, 48, 247, 56, 152, 229, 255, 168, 96, 48, 239, 24, 152, 101,
	255, 168, 96, 48, 231, 141, 108, 5, 141, 109, 5, 200, 96, 48, 221, 173,
	68, 5, 48, 216, 141, 107, 5, 200, 140, 105, 5, 24, 152, 101, 255, 141,
	106, 5, 96, 136, 48, 10, 177, 252, 201, 143, 240, 4, 201, 239, 208, 243,
	200, 96, 162, 2, 189, 72, 5, 240, 5, 222, 72, 5, 16, 99, 189, 75,
	5, 208, 94, 188, 66, 5, 192, 64, 176, 87, 173, 116, 5, 133, 252, 173,
	117, 5, 133, 253, 177, 252, 133, 254, 24, 152, 105, 64, 168, 177, 252, 133,
	255, 37, 254, 201, 255, 240, 58, 188, 69, 5, 177, 254, 41, 192, 208, 12,
	177, 254, 41, 63, 157, 15, 5, 254, 69, 5, 16, 235, 201, 64, 208, 19,
	177, 254, 41, 63, 141, 111, 5, 189, 15, 5, 141, 112, 5, 32, 188, 6,
	76, 72, 9, 201, 128, 208, 10, 177, 254, 41, 63, 157, 72, 5, 254, 69,
	5, 202, 16, 144, 174, 103, 5, 232, 138, 41, 63, 141, 103, 5, 206, 109,
	5, 208, 14, 173, 108, 5, 141, 109, 5, 173, 103, 5, 208, 3, 238, 104,
	5, 172, 48, 5, 173, 82, 5, 41, 7, 201, 5, 240, 4, 201, 6, 208,
	1, 136, 140, 39, 5, 160, 0, 201, 5, 240, 4, 201, 6, 208, 2, 160,
	2, 201, 7, 208, 2, 160, 40, 140, 44, 5, 162, 2, 189, 82, 5, 41,
	224, 157, 40, 5, 189, 97, 5, 133, 252, 189, 100, 5, 133, 253, 189, 57,
	5, 201, 255, 240, 54, 201, 15, 208, 32, 189, 63, 5, 240, 45, 222, 63,
	5, 189, 63, 5, 208, 37, 188, 9, 5, 240, 1, 136, 152, 157, 9, 5,
	189, 88, 5, 157, 63, 5, 76, 229, 9, 189, 57, 5, 74, 168, 177, 252,
	144, 4, 74, 74, 74, 74, 41, 15, 157, 9, 5, 188, 45, 5, 189, 82,
	5, 41, 7, 201, 1, 208, 31, 136, 152, 200, 221, 48, 5, 8, 169, 1,
	40, 208, 2, 10, 10, 61, 60, 5, 240, 12, 188, 48, 5, 192, 255, 208,
	5, 169, 0, 157, 9, 5, 152, 157, 36, 5, 169, 1, 141, 110, 5, 189,
	57, 5, 201, 15, 240, 56, 41, 7, 168, 185, 205, 12, 133, 254, 189, 57,
	5, 41, 8, 8, 138, 40, 24, 240, 2, 105, 3, 168, 185, 91, 5, 37,
	254, 240, 27, 189, 51, 5, 157, 36, 5, 142, 110, 5, 202, 16, 8, 141,
	39, 5, 169, 0, 141, 44, 5, 232, 189, 54, 5, 157, 40, 5, 189, 57,
	5, 41, 15, 201, 15, 240, 16, 254, 57, 5, 189, 57, 5, 201, 15, 208,
	6, 189, 88, 5, 157, 63, 5, 189, 75, 5, 16, 10, 189, 9, 5, 208,
	5, 169, 64, 157, 75, 5, 254, 60, 5, 160, 0, 189, 82, 5, 74, 74,
	74, 74, 144, 1, 136, 74, 144, 1, 200, 24, 152, 125, 45, 5, 157, 45,
	5, 189, 48, 5, 201, 255, 208, 2, 160, 0, 24, 152, 125, 48, 5, 157,
	48, 5, 202, 48, 3, 76, 150, 9, 173, 40, 5, 141, 43, 5, 173, 82,
	5, 41, 7, 170, 160, 3, 173, 110, 5, 240, 3, 188, 213, 12, 152, 72,
	185, 185, 12, 8, 41, 127, 170, 152, 41, 3, 10, 168, 189, 36, 5, 153,
	0, 210, 200, 189, 9, 5, 224, 3, 208, 3, 173, 9, 5, 29, 40, 5,
	40, 16, 2, 169, 0, 153, 0, 210, 104, 168, 136, 41, 3, 208, 207, 160,
	8, 173, 44, 5, 153, 0, 210, 24, 104, 133, 255, 104, 133, 254, 104, 133,
	253, 104, 133, 252, 96, 104, 170, 240, 78, 201, 2, 240, 6, 104, 104, 202,
	208, 251, 96, 165, 20, 197, 20, 240, 252, 173, 36, 2, 201, 134, 208, 7,
	173, 37, 2, 201, 11, 240, 230, 173, 36, 2, 141, 143, 11, 173, 37, 2,
	141, 144, 11, 169, 134, 141, 36, 2, 169, 11, 141, 37, 2, 104, 104, 240,
	3, 56, 233, 1, 141, 93, 11, 104, 168, 104, 170, 169, 112, 32, 120, 5,
	169, 0, 162, 0, 76, 120, 5, 165, 20, 197, 20, 240, 252, 173, 36, 2,
	201, 134, 208, 174, 173, 37, 2, 201, 11, 208, 167, 173, 143, 11, 141, 36,
	2, 173, 144, 11, 141, 37, 2, 169, 64, 76, 120, 5, 32, 203, 7, 144,
	3, 32, 117, 11, 76, 255, 255, 178, 5, 221, 5, 168, 6, 59, 6, 123,
	6, 148, 6, 159, 6, 82, 6, 147, 8, 153, 8, 157, 8, 165, 8, 173,
	8, 183, 8, 205, 8, 185, 11, 250, 11, 59, 12, 128, 160, 32, 64, 255,
	241, 228, 215, 203, 192, 181, 170, 161, 152, 143, 135, 127, 120, 114, 107, 101,
	95, 90, 85, 80, 75, 71, 67, 63, 60, 56, 53, 50, 47, 44, 42, 39,
	37, 35, 33, 31, 29, 28, 26, 24, 23, 22, 20, 19, 18, 17, 16, 15,
	14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0, 0,
	0, 0, 0, 0, 242, 233, 218, 206, 191, 182, 170, 161, 152, 143, 137, 128,
	122, 113, 107, 101, 95, 0, 86, 80, 103, 96, 90, 85, 81, 76, 72, 67,
	63, 61, 57, 52, 51, 57, 45, 42, 40, 37, 36, 33, 31, 30, 0, 0,
	15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0,
	0, 56, 11, 140, 10, 0, 10, 106, 9, 232, 8, 106, 8, 239, 7, 128,
	7, 8, 7, 174, 6, 70, 6, 230, 5, 149, 5, 65, 5, 246, 4, 176,
	4, 110, 4, 48, 4, 246, 3, 187, 3, 132, 3, 82, 3, 34, 3, 244,
	2, 200, 2, 160, 2, 122, 2, 85, 2, 52, 2, 20, 2, 245, 1, 216,
	1, 189, 1, 164, 1, 141, 1, 119, 1, 96, 1, 78, 1, 56, 1, 39,
	1, 21, 1, 6, 1, 247, 0, 232, 0, 219, 0, 207, 0, 195, 0, 184,
	0, 172, 0, 162, 0, 154, 0, 144, 0, 136, 0, 127, 0, 120, 0, 112,
	0, 106, 0, 100, 0, 94, 0, 87, 0, 82, 0, 50, 0, 10, 0, 0,
	1, 2, 131, 0, 1, 2, 3, 1, 0, 2, 131, 1, 0, 2, 3, 1,
	2, 128, 3, 128, 64, 32, 16, 8, 4, 2, 1, 3, 3, 3, 3, 7,
	11, 15, 19 };
static const unsigned char CiBinaryResource_cmr_obx[2019] = { 255, 255, 0, 5, 220, 12, 76, 15, 11, 76, 120, 5, 76, 203, 7, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 160, 227, 237, 227, 160, 240, 236, 225,
	249, 229, 242, 160, 246, 160, 178, 174, 177, 160, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255,
	255, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 128, 128, 128, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 141, 110,
	5, 142, 111, 5, 140, 112, 5, 41, 112, 74, 74, 74, 170, 189, 145, 11,
	141, 169, 5, 189, 146, 11, 141, 170, 5, 169, 3, 141, 15, 210, 216, 165,
	254, 72, 165, 255, 72, 172, 112, 5, 174, 111, 5, 173, 110, 5, 32, 178,
	5, 104, 133, 255, 104, 133, 254, 96, 173, 118, 5, 133, 254, 173, 119, 5,
	133, 255, 160, 0, 138, 240, 28, 177, 254, 201, 143, 240, 4, 201, 239, 208,
	12, 202, 208, 9, 200, 192, 84, 176, 9, 152, 170, 16, 6, 200, 192, 84,
	144, 229, 96, 142, 104, 5, 32, 123, 6, 169, 0, 162, 9, 157, 69, 5,
	202, 16, 250, 141, 103, 5, 169, 1, 141, 113, 5, 169, 255, 141, 106, 5,
	173, 114, 5, 133, 254, 173, 115, 5, 133, 255, 160, 19, 177, 254, 170, 173,
	118, 5, 133, 254, 173, 119, 5, 133, 255, 172, 104, 5, 177, 254, 201, 207,
	208, 13, 152, 24, 105, 85, 168, 177, 254, 48, 15, 170, 76, 52, 6, 201,
	143, 240, 7, 201, 239, 240, 3, 136, 16, 226, 142, 108, 5, 142, 109, 5,
	96, 41, 15, 240, 245, 142, 218, 10, 142, 240, 10, 142, 255, 10, 140, 219,
	10, 140, 241, 10, 140, 0, 11, 96, 142, 114, 5, 134, 254, 140, 115, 5,
	132, 255, 24, 138, 105, 20, 141, 116, 5, 152, 105, 0, 141, 117, 5, 142,
	118, 5, 200, 200, 140, 119, 5, 160, 19, 177, 254, 141, 108, 5, 141, 109,
	5, 162, 8, 169, 0, 141, 113, 5, 157, 0, 210, 224, 3, 176, 8, 157,
	9, 5, 169, 255, 157, 57, 5, 202, 16, 233, 169, 128, 162, 3, 157, 75,
	5, 202, 16, 250, 96, 169, 1, 141, 113, 5, 169, 0, 240, 238, 41, 3,
	201, 3, 240, 240, 224, 64, 176, 236, 192, 26, 176, 232, 170, 169, 128, 157,
	75, 5, 169, 0, 157, 57, 5, 157, 60, 5, 157, 63, 5, 173, 111, 5,
	157, 12, 5, 173, 112, 5, 10, 10, 10, 133, 254, 24, 173, 114, 5, 105,
	48, 72, 173, 115, 5, 105, 1, 168, 104, 24, 101, 254, 157, 97, 5, 152,
	105, 0, 157, 100, 5, 24, 173, 114, 5, 105, 148, 133, 254, 173, 115, 5,
	105, 0, 133, 255, 173, 112, 5, 10, 109, 112, 5, 10, 168, 177, 254, 157,
	79, 5, 200, 177, 254, 157, 82, 5, 41, 7, 141, 110, 5, 200, 177, 254,
	157, 85, 5, 200, 177, 254, 157, 88, 5, 200, 177, 254, 157, 91, 5, 200,
	177, 254, 157, 94, 5, 160, 0, 173, 110, 5, 201, 3, 208, 2, 160, 2,
	201, 7, 208, 2, 160, 4, 185, 175, 11, 133, 254, 185, 176, 11, 133, 255,
	189, 85, 5, 74, 74, 74, 74, 24, 109, 111, 5, 141, 111, 5, 141, 194,
	7, 168, 173, 110, 5, 201, 7, 208, 15, 152, 10, 168, 177, 254, 157, 45,
	5, 200, 140, 111, 5, 76, 131, 7, 177, 254, 157, 45, 5, 189, 85, 5,
	41, 15, 24, 109, 111, 5, 141, 111, 5, 172, 111, 5, 173, 110, 5, 201,
	5, 8, 177, 254, 40, 240, 8, 221, 45, 5, 208, 3, 56, 233, 1, 157,
	48, 5, 189, 79, 5, 72, 41, 3, 168, 185, 181, 11, 157, 54, 5, 104,
	74, 74, 74, 74, 160, 62, 201, 15, 240, 16, 160, 55, 201, 14, 240, 10,
	160, 48, 201, 13, 240, 4, 24, 105, 0, 168, 185, 185, 11, 157, 51, 5,
	96, 216, 165, 252, 72, 165, 253, 72, 165, 254, 72, 165, 255, 72, 173, 113,
	5, 208, 3, 76, 2, 11, 173, 78, 5, 240, 3, 76, 107, 9, 173, 108,
	5, 205, 109, 5, 240, 3, 76, 88, 9, 173, 103, 5, 240, 3, 76, 220,
	8, 162, 2, 188, 75, 5, 48, 3, 157, 75, 5, 157, 69, 5, 202, 16,
	242, 173, 118, 5, 133, 252, 173, 119, 5, 133, 253, 172, 104, 5, 132, 254,
	204, 106, 5, 208, 25, 173, 107, 5, 240, 20, 173, 104, 5, 172, 105, 5,
	140, 104, 5, 206, 107, 5, 208, 232, 141, 104, 5, 168, 16, 226, 162, 0,
	177, 252, 201, 254, 208, 14, 172, 104, 5, 200, 196, 254, 240, 67, 140, 104,
	5, 76, 26, 8, 157, 66, 5, 24, 152, 105, 85, 168, 232, 224, 3, 144,
	223, 172, 104, 5, 177, 252, 16, 122, 201, 255, 240, 118, 74, 74, 74, 41,
	14, 170, 189, 161, 11, 141, 126, 8, 189, 162, 11, 141, 127, 8, 173, 67,
	5, 133, 255, 32, 147, 8, 140, 104, 5, 192, 85, 176, 4, 196, 254, 208,
	143, 164, 254, 140, 104, 5, 76, 2, 11, 32, 148, 6, 160, 255, 96, 48,
	251, 168, 96, 48, 247, 56, 152, 229, 255, 168, 96, 48, 239, 24, 152, 101,
	255, 168, 96, 48, 231, 141, 108, 5, 141, 109, 5, 200, 96, 48, 221, 173,
	68, 5, 48, 216, 141, 107, 5, 200, 140, 105, 5, 24, 152, 101, 255, 141,
	106, 5, 96, 136, 48, 10, 177, 252, 201, 143, 240, 4, 201, 239, 208, 243,
	200, 96, 162, 2, 189, 72, 5, 240, 5, 222, 72, 5, 16, 99, 189, 75,
	5, 208, 94, 188, 66, 5, 192, 64, 176, 87, 173, 116, 5, 133, 252, 173,
	117, 5, 133, 253, 177, 252, 133, 254, 24, 152, 105, 64, 168, 177, 252, 133,
	255, 37, 254, 201, 255, 240, 58, 188, 69, 5, 177, 254, 41, 192, 208, 12,
	177, 254, 41, 63, 157, 15, 5, 254, 69, 5, 16, 235, 201, 64, 208, 19,
	177, 254, 41, 63, 141, 111, 5, 189, 15, 5, 141, 112, 5, 32, 188, 6,
	76, 72, 9, 201, 128, 208, 10, 177, 254, 41, 63, 157, 72, 5, 254, 69,
	5, 202, 16, 144, 174, 103, 5, 232, 138, 41, 63, 141, 103, 5, 206, 109,
	5, 208, 14, 173, 108, 5, 141, 109, 5, 173, 103, 5, 208, 3, 238, 104,
	5, 172, 48, 5, 173, 82, 5, 41, 7, 201, 5, 240, 4, 201, 6, 208,
	1, 136, 140, 39, 5, 160, 0, 201, 5, 240, 4, 201, 6, 208, 2, 160,
	2, 201, 7, 208, 2, 160, 40, 140, 44, 5, 162, 2, 189, 82, 5, 41,
	224, 157, 40, 5, 189, 97, 5, 133, 252, 189, 100, 5, 133, 253, 189, 57,
	5, 201, 255, 240, 54, 201, 15, 208, 32, 189, 63, 5, 240, 45, 222, 63,
	5, 189, 63, 5, 208, 37, 188, 9, 5, 240, 1, 136, 152, 157, 9, 5,
	189, 88, 5, 157, 63, 5, 76, 229, 9, 189, 57, 5, 74, 168, 177, 252,
	144, 4, 74, 74, 74, 74, 41, 15, 157, 9, 5, 188, 45, 5, 189, 82,
	5, 41, 7, 201, 1, 208, 31, 136, 152, 200, 221, 48, 5, 8, 169, 1,
	40, 208, 2, 10, 10, 61, 60, 5, 240, 12, 188, 48, 5, 192, 255, 208,
	5, 169, 0, 157, 9, 5, 152, 157, 36, 5, 169, 1, 141, 110, 5, 189,
	57, 5, 201, 15, 240, 56, 41, 7, 168, 185, 205, 12, 133, 254, 189, 57,
	5, 41, 8, 8, 138, 40, 24, 240, 2, 105, 3, 168, 185, 91, 5, 37,
	254, 240, 27, 189, 51, 5, 157, 36, 5, 142, 110, 5, 202, 16, 8, 141,
	39, 5, 169, 0, 141, 44, 5, 232, 189, 54, 5, 157, 40, 5, 189, 57,
	5, 41, 15, 201, 15, 240, 16, 254, 57, 5, 189, 57, 5, 201, 15, 208,
	6, 189, 88, 5, 157, 63, 5, 189, 75, 5, 16, 10, 189, 9, 5, 208,
	5, 169, 64, 157, 75, 5, 254, 60, 5, 160, 0, 189, 82, 5, 74, 74,
	74, 74, 144, 1, 136, 74, 144, 1, 200, 24, 152, 125, 45, 5, 157, 45,
	5, 189, 48, 5, 201, 255, 208, 2, 160, 0, 24, 152, 125, 48, 5, 157,
	48, 5, 202, 48, 3, 76, 150, 9, 173, 40, 5, 141, 43, 5, 173, 82,
	5, 41, 7, 170, 160, 3, 173, 110, 5, 240, 3, 188, 213, 12, 152, 72,
	185, 185, 12, 8, 41, 127, 170, 152, 41, 3, 10, 168, 189, 36, 5, 153,
	0, 210, 200, 189, 9, 5, 224, 3, 208, 3, 173, 9, 5, 29, 40, 5,
	40, 16, 2, 169, 0, 153, 0, 210, 104, 168, 136, 41, 3, 208, 207, 160,
	8, 173, 44, 5, 153, 0, 210, 24, 104, 133, 255, 104, 133, 254, 104, 133,
	253, 104, 133, 252, 96, 104, 170, 240, 78, 201, 2, 240, 6, 104, 104, 202,
	208, 251, 96, 165, 20, 197, 20, 240, 252, 173, 36, 2, 201, 134, 208, 7,
	173, 37, 2, 201, 11, 240, 230, 173, 36, 2, 141, 143, 11, 173, 37, 2,
	141, 144, 11, 169, 134, 141, 36, 2, 169, 11, 141, 37, 2, 104, 104, 240,
	3, 56, 233, 1, 141, 93, 11, 104, 168, 104, 170, 169, 112, 32, 120, 5,
	169, 0, 162, 0, 76, 120, 5, 165, 20, 197, 20, 240, 252, 173, 36, 2,
	201, 134, 208, 174, 173, 37, 2, 201, 11, 208, 167, 173, 143, 11, 141, 36,
	2, 173, 144, 11, 141, 37, 2, 169, 64, 76, 120, 5, 32, 203, 7, 144,
	3, 32, 117, 11, 76, 255, 255, 178, 5, 221, 5, 168, 6, 59, 6, 123,
	6, 148, 6, 159, 6, 82, 6, 147, 8, 153, 8, 157, 8, 165, 8, 173,
	8, 183, 8, 205, 8, 185, 11, 250, 11, 59, 12, 128, 160, 32, 64, 255,
	241, 228, 215, 203, 192, 181, 170, 161, 152, 143, 135, 127, 120, 114, 107, 101,
	95, 90, 85, 80, 75, 71, 67, 63, 60, 56, 53, 50, 47, 44, 42, 39,
	37, 35, 33, 31, 29, 28, 26, 24, 23, 22, 20, 19, 18, 17, 16, 15,
	14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0, 0,
	0, 0, 0, 0, 242, 233, 218, 206, 191, 182, 170, 161, 152, 143, 137, 128,
	122, 113, 107, 101, 95, 92, 86, 80, 77, 71, 68, 65, 62, 56, 53, 136,
	127, 121, 115, 108, 103, 96, 90, 85, 81, 76, 72, 67, 63, 61, 57, 52,
	51, 48, 45, 42, 40, 37, 36, 33, 31, 30, 5, 4, 3, 2, 1, 0,
	0, 56, 11, 140, 10, 0, 10, 106, 9, 232, 8, 106, 8, 239, 7, 128,
	7, 8, 7, 174, 6, 70, 6, 230, 5, 149, 5, 65, 5, 246, 4, 176,
	4, 110, 4, 48, 4, 246, 3, 187, 3, 132, 3, 82, 3, 34, 3, 244,
	2, 200, 2, 160, 2, 122, 2, 85, 2, 52, 2, 20, 2, 245, 1, 216,
	1, 189, 1, 164, 1, 141, 1, 119, 1, 96, 1, 78, 1, 56, 1, 39,
	1, 21, 1, 6, 1, 247, 0, 232, 0, 219, 0, 207, 0, 195, 0, 184,
	0, 172, 0, 162, 0, 154, 0, 144, 0, 136, 0, 127, 0, 120, 0, 112,
	0, 106, 0, 100, 0, 94, 0, 87, 0, 82, 0, 50, 0, 10, 0, 0,
	1, 2, 131, 0, 1, 2, 3, 1, 0, 2, 131, 1, 0, 2, 3, 1,
	2, 128, 3, 128, 64, 32, 16, 8, 4, 2, 1, 3, 3, 3, 3, 7,
	11, 15, 19 };
static const unsigned char CiBinaryResource_cms_obx[2753] = { 255, 255, 0, 5, 186, 15, 234, 234, 234, 76, 21, 8, 76, 92, 15, 35,
	5, 169, 5, 173, 5, 184, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 128, 128, 128, 128, 128, 128, 0, 0, 0, 0, 0, 0, 255,
	255, 255, 255, 255, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 130, 0, 0, 6, 6, 0,
	128, 20, 128, 128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15,
	15, 0, 0, 0, 0, 0, 0, 0, 0, 255, 0, 0, 0, 0, 0, 0,
	1, 2, 131, 0, 1, 2, 3, 1, 0, 2, 131, 1, 0, 2, 3, 1,
	2, 128, 3, 128, 64, 32, 16, 8, 4, 2, 1, 75, 8, 118, 8, 133,
	9, 19, 9, 80, 9, 110, 9, 124, 9, 26, 9, 128, 160, 32, 64, 255,
	241, 228, 215, 203, 192, 181, 170, 161, 152, 143, 135, 127, 120, 114, 107, 101,
	95, 90, 85, 80, 75, 71, 67, 63, 60, 56, 53, 50, 47, 44, 42, 39,
	37, 35, 33, 31, 29, 28, 26, 24, 23, 22, 20, 19, 18, 17, 16, 15,
	14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0, 0,
	0, 0, 0, 0, 242, 233, 218, 206, 191, 182, 170, 161, 152, 143, 137, 128,
	122, 113, 107, 101, 95, 0, 86, 80, 103, 96, 90, 85, 81, 76, 72, 67,
	63, 61, 57, 52, 51, 57, 45, 42, 40, 37, 36, 33, 31, 30, 0, 0,
	15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0,
	0, 56, 11, 140, 10, 0, 10, 106, 9, 232, 8, 106, 8, 239, 7, 128,
	7, 8, 7, 174, 6, 70, 6, 230, 5, 149, 5, 65, 5, 246, 4, 176,
	4, 110, 4, 48, 4, 246, 3, 187, 3, 132, 3, 82, 3, 34, 3, 244,
	2, 200, 2, 160, 2, 122, 2, 85, 2, 52, 2, 20, 2, 245, 1, 216,
	1, 189, 1, 164, 1, 141, 1, 119, 1, 96, 1, 78, 1, 56, 1, 39,
	1, 21, 1, 6, 1, 247, 0, 232, 0, 219, 0, 207, 0, 195, 0, 184,
	0, 172, 0, 162, 0, 154, 0, 144, 0, 136, 0, 127, 0, 120, 0, 112,
	0, 106, 0, 100, 0, 94, 0, 87, 0, 82, 0, 50, 0, 10, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0,
	0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 0,
	0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 0,
	0, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 0,
	0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 0,
	0, 1, 1, 2, 2, 2, 3, 3, 4, 4, 4, 5, 5, 6, 6, 0,
	0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 0,
	1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 0,
	1, 1, 2, 2, 3, 4, 4, 5, 5, 6, 7, 7, 8, 8, 9, 0,
	1, 1, 2, 3, 3, 4, 5, 5, 6, 7, 7, 8, 9, 9, 10, 0,
	1, 1, 2, 3, 4, 4, 5, 6, 7, 7, 8, 9, 10, 10, 11, 0,
	1, 2, 2, 3, 4, 5, 6, 7, 8, 9, 9, 10, 11, 11, 12, 0,
	1, 2, 3, 4, 5, 5, 6, 7, 8, 9, 10, 10, 11, 12, 13, 0,
	1, 2, 3, 4, 5, 6, 7, 7, 8, 9, 10, 11, 12, 13, 14, 0,
	1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 6,
	12, 12, 12, 18, 12, 28, 12, 38, 12, 50, 12, 79, 12, 233, 5, 42,
	6, 107, 6, 161, 11, 196, 11, 185, 11, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 3, 3, 3, 3, 7, 11, 15, 19, 141, 143, 5, 142, 144,
	5, 140, 145, 5, 41, 112, 74, 74, 74, 170, 169, 3, 141, 15, 210, 189,
	213, 5, 141, 73, 8, 189, 214, 5, 141, 74, 8, 169, 3, 141, 31, 210,
	169, 1, 141, 146, 5, 172, 145, 5, 174, 144, 5, 173, 143, 5, 76, 72,
	8, 173, 147, 5, 133, 252, 173, 148, 5, 133, 253, 160, 0, 138, 240, 28,
	177, 252, 201, 143, 240, 4, 201, 239, 208, 12, 202, 208, 9, 200, 192, 84,
	176, 9, 152, 170, 16, 6, 200, 192, 84, 144, 229, 96, 142, 149, 5, 169,
	0, 162, 5, 157, 17, 5, 157, 23, 5, 157, 29, 5, 202, 16, 244, 141,
	150, 5, 141, 157, 5, 160, 255, 140, 159, 5, 173, 153, 5, 133, 252, 173,
	154, 5, 133, 253, 160, 19, 177, 252, 170, 173, 147, 5, 133, 252, 173, 148,
	5, 133, 253, 172, 149, 5, 152, 72, 169, 15, 141, 169, 5, 141, 170, 5,
	177, 252, 201, 135, 208, 35, 152, 72, 24, 105, 85, 168, 177, 252, 16, 2,
	169, 15, 41, 15, 141, 169, 5, 152, 24, 105, 85, 168, 177, 252, 16, 3,
	173, 169, 5, 41, 15, 141, 170, 5, 104, 76, 243, 8, 177, 252, 201, 143,
	240, 7, 201, 239, 240, 3, 136, 16, 199, 104, 168, 177, 252, 201, 207, 208,
	13, 152, 24, 105, 85, 168, 177, 252, 48, 15, 170, 76, 19, 9, 201, 143,
	240, 7, 201, 239, 240, 3, 136, 16, 226, 142, 151, 5, 142, 152, 5, 96,
	142, 153, 5, 134, 252, 140, 154, 5, 132, 253, 24, 138, 105, 20, 141, 155,
	5, 152, 105, 0, 141, 156, 5, 24, 138, 105, 0, 141, 147, 5, 152, 105,
	2, 141, 148, 5, 160, 19, 177, 252, 141, 151, 5, 141, 152, 5, 162, 3,
	142, 31, 210, 142, 15, 210, 169, 0, 141, 146, 5, 160, 8, 169, 0, 153,
	0, 210, 153, 16, 210, 192, 6, 176, 8, 153, 35, 5, 169, 255, 153, 41,
	5, 136, 16, 233, 169, 128, 162, 5, 157, 29, 5, 202, 16, 250, 141, 157,
	5, 96, 169, 0, 240, 240, 141, 157, 5, 240, 11, 173, 143, 5, 41, 7,
	170, 169, 128, 157, 29, 5, 172, 145, 5, 173, 144, 5, 141, 143, 5, 140,
	145, 5, 169, 0, 157, 83, 5, 157, 41, 5, 157, 77, 5, 152, 10, 10,
	10, 133, 254, 24, 173, 153, 5, 105, 48, 72, 173, 154, 5, 105, 1, 168,
	104, 24, 101, 254, 157, 101, 5, 152, 105, 0, 157, 71, 5, 24, 173, 153,
	5, 105, 148, 133, 252, 173, 154, 5, 105, 0, 133, 253, 173, 145, 5, 10,
	109, 145, 5, 10, 168, 140, 145, 5, 200, 200, 200, 200, 200, 177, 252, 157,
	113, 5, 136, 177, 252, 157, 107, 5, 136, 177, 252, 157, 119, 5, 136, 136,
	177, 252, 157, 59, 5, 160, 0, 41, 7, 201, 3, 208, 2, 160, 2, 201,
	7, 208, 2, 160, 4, 185, 247, 7, 133, 254, 185, 248, 7, 133, 255, 172,
	145, 5, 200, 200, 177, 252, 74, 74, 74, 74, 24, 109, 143, 5, 141, 143,
	5, 141, 159, 10, 168, 189, 59, 5, 41, 7, 201, 7, 208, 15, 152, 10,
	168, 177, 254, 157, 125, 5, 200, 140, 143, 5, 76, 92, 10, 177, 254, 157,
	125, 5, 172, 145, 5, 200, 200, 177, 252, 41, 15, 24, 109, 143, 5, 141,
	143, 5, 172, 143, 5, 189, 59, 5, 41, 7, 201, 5, 8, 177, 254, 40,
	240, 8, 221, 125, 5, 208, 3, 56, 233, 1, 157, 89, 5, 172, 145, 5,
	177, 252, 72, 41, 3, 168, 185, 229, 5, 157, 131, 5, 104, 74, 74, 74,
	74, 160, 62, 201, 15, 240, 16, 160, 55, 201, 14, 240, 10, 160, 48, 201,
	13, 240, 4, 24, 105, 50, 168, 185, 233, 5, 157, 137, 5, 96, 216, 165,
	252, 72, 165, 253, 72, 165, 254, 72, 165, 255, 72, 173, 146, 5, 208, 3,
	76, 47, 15, 173, 157, 5, 240, 3, 76, 225, 12, 173, 152, 5, 205, 151,
	5, 176, 3, 76, 206, 12, 173, 150, 5, 240, 3, 76, 158, 11, 162, 5,
	169, 0, 188, 29, 5, 48, 3, 157, 29, 5, 157, 17, 5, 202, 16, 242,
	173, 147, 5, 133, 252, 173, 148, 5, 133, 253, 172, 149, 5, 140, 161, 5,
	204, 159, 5, 208, 25, 173, 160, 5, 240, 20, 173, 149, 5, 172, 158, 5,
	140, 149, 5, 206, 160, 5, 208, 232, 141, 149, 5, 168, 16, 226, 162, 0,
	177, 252, 201, 254, 240, 28, 157, 53, 5, 230, 253, 177, 252, 198, 253, 201,
	254, 240, 15, 157, 56, 5, 24, 152, 105, 85, 168, 232, 224, 3, 144, 224,
	176, 34, 172, 149, 5, 200, 204, 161, 5, 240, 80, 140, 149, 5, 76, 250,
	10, 104, 41, 14, 170, 189, 253, 7, 141, 135, 11, 189, 254, 7, 141, 136,
	11, 76, 129, 11, 172, 149, 5, 177, 252, 16, 57, 201, 255, 240, 53, 74,
	74, 74, 72, 41, 1, 240, 218, 104, 41, 14, 170, 189, 233, 7, 141, 135,
	11, 189, 234, 7, 141, 136, 11, 173, 54, 5, 133, 254, 32, 134, 11, 140,
	149, 5, 192, 85, 176, 5, 204, 161, 5, 208, 179, 172, 161, 5, 140, 149,
	5, 76, 47, 15, 76, 94, 12, 165, 254, 48, 18, 41, 15, 141, 169, 5,
	173, 55, 5, 16, 3, 173, 169, 5, 41, 15, 141, 170, 5, 200, 96, 165,
	254, 48, 250, 41, 1, 141, 184, 5, 200, 96, 173, 179, 5, 48, 20, 206,
	180, 5, 208, 51, 169, 50, 141, 180, 5, 206, 179, 5, 208, 41, 206, 179,
	5, 200, 96, 165, 254, 48, 214, 141, 180, 5, 238, 180, 5, 165, 254, 48,
	204, 141, 180, 5, 238, 180, 5, 173, 55, 5, 141, 179, 5, 16, 5, 169,
	0, 141, 179, 5, 238, 179, 5, 104, 104, 76, 225, 12, 32, 110, 9, 160,
	255, 96, 165, 254, 48, 249, 168, 96, 165, 254, 48, 243, 56, 152, 229, 254,
	168, 96, 165, 254, 48, 233, 24, 152, 101, 254, 168, 96, 165, 254, 48, 223,
	141, 151, 5, 141, 152, 5, 200, 96, 165, 254, 48, 211, 173, 55, 5, 48,
	206, 200, 140, 158, 5, 24, 152, 101, 254, 141, 159, 5, 173, 55, 5, 141,
	160, 5, 192, 84, 96, 136, 48, 10, 177, 252, 201, 143, 240, 4, 201, 239,
	208, 243, 200, 96, 162, 5, 189, 23, 5, 240, 5, 222, 23, 5, 16, 87,
	189, 29, 5, 208, 82, 188, 53, 5, 201, 64, 176, 75, 173, 155, 5, 133,
	252, 173, 156, 5, 133, 253, 177, 252, 133, 254, 24, 152, 105, 64, 168, 177,
	252, 133, 255, 188, 17, 5, 177, 254, 41, 192, 208, 12, 177, 254, 41, 63,
	157, 47, 5, 254, 17, 5, 16, 235, 201, 64, 208, 13, 177, 254, 41, 63,
	188, 47, 5, 32, 150, 9, 76, 190, 12, 201, 128, 208, 10, 177, 254, 41,
	63, 157, 23, 5, 254, 17, 5, 202, 16, 156, 174, 150, 5, 232, 138, 41,
	63, 141, 150, 5, 206, 152, 5, 208, 14, 173, 151, 5, 141, 152, 5, 173,
	150, 5, 208, 3, 238, 149, 5, 172, 89, 5, 173, 59, 5, 41, 7, 201,
	5, 240, 4, 201, 6, 208, 1, 136, 140, 162, 5, 160, 0, 201, 5, 240,
	4, 201, 6, 208, 2, 160, 2, 201, 7, 208, 2, 160, 40, 140, 164, 5,
	172, 92, 5, 173, 62, 5, 41, 7, 201, 5, 240, 4, 201, 6, 208, 1,
	136, 140, 163, 5, 160, 0, 201, 5, 240, 4, 201, 6, 208, 2, 160, 2,
	201, 7, 208, 2, 160, 40, 140, 165, 5, 162, 5, 189, 59, 5, 41, 224,
	157, 65, 5, 189, 101, 5, 133, 252, 189, 71, 5, 133, 253, 189, 41, 5,
	201, 255, 240, 55, 201, 15, 208, 33, 189, 77, 5, 240, 46, 222, 77, 5,
	189, 77, 5, 208, 38, 188, 35, 5, 240, 1, 136, 152, 157, 35, 5, 189,
	119, 5, 157, 77, 5, 136, 76, 133, 13, 189, 41, 5, 74, 168, 177, 252,
	144, 4, 74, 74, 74, 74, 41, 15, 157, 35, 5, 188, 125, 5, 189, 59,
	5, 41, 7, 201, 1, 208, 31, 136, 152, 200, 221, 89, 5, 8, 169, 1,
	40, 208, 2, 10, 10, 61, 83, 5, 240, 12, 188, 89, 5, 192, 255, 208,
	5, 169, 0, 157, 35, 5, 152, 157, 95, 5, 169, 1, 141, 168, 5, 189,
	41, 5, 201, 15, 240, 76, 41, 7, 168, 185, 205, 5, 133, 254, 189, 41,
	5, 41, 8, 8, 138, 40, 24, 240, 2, 105, 6, 168, 185, 107, 5, 37,
	254, 240, 47, 189, 137, 5, 157, 95, 5, 142, 168, 5, 202, 224, 2, 240,
	15, 224, 255, 208, 22, 141, 162, 5, 169, 0, 141, 164, 5, 76, 5, 14,
	173, 140, 5, 141, 163, 5, 169, 0, 141, 165, 5, 232, 189, 131, 5, 157,
	65, 5, 189, 41, 5, 41, 15, 201, 15, 240, 18, 254, 41, 5, 189, 41,
	5, 41, 15, 201, 15, 208, 6, 189, 119, 5, 157, 77, 5, 189, 29, 5,
	16, 10, 189, 35, 5, 208, 5, 169, 64, 157, 29, 5, 254, 83, 5, 160,
	0, 189, 59, 5, 74, 74, 74, 74, 144, 1, 136, 74, 144, 1, 200, 24,
	152, 125, 125, 5, 157, 125, 5, 189, 89, 5, 201, 255, 208, 2, 160, 0,
	24, 152, 125, 89, 5, 157, 89, 5, 202, 48, 3, 76, 53, 13, 32, 123,
	15, 173, 65, 5, 141, 166, 5, 173, 68, 5, 141, 167, 5, 173, 59, 5,
	41, 7, 32, 181, 15, 152, 72, 185, 185, 5, 8, 41, 127, 170, 152, 41,
	3, 10, 168, 224, 3, 208, 3, 76, 196, 14, 189, 173, 5, 208, 39, 189,
	95, 5, 153, 0, 210, 189, 35, 5, 29, 65, 5, 40, 16, 2, 169, 0,
	153, 1, 210, 104, 168, 136, 41, 3, 240, 3, 76, 127, 14, 173, 164, 5,
	141, 8, 210, 76, 228, 14, 40, 76, 173, 14, 173, 173, 5, 208, 23, 173,
	162, 5, 153, 0, 210, 173, 35, 5, 13, 166, 5, 40, 16, 2, 169, 0,
	153, 1, 210, 76, 173, 14, 40, 76, 173, 14, 173, 62, 5, 41, 7, 32,
	181, 15, 152, 72, 185, 185, 5, 8, 41, 127, 170, 152, 41, 3, 10, 168,
	224, 3, 208, 3, 76, 60, 15, 189, 176, 5, 208, 30, 189, 98, 5, 153,
	16, 210, 189, 38, 5, 29, 68, 5, 40, 16, 2, 169, 0, 153, 17, 210,
	104, 168, 136, 41, 3, 240, 7, 76, 236, 14, 40, 76, 26, 15, 173, 165,
	5, 141, 24, 210, 24, 104, 133, 255, 104, 133, 254, 104, 133, 253, 104, 133,
	252, 96, 173, 176, 5, 208, 23, 173, 163, 5, 153, 16, 210, 173, 38, 5,
	13, 167, 5, 40, 16, 2, 169, 0, 153, 17, 210, 76, 26, 15, 40, 76,
	26, 15, 32, 168, 10, 176, 25, 173, 184, 5, 240, 20, 173, 157, 5, 141,
	183, 5, 169, 1, 141, 157, 5, 32, 168, 10, 173, 183, 5, 141, 157, 5,
	96, 173, 169, 5, 10, 10, 10, 10, 141, 171, 5, 173, 170, 5, 10, 10,
	10, 10, 141, 172, 5, 162, 2, 134, 200, 173, 171, 5, 29, 35, 5, 170,
	189, 233, 6, 166, 200, 157, 35, 5, 173, 172, 5, 29, 38, 5, 170, 189,
	233, 6, 166, 200, 157, 38, 5, 202, 16, 221, 96, 168, 185, 13, 8, 168,
	96 };
static const unsigned char CiBinaryResource_dlt_obx[2125] = { 255, 255, 0, 4, 70, 12, 255, 241, 228, 215, 203, 192, 181, 170, 161, 152,
	143, 135, 127, 121, 114, 107, 101, 95, 90, 85, 80, 75, 71, 67, 63, 60,
	56, 53, 50, 47, 44, 42, 39, 37, 35, 33, 31, 29, 28, 26, 24, 23,
	22, 20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6,
	5, 4, 255, 241, 228, 215, 242, 233, 218, 206, 191, 182, 170, 161, 152, 143,
	137, 128, 122, 113, 107, 101, 95, 92, 86, 80, 103, 96, 90, 85, 81, 76,
	72, 67, 63, 61, 57, 52, 51, 48, 45, 42, 40, 37, 36, 33, 31, 30,
	28, 27, 25, 0, 22, 21, 0, 10, 9, 8, 7, 6, 5, 4, 3, 2,
	1, 0, 242, 233, 218, 206, 242, 233, 218, 206, 191, 182, 170, 161, 152, 143,
	137, 128, 122, 113, 107, 101, 95, 92, 86, 80, 103, 96, 90, 85, 81, 76,
	72, 67, 63, 61, 57, 52, 51, 48, 45, 42, 40, 37, 36, 33, 31, 30,
	28, 27, 25, 0, 22, 21, 0, 10, 9, 8, 7, 6, 5, 4, 3, 2,
	1, 0, 242, 233, 218, 206, 255, 241, 228, 216, 202, 192, 181, 171, 162, 153,
	142, 135, 127, 120, 115, 108, 102, 97, 90, 85, 81, 75, 72, 67, 63, 60,
	57, 52, 51, 48, 45, 42, 40, 37, 36, 33, 31, 30, 28, 27, 25, 23,
	22, 21, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6,
	5, 4, 3, 2, 1, 255, 76, 9, 5, 76, 200, 5, 76, 183, 5, 136,
	140, 54, 3, 169, 126, 141, 53, 3, 162, 6, 142, 51, 3, 162, 1, 142,
	52, 3, 32, 51, 5, 32, 95, 5, 32, 163, 5, 32, 139, 5, 169, 1,
	141, 50, 3, 169, 3, 141, 15, 210, 96, 162, 0, 160, 32, 142, 48, 3,
	140, 49, 3, 160, 0, 173, 48, 3, 153, 0, 2, 173, 49, 3, 153, 64,
	2, 173, 48, 3, 24, 105, 128, 141, 48, 3, 144, 3, 238, 49, 3, 200,
	192, 64, 208, 225, 96, 162, 0, 160, 68, 142, 48, 3, 140, 49, 3, 160,
	0, 173, 48, 3, 153, 128, 2, 173, 49, 3, 153, 160, 2, 173, 48, 3,
	24, 105, 64, 141, 48, 3, 144, 3, 238, 49, 3, 200, 192, 32, 208, 225,
	96, 173, 0, 76, 41, 1, 74, 106, 106, 168, 162, 0, 185, 128, 4, 157,
	64, 4, 200, 232, 224, 64, 208, 244, 96, 160, 3, 169, 0, 153, 40, 3,
	153, 32, 3, 153, 36, 3, 153, 44, 3, 136, 16, 241, 96, 169, 0, 141,
	50, 3, 160, 7, 169, 0, 153, 0, 210, 136, 16, 250, 96, 96, 173, 50,
	3, 240, 250, 173, 40, 3, 13, 41, 3, 13, 42, 3, 13, 43, 3, 141,
	8, 210, 174, 36, 3, 172, 32, 3, 142, 0, 210, 140, 1, 210, 174, 37,
	3, 172, 33, 3, 142, 2, 210, 140, 3, 210, 174, 38, 3, 172, 34, 3,
	142, 4, 210, 140, 5, 210, 174, 39, 3, 172, 35, 3, 142, 6, 210, 140,
	7, 210, 206, 52, 3, 208, 74, 173, 51, 3, 141, 52, 3, 238, 53, 3,
	238, 53, 3, 16, 28, 238, 54, 3, 169, 0, 141, 53, 3, 32, 199, 6,
	173, 4, 3, 13, 5, 3, 13, 6, 3, 13, 7, 3, 208, 3, 76, 183,
	5, 173, 4, 3, 240, 3, 32, 97, 7, 173, 5, 3, 240, 3, 32, 192,
	7, 173, 6, 3, 240, 3, 32, 31, 8, 173, 7, 3, 240, 3, 32, 126,
	8, 173, 4, 3, 240, 8, 173, 44, 3, 240, 3, 32, 221, 8, 173, 5,
	3, 240, 8, 173, 45, 3, 240, 3, 32, 206, 9, 173, 6, 3, 240, 8,
	173, 46, 3, 240, 3, 32, 191, 10, 173, 7, 3, 240, 8, 173, 47, 3,
	240, 3, 32, 131, 11, 96, 192, 67, 144, 14, 169, 0, 141, 4, 3, 141,
	32, 3, 141, 40, 3, 76, 230, 6, 192, 66, 208, 15, 189, 128, 64, 141,
	51, 3, 141, 52, 3, 238, 54, 3, 76, 199, 6, 192, 65, 208, 9, 189,
	128, 64, 141, 54, 3, 76, 199, 6, 104, 104, 76, 183, 5, 174, 54, 3,
	188, 0, 64, 192, 64, 176, 191, 189, 128, 64, 141, 24, 3, 185, 0, 2,
	133, 224, 185, 64, 2, 133, 225, 169, 1, 141, 4, 3, 188, 0, 65, 192,
	64, 176, 78, 189, 128, 65, 141, 25, 3, 185, 0, 2, 133, 226, 185, 64,
	2, 133, 227, 169, 1, 141, 5, 3, 188, 0, 66, 192, 64, 176, 63, 189,
	128, 66, 141, 26, 3, 185, 0, 2, 133, 228, 185, 64, 2, 133, 229, 169,
	1, 141, 6, 3, 188, 0, 67, 192, 64, 176, 48, 189, 128, 67, 141, 27,
	3, 185, 0, 2, 133, 230, 185, 64, 2, 133, 231, 169, 1, 141, 7, 3,
	96, 169, 0, 141, 5, 3, 141, 33, 3, 141, 41, 3, 240, 186, 169, 0,
	141, 6, 3, 141, 34, 3, 141, 42, 3, 240, 201, 169, 0, 141, 7, 3,
	141, 35, 3, 141, 43, 3, 96, 172, 53, 3, 177, 224, 48, 11, 200, 177,
	224, 48, 1, 96, 104, 104, 76, 31, 6, 24, 109, 24, 3, 41, 127, 141,
	8, 3, 169, 15, 141, 0, 3, 141, 44, 3, 200, 177, 224, 170, 189, 160,
	2, 133, 233, 133, 241, 133, 249, 189, 128, 2, 133, 232, 73, 16, 133, 240,
	73, 48, 133, 248, 160, 49, 177, 232, 141, 12, 3, 160, 51, 177, 232, 41,
	127, 141, 16, 3, 169, 0, 141, 20, 3, 141, 28, 3, 160, 48, 177, 232,
	41, 213, 141, 40, 3, 96, 172, 53, 3, 177, 226, 48, 11, 200, 177, 226,
	48, 1, 96, 104, 104, 76, 31, 6, 24, 109, 25, 3, 41, 127, 141, 9,
	3, 169, 15, 141, 1, 3, 141, 45, 3, 200, 177, 226, 170, 189, 160, 2,
	133, 235, 133, 243, 133, 251, 189, 128, 2, 133, 234, 73, 16, 133, 242, 73,
	48, 133, 250, 160, 49, 177, 234, 141, 13, 3, 160, 51, 177, 234, 41, 127,
	141, 17, 3, 169, 0, 141, 21, 3, 141, 29, 3, 160, 48, 177, 234, 41,
	131, 141, 41, 3, 96, 172, 53, 3, 177, 228, 48, 11, 200, 177, 228, 48,
	1, 96, 104, 104, 76, 31, 6, 24, 109, 26, 3, 41, 127, 141, 10, 3,
	169, 15, 141, 2, 3, 141, 46, 3, 200, 177, 228, 170, 189, 160, 2, 133,
	237, 133, 245, 133, 253, 189, 128, 2, 133, 236, 73, 16, 133, 244, 73, 48,
	133, 252, 160, 49, 177, 236, 141, 14, 3, 160, 51, 177, 236, 41, 127, 141,
	18, 3, 169, 0, 141, 22, 3, 141, 30, 3, 160, 48, 177, 236, 41, 169,
	141, 42, 3, 96, 172, 53, 3, 177, 230, 48, 11, 200, 177, 230, 48, 1,
	96, 104, 104, 76, 31, 6, 24, 109, 27, 3, 41, 127, 141, 11, 3, 169,
	15, 141, 3, 3, 141, 47, 3, 200, 177, 230, 170, 189, 160, 2, 133, 239,
	133, 247, 133, 255, 189, 128, 2, 133, 238, 73, 16, 133, 246, 73, 48, 133,
	254, 160, 49, 177, 238, 141, 15, 3, 160, 51, 177, 238, 41, 127, 141, 19,
	3, 169, 0, 141, 23, 3, 141, 31, 3, 160, 48, 177, 238, 41, 129, 141,
	43, 3, 96, 172, 0, 3, 48, 70, 177, 232, 141, 32, 3, 177, 240, 208,
	9, 32, 108, 9, 206, 0, 3, 76, 79, 9, 201, 1, 240, 39, 201, 3,
	208, 16, 173, 8, 3, 24, 113, 248, 170, 173, 28, 3, 141, 55, 3, 76,
	24, 9, 173, 28, 3, 24, 113, 248, 141, 55, 3, 174, 8, 3, 32, 150,
	9, 206, 0, 3, 96, 177, 248, 141, 36, 3, 206, 0, 3, 96, 32, 108,
	9, 160, 49, 177, 232, 240, 30, 206, 12, 3, 240, 3, 76, 79, 9, 173,
	32, 3, 41, 15, 240, 11, 206, 32, 3, 177, 232, 141, 12, 3, 76, 79,
	9, 141, 44, 3, 96, 173, 28, 3, 24, 160, 50, 113, 232, 141, 28, 3,
	206, 16, 3, 208, 12, 238, 20, 3, 160, 51, 177, 232, 41, 127, 141, 16,
	3, 96, 173, 20, 3, 41, 3, 24, 105, 52, 168, 177, 232, 170, 160, 51,
	177, 232, 48, 14, 138, 109, 8, 3, 170, 173, 28, 3, 141, 55, 3, 76,
	150, 9, 138, 109, 28, 3, 141, 55, 3, 174, 8, 3, 189, 0, 4, 24,
	109, 55, 3, 141, 36, 3, 173, 40, 3, 41, 4, 208, 1, 96, 172, 0,
	3, 177, 240, 208, 21, 138, 24, 160, 0, 113, 248, 170, 189, 0, 4, 24,
	109, 55, 3, 24, 105, 255, 141, 38, 3, 96, 173, 36, 3, 24, 105, 255,
	141, 38, 3, 96, 172, 1, 3, 48, 70, 177, 234, 141, 33, 3, 177, 242,
	208, 9, 32, 93, 10, 206, 1, 3, 76, 64, 10, 201, 1, 240, 39, 201,
	3, 208, 16, 173, 9, 3, 24, 113, 250, 170, 173, 29, 3, 141, 55, 3,
	76, 9, 10, 173, 29, 3, 24, 113, 250, 141, 55, 3, 174, 9, 3, 32,
	135, 10, 206, 1, 3, 96, 177, 250, 141, 37, 3, 206, 1, 3, 96, 32,
	93, 10, 160, 49, 177, 234, 240, 30, 206, 13, 3, 240, 3, 76, 64, 10,
	173, 33, 3, 41, 15, 240, 11, 206, 33, 3, 177, 234, 141, 13, 3, 76,
	64, 10, 141, 45, 3, 96, 173, 29, 3, 24, 160, 50, 113, 234, 141, 29,
	3, 206, 17, 3, 208, 12, 238, 21, 3, 160, 51, 177, 234, 41, 127, 141,
	17, 3, 96, 173, 21, 3, 41, 3, 24, 105, 52, 168, 177, 234, 170, 160,
	51, 177, 234, 48, 14, 138, 109, 9, 3, 170, 173, 29, 3, 141, 55, 3,
	76, 135, 10, 138, 109, 29, 3, 141, 55, 3, 174, 9, 3, 189, 0, 4,
	24, 109, 55, 3, 141, 37, 3, 173, 41, 3, 41, 2, 208, 1, 96, 172,
	1, 3, 177, 242, 208, 21, 138, 24, 160, 0, 113, 250, 170, 189, 0, 4,
	24, 109, 55, 3, 24, 105, 255, 141, 39, 3, 96, 173, 37, 3, 24, 105,
	255, 141, 39, 3, 96, 172, 2, 3, 48, 70, 177, 236, 141, 34, 3, 177,
	244, 208, 9, 32, 78, 11, 206, 2, 3, 76, 49, 11, 201, 1, 240, 39,
	201, 3, 208, 16, 173, 10, 3, 24, 113, 252, 170, 173, 30, 3, 141, 55,
	3, 76, 250, 10, 173, 30, 3, 24, 113, 252, 141, 55, 3, 174, 10, 3,
	32, 120, 11, 206, 2, 3, 96, 177, 252, 141, 38, 3, 206, 2, 3, 96,
	32, 78, 11, 160, 49, 177, 236, 240, 30, 206, 14, 3, 240, 3, 76, 49,
	11, 173, 34, 3, 41, 15, 240, 11, 206, 34, 3, 177, 236, 141, 14, 3,
	76, 49, 11, 141, 46, 3, 96, 173, 30, 3, 24, 160, 50, 113, 236, 141,
	30, 3, 206, 18, 3, 208, 12, 238, 22, 3, 160, 51, 177, 236, 41, 127,
	141, 18, 3, 96, 173, 22, 3, 41, 3, 24, 105, 52, 168, 177, 236, 170,
	160, 51, 177, 236, 48, 14, 138, 109, 10, 3, 170, 173, 30, 3, 141, 55,
	3, 76, 120, 11, 138, 109, 30, 3, 141, 55, 3, 174, 10, 3, 189, 0,
	4, 24, 109, 55, 3, 141, 38, 3, 96, 172, 3, 3, 48, 70, 177, 238,
	141, 35, 3, 177, 246, 208, 9, 32, 18, 12, 206, 3, 3, 76, 245, 11,
	201, 1, 240, 39, 201, 3, 208, 16, 173, 11, 3, 24, 113, 254, 170, 173,
	31, 3, 141, 55, 3, 76, 190, 11, 173, 31, 3, 24, 113, 254, 141, 55,
	3, 174, 11, 3, 32, 60, 12, 206, 3, 3, 96, 177, 254, 141, 39, 3,
	206, 3, 3, 96, 32, 18, 12, 160, 49, 177, 238, 240, 30, 206, 15, 3,
	240, 3, 76, 245, 11, 173, 35, 3, 41, 15, 240, 11, 206, 35, 3, 177,
	238, 141, 15, 3, 76, 245, 11, 141, 47, 3, 96, 173, 31, 3, 24, 160,
	50, 113, 238, 141, 31, 3, 206, 19, 3, 208, 12, 238, 23, 3, 160, 51,
	177, 238, 41, 127, 141, 19, 3, 96, 173, 23, 3, 41, 3, 24, 105, 52,
	168, 177, 238, 170, 160, 51, 177, 238, 48, 14, 138, 109, 11, 3, 170, 173,
	31, 3, 141, 55, 3, 76, 60, 12, 138, 109, 31, 3, 141, 55, 3, 174,
	11, 3, 189, 0, 4, 24, 109, 55, 3, 141, 39, 3, 96 };
static const unsigned char CiBinaryResource_fc_obx[1220] = { 255, 255, 0, 4, 189, 8, 76, 9, 4, 32, 16, 4, 76, 173, 5, 162,
	0, 160, 10, 32, 25, 5, 162, 8, 189, 172, 8, 157, 0, 210, 157, 16,
	210, 202, 16, 244, 96, 133, 244, 162, 0, 134, 230, 134, 232, 134, 234, 169,
	0, 133, 231, 133, 233, 133, 235, 133, 236, 133, 238, 133, 240, 133, 237, 133,
	239, 133, 241, 138, 160, 2, 162, 4, 32, 9, 5, 136, 202, 202, 16, 248,
	162, 4, 32, 160, 4, 202, 202, 16, 249, 169, 255, 197, 230, 240, 34, 197,
	232, 240, 30, 197, 234, 240, 26, 169, 254, 160, 0, 209, 224, 240, 18, 209,
	226, 240, 14, 209, 228, 240, 10, 177, 224, 49, 226, 49, 228, 201, 255, 208,
	207, 162, 4, 32, 153, 4, 202, 202, 16, 249, 166, 230, 228, 232, 176, 2,
	166, 232, 228, 234, 176, 2, 166, 234, 232, 198, 244, 208, 140, 138, 96, 181,
	231, 240, 2, 246, 230, 96, 161, 224, 201, 254, 176, 29, 181, 230, 201, 255,
	240, 23, 181, 237, 208, 17, 161, 224, 201, 64, 144, 28, 208, 3, 32, 196,
	4, 32, 196, 4, 76, 160, 4, 214, 237, 96, 246, 224, 208, 2, 246, 225,
	180, 230, 200, 240, 2, 246, 230, 96, 168, 185, 191, 8, 133, 242, 185, 31,
	9, 133, 243, 180, 231, 246, 231, 177, 242, 201, 64, 144, 22, 201, 96, 144,
	23, 201, 255, 144, 238, 169, 0, 149, 237, 149, 236, 149, 231, 32, 196, 4,
	76, 160, 4, 181, 236, 149, 237, 96, 41, 31, 149, 236, 76, 221, 4, 72,
	24, 121, 159, 9, 149, 224, 169, 0, 121, 162, 9, 149, 225, 104, 96, 134,
	252, 132, 253, 72, 160, 2, 177, 252, 162, 0, 157, 127, 9, 24, 113, 252,
	232, 224, 32, 144, 245, 165, 252, 166, 253, 24, 105, 3, 144, 1, 232, 141,
	159, 9, 142, 162, 9, 232, 141, 160, 9, 142, 163, 9, 232, 141, 161, 9,
	142, 164, 9, 232, 133, 254, 134, 255, 24, 105, 128, 144, 1, 232, 133, 252,
	134, 253, 162, 0, 160, 0, 165, 252, 153, 191, 8, 165, 253, 153, 31, 9,
	161, 252, 230, 252, 208, 2, 230, 253, 201, 255, 208, 244, 200, 192, 64, 144,
	229, 162, 0, 165, 252, 157, 255, 8, 165, 253, 157, 95, 9, 160, 0, 177,
	252, 200, 201, 255, 208, 249, 152, 24, 101, 252, 133, 252, 144, 2, 230, 253,
	232, 224, 32, 144, 222, 104, 240, 3, 32, 31, 4, 141, 190, 8, 169, 64,
	141, 170, 8, 44, 170, 8, 48, 39, 80, 53, 169, 0, 162, 11, 157, 125,
	8, 202, 16, 250, 141, 170, 8, 162, 2, 169, 8, 157, 167, 8, 173, 190,
	8, 157, 122, 8, 202, 16, 242, 169, 80, 141, 180, 8, 76, 233, 5, 169,
	0, 162, 7, 157, 172, 8, 202, 16, 250, 169, 128, 141, 170, 8, 96, 238,
	171, 8, 162, 2, 134, 30, 232, 138, 10, 168, 132, 31, 202, 189, 159, 9,
	133, 28, 189, 162, 9, 133, 29, 189, 128, 8, 240, 3, 76, 240, 6, 188,
	122, 8, 177, 28, 201, 64, 240, 14, 201, 255, 240, 24, 201, 254, 208, 45,
	141, 170, 8, 76, 203, 7, 200, 177, 28, 141, 180, 8, 200, 152, 157, 122,
	8, 76, 9, 6, 173, 190, 8, 157, 122, 8, 169, 80, 141, 180, 8, 169,
	0, 157, 128, 8, 157, 131, 8, 157, 125, 8, 76, 9, 6, 72, 41, 128,
	240, 11, 254, 122, 8, 104, 41, 15, 157, 167, 8, 16, 178, 104, 168, 185,
	191, 8, 133, 28, 185, 31, 9, 133, 29, 189, 131, 8, 157, 128, 8, 169,
	0, 157, 158, 8, 188, 125, 8, 177, 28, 48, 7, 10, 48, 36, 74, 76,
	177, 6, 10, 10, 168, 177, 254, 157, 137, 8, 200, 177, 254, 157, 143, 8,
	200, 177, 254, 157, 146, 8, 200, 177, 254, 157, 149, 8, 254, 125, 8, 76,
	110, 6, 74, 41, 31, 170, 189, 127, 9, 166, 30, 157, 128, 8, 157, 131,
	8, 254, 125, 8, 76, 110, 6, 157, 155, 8, 24, 125, 167, 8, 168, 224,
	0, 208, 15, 185, 242, 7, 141, 172, 8, 185, 50, 8, 141, 174, 8, 76,
	215, 6, 185, 196, 7, 157, 134, 8, 164, 31, 153, 172, 8, 169, 0, 157,
	140, 8, 254, 125, 8, 188, 125, 8, 177, 28, 201, 255, 208, 8, 169, 0,
	157, 125, 8, 254, 122, 8, 189, 137, 8, 168, 185, 255, 8, 141, 6, 7,
	185, 95, 9, 141, 7, 7, 166, 30, 188, 140, 8, 185, 255, 255, 201, 255,
	240, 39, 16, 16, 164, 31, 153, 173, 8, 169, 0, 153, 172, 8, 254, 140,
	8, 76, 148, 7, 164, 31, 254, 140, 8, 29, 143, 8, 153, 173, 8, 224,
	0, 240, 6, 189, 134, 8, 153, 172, 8, 189, 146, 8, 240, 35, 173, 171,
	8, 41, 1, 208, 5, 189, 146, 8, 208, 2, 169, 0, 141, 78, 7, 24,
	189, 155, 8, 105, 2, 125, 167, 8, 168, 185, 196, 7, 164, 31, 153, 172,
	8, 189, 149, 8, 240, 52, 48, 32, 188, 152, 8, 254, 152, 8, 185, 181,
	8, 201, 31, 208, 7, 169, 0, 157, 152, 8, 240, 236, 24, 125, 134, 8,
	164, 31, 153, 172, 8, 76, 148, 7, 189, 134, 8, 201, 255, 240, 11, 254,
	134, 8, 254, 134, 8, 164, 31, 153, 172, 8, 189, 158, 8, 240, 41, 189,
	161, 8, 240, 6, 222, 161, 8, 76, 194, 7, 189, 158, 8, 16, 10, 24,
	189, 134, 8, 125, 164, 8, 76, 186, 7, 56, 189, 134, 8, 253, 164, 8,
	157, 134, 8, 164, 31, 153, 172, 8, 222, 128, 8, 202, 48, 3, 76, 238,
	5, 96, 255, 241, 228, 215, 203, 192, 181, 170, 161, 152, 143, 135, 127, 120,
	114, 107, 101, 95, 90, 85, 80, 75, 71, 67, 63, 60, 56, 53, 50, 47,
	44, 42, 39, 37, 35, 33, 31, 29, 28, 26, 23, 22, 19, 15, 7, 0,
	56, 140, 0, 106, 232, 106, 239, 128, 8, 174, 70, 230, 149, 65, 246, 176,
	110, 48, 246, 187, 132, 82, 34, 244, 200, 160, 122, 85, 52, 20, 245, 216,
	189, 164, 141, 119, 96, 78, 56, 39, 21, 6, 247, 232, 219, 207, 195, 184,
	172, 162, 154, 144, 136, 127, 120, 112, 106, 100, 94, 87, 82, 50, 10, 0,
	11, 10, 10, 9, 8, 8, 7, 7, 7, 6, 6, 5, 5, 5, 4, 4,
	4, 4, 3, 3, 3, 3, 3, 2, 2, 2, 2, 2, 2, 2, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 0, 0, 1, 1, 0,
	0, 255, 255, 31 };
static const unsigned char CiBinaryResource_mpt_obx[2233] = { 255, 255, 0, 5, 178, 13, 76, 205, 11, 173, 46, 7, 208, 1, 96, 169,
	0, 141, 28, 14, 238, 29, 14, 173, 23, 14, 205, 187, 13, 144, 80, 206,
	21, 14, 240, 3, 76, 197, 5, 162, 0, 142, 23, 14, 169, 0, 157, 237,
	13, 157, 245, 13, 189, 179, 13, 133, 236, 189, 183, 13, 133, 237, 172, 22,
	14, 177, 236, 200, 201, 255, 240, 7, 201, 254, 208, 15, 76, 42, 12, 177,
	236, 48, 249, 10, 168, 140, 22, 14, 76, 59, 5, 157, 233, 13, 177, 236,
	157, 213, 13, 232, 224, 4, 208, 196, 200, 140, 22, 14, 76, 197, 5, 206,
	21, 14, 16, 87, 173, 188, 13, 141, 21, 14, 162, 3, 222, 245, 13, 16,
	68, 189, 233, 13, 10, 168, 185, 255, 255, 133, 236, 200, 185, 255, 255, 133,
	237, 5, 236, 240, 48, 189, 237, 13, 141, 31, 14, 32, 62, 7, 172, 31,
	14, 200, 152, 157, 237, 13, 189, 241, 13, 157, 245, 13, 224, 2, 208, 21,
	189, 197, 13, 73, 15, 10, 10, 10, 10, 105, 69, 141, 161, 13, 169, 10,
	105, 0, 141, 162, 13, 202, 16, 180, 238, 23, 14, 162, 1, 173, 27, 14,
	201, 2, 240, 2, 162, 3, 173, 27, 14, 201, 2, 208, 5, 236, 25, 14,
	240, 3, 76, 118, 6, 181, 240, 61, 114, 6, 240, 18, 160, 40, 177, 236,
	24, 125, 225, 13, 32, 117, 9, 56, 125, 1, 14, 157, 203, 13, 202, 16,
	213, 169, 3, 141, 15, 210, 165, 241, 41, 16, 240, 15, 172, 226, 13, 185,
	198, 9, 141, 201, 13, 185, 5, 10, 141, 202, 13, 173, 201, 13, 141, 0,
	210, 173, 202, 13, 141, 2, 210, 173, 203, 13, 141, 4, 210, 173, 204, 13,
	141, 6, 210, 173, 193, 13, 162, 255, 172, 27, 14, 192, 1, 208, 5, 174,
	25, 14, 240, 3, 141, 1, 210, 173, 194, 13, 224, 1, 240, 3, 141, 3,
	210, 192, 2, 240, 20, 173, 195, 13, 224, 2, 240, 3, 141, 5, 210, 173,
	196, 13, 224, 3, 240, 3, 141, 7, 210, 165, 240, 5, 241, 5, 242, 5,
	243, 13, 28, 14, 141, 8, 210, 96, 4, 2, 0, 0, 189, 217, 13, 133,
	236, 189, 221, 13, 133, 237, 5, 236, 208, 8, 157, 193, 13, 149, 240, 76,
	248, 5, 180, 244, 192, 32, 240, 66, 177, 236, 56, 253, 197, 13, 44, 58,
	7, 240, 2, 41, 240, 157, 193, 13, 200, 177, 236, 141, 30, 14, 200, 148,
	244, 41, 7, 240, 60, 168, 185, 126, 9, 141, 203, 6, 185, 133, 9, 141,
	204, 6, 173, 30, 14, 74, 74, 74, 74, 74, 9, 40, 168, 177, 236, 24,
	32, 255, 255, 169, 0, 149, 240, 76, 248, 5, 189, 9, 14, 240, 18, 222,
	13, 14, 208, 13, 157, 13, 14, 189, 193, 13, 41, 15, 240, 3, 222, 193,
	13, 160, 35, 177, 236, 149, 240, 189, 17, 14, 24, 105, 37, 168, 41, 3,
	157, 17, 14, 136, 177, 236, 125, 209, 13, 157, 225, 13, 32, 119, 9, 157,
	201, 13, 189, 5, 14, 240, 6, 222, 5, 14, 76, 223, 5, 189, 189, 13,
	141, 30, 7, 16, 254, 76, 194, 8, 0, 76, 229, 8, 0, 76, 251, 8,
	0, 76, 21, 9, 0, 76, 37, 9, 0, 76, 56, 9, 0, 76, 66, 9,
	16, 76, 72, 9, 169, 0, 157, 197, 13, 172, 31, 14, 136, 200, 177, 236,
	201, 254, 208, 4, 140, 31, 14, 96, 201, 224, 144, 8, 173, 187, 13, 141,
	23, 14, 208, 233, 201, 208, 144, 10, 41, 15, 141, 188, 13, 141, 21, 14,
	16, 219, 201, 192, 144, 9, 41, 15, 73, 15, 157, 197, 13, 16, 206, 201,
	128, 144, 7, 41, 63, 157, 241, 13, 16, 195, 201, 64, 144, 27, 200, 140,
	31, 14, 41, 31, 157, 229, 13, 10, 168, 185, 255, 255, 157, 217, 13, 200,
	185, 255, 255, 157, 221, 13, 76, 62, 7, 140, 31, 14, 141, 30, 14, 24,
	125, 213, 13, 157, 209, 13, 173, 27, 14, 240, 66, 201, 2, 240, 58, 189,
	229, 13, 201, 31, 208, 55, 173, 30, 14, 56, 233, 1, 41, 15, 168, 177,
	254, 133, 253, 152, 9, 16, 168, 177, 254, 133, 248, 160, 1, 5, 253, 208,
	2, 160, 0, 140, 26, 14, 169, 0, 133, 252, 157, 217, 13, 157, 221, 13,
	138, 10, 141, 24, 14, 142, 25, 14, 96, 224, 2, 176, 99, 189, 217, 13,
	133, 238, 189, 221, 13, 133, 239, 5, 238, 240, 74, 160, 32, 177, 238, 41,
	15, 157, 249, 13, 177, 238, 41, 112, 74, 74, 157, 189, 13, 200, 177, 238,
	10, 10, 72, 41, 63, 157, 5, 14, 104, 41, 192, 157, 205, 13, 200, 177,
	238, 157, 9, 14, 157, 13, 14, 169, 0, 149, 244, 157, 17, 14, 157, 253,
	13, 157, 1, 14, 189, 209, 13, 157, 225, 13, 32, 117, 9, 157, 201, 13,
	236, 25, 14, 240, 1, 96, 160, 255, 140, 25, 14, 200, 140, 26, 14, 96,
	224, 2, 208, 51, 172, 211, 13, 185, 69, 11, 141, 121, 13, 185, 129, 11,
	141, 127, 13, 169, 0, 133, 249, 133, 250, 173, 231, 13, 41, 15, 168, 177,
	254, 133, 251, 152, 9, 16, 168, 177, 254, 141, 137, 13, 5, 251, 208, 6,
	141, 121, 13, 141, 127, 13, 96, 173, 232, 13, 41, 15, 168, 177, 254, 133,
	253, 152, 9, 16, 168, 177, 254, 5, 253, 240, 15, 177, 254, 56, 229, 253,
	133, 248, 169, 0, 133, 252, 169, 141, 208, 2, 169, 173, 141, 97, 13, 141,
	56, 13, 169, 24, 141, 7, 210, 96, 173, 29, 14, 41, 7, 74, 74, 144,
	18, 208, 24, 189, 249, 13, 24, 157, 1, 14, 125, 201, 13, 157, 201, 13,
	76, 223, 5, 169, 0, 157, 1, 14, 76, 223, 5, 189, 201, 13, 56, 253,
	249, 13, 157, 201, 13, 56, 169, 0, 253, 249, 13, 157, 1, 14, 76, 223,
	5, 189, 253, 13, 24, 157, 1, 14, 125, 201, 13, 157, 201, 13, 24, 189,
	253, 13, 125, 249, 13, 157, 253, 13, 76, 223, 5, 189, 225, 13, 56, 253,
	253, 13, 157, 225, 13, 32, 117, 9, 76, 5, 9, 169, 0, 56, 253, 253,
	13, 157, 1, 14, 189, 201, 13, 56, 253, 253, 13, 76, 5, 9, 189, 225,
	13, 24, 125, 253, 13, 76, 28, 9, 32, 85, 9, 76, 208, 8, 32, 85,
	9, 24, 125, 225, 13, 32, 155, 9, 76, 223, 5, 188, 253, 13, 189, 249,
	13, 48, 2, 200, 200, 136, 152, 157, 253, 13, 221, 249, 13, 208, 8, 189,
	249, 13, 73, 255, 157, 249, 13, 189, 253, 13, 96, 41, 63, 29, 205, 13,
	168, 185, 255, 255, 96, 148, 145, 152, 165, 173, 180, 192, 9, 9, 9, 9,
	9, 9, 9, 64, 0, 32, 0, 125, 201, 13, 157, 201, 13, 96, 125, 209,
	13, 157, 225, 13, 32, 117, 9, 157, 201, 13, 96, 157, 201, 13, 189, 141,
	9, 16, 12, 157, 201, 13, 169, 128, 208, 5, 157, 201, 13, 169, 1, 13,
	28, 14, 141, 28, 14, 96, 45, 10, 210, 157, 201, 13, 96, 242, 51, 150,
	226, 56, 140, 0, 106, 232, 106, 239, 128, 8, 174, 70, 230, 149, 65, 246,
	176, 110, 48, 246, 187, 132, 82, 34, 244, 200, 160, 122, 85, 52, 20, 245,
	216, 189, 164, 141, 119, 96, 78, 56, 39, 21, 6, 247, 232, 219, 207, 195,
	184, 172, 162, 154, 144, 136, 127, 120, 112, 106, 100, 94, 13, 13, 12, 11,
	11, 10, 10, 9, 8, 8, 7, 7, 7, 6, 6, 5, 5, 5, 4, 4,
	4, 4, 3, 3, 3, 3, 3, 2, 2, 2, 2, 2, 2, 2, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 24, 24, 24, 24,
	24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 22, 22, 23, 23, 23,
	23, 24, 24, 24, 24, 24, 25, 25, 25, 25, 26, 21, 21, 22, 22, 22,
	23, 23, 24, 24, 24, 25, 25, 26, 26, 26, 27, 20, 21, 21, 22, 22,
	23, 23, 24, 24, 24, 25, 25, 26, 26, 27, 27, 20, 20, 21, 21, 22,
	22, 23, 23, 24, 25, 25, 26, 26, 27, 27, 28, 19, 20, 20, 21, 22,
	22, 23, 23, 24, 25, 25, 26, 26, 27, 28, 28, 19, 19, 20, 21, 21,
	22, 23, 23, 24, 25, 25, 26, 27, 27, 28, 29, 18, 19, 20, 20, 21,
	22, 23, 23, 24, 25, 25, 26, 27, 28, 28, 29, 18, 19, 19, 20, 21,
	22, 22, 23, 24, 25, 26, 26, 27, 28, 29, 29, 18, 18, 19, 20, 21,
	22, 22, 23, 24, 25, 26, 26, 27, 28, 29, 30, 17, 18, 19, 20, 21,
	22, 22, 23, 24, 25, 26, 26, 27, 28, 29, 30, 17, 18, 19, 20, 21,
	21, 22, 23, 24, 25, 26, 27, 27, 28, 29, 30, 17, 18, 19, 20, 20,
	21, 22, 23, 24, 25, 26, 27, 28, 28, 29, 30, 17, 18, 19, 19, 20,
	21, 22, 23, 24, 25, 26, 27, 28, 29, 29, 30, 17, 18, 18, 19, 20,
	21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 30, 16, 17, 18, 19, 20,
	21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 34, 36, 38, 41,
	43, 46, 48, 51, 55, 58, 61, 65, 69, 73, 77, 82, 87, 92, 97, 103,
	110, 116, 123, 130, 138, 146, 155, 164, 174, 184, 195, 207, 220, 233, 246, 5,
	21, 37, 55, 73, 93, 113, 135, 159, 184, 210, 237, 11, 42, 75, 110, 147,
	186, 227, 15, 62, 112, 164, 219, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 3, 3,
	3, 3, 3, 229, 42, 64, 89, 100, 238, 8, 166, 11, 12, 12, 12, 12,
	12, 13, 13, 142, 50, 7, 140, 54, 7, 41, 7, 168, 185, 189, 11, 141,
	227, 11, 185, 197, 11, 141, 228, 11, 76, 255, 255, 173, 54, 7, 174, 50,
	7, 141, 148, 7, 141, 155, 7, 142, 149, 7, 142, 156, 7, 24, 105, 64,
	141, 129, 5, 141, 135, 5, 144, 1, 232, 142, 130, 5, 142, 136, 5, 24,
	105, 128, 141, 124, 9, 144, 1, 232, 142, 125, 9, 232, 141, 31, 12, 142,
	32, 12, 162, 9, 189, 255, 255, 157, 179, 13, 202, 16, 247, 206, 188, 13,
	169, 0, 141, 46, 7, 162, 98, 157, 189, 13, 202, 16, 250, 162, 8, 157,
	0, 210, 202, 16, 250, 96, 32, 42, 12, 173, 50, 7, 10, 141, 22, 14,
	173, 187, 13, 141, 23, 14, 169, 1, 141, 21, 14, 141, 46, 7, 96, 173,
	54, 7, 133, 254, 173, 50, 7, 133, 255, 96, 173, 54, 7, 41, 3, 170,
	173, 50, 7, 32, 198, 7, 173, 26, 14, 240, 238, 14, 54, 7, 32, 190,
	12, 169, 1, 141, 27, 14, 173, 26, 14, 240, 222, 201, 1, 208, 5, 160,
	0, 238, 26, 14, 177, 252, 174, 24, 14, 74, 74, 74, 74, 9, 16, 141,
	10, 212, 141, 10, 212, 157, 1, 210, 177, 252, 9, 16, 141, 10, 212, 141,
	10, 212, 157, 1, 210, 200, 208, 206, 230, 253, 165, 253, 197, 248, 208, 198,
	140, 26, 14, 96, 144, 21, 169, 234, 141, 153, 12, 141, 154, 12, 141, 155,
	12, 141, 166, 12, 141, 167, 12, 141, 168, 12, 96, 169, 141, 141, 153, 12,
	141, 166, 12, 169, 10, 141, 154, 12, 141, 167, 12, 169, 212, 141, 155, 12,
	141, 168, 12, 96, 169, 0, 141, 26, 14, 173, 50, 7, 74, 32, 190, 12,
	169, 1, 141, 27, 14, 32, 128, 12, 173, 27, 14, 208, 248, 96, 169, 2,
	141, 27, 14, 141, 25, 14, 169, 24, 141, 7, 210, 169, 17, 133, 250, 169,
	13, 133, 251, 169, 173, 141, 97, 13, 141, 56, 13, 160, 0, 140, 121, 13,
	140, 127, 13, 174, 11, 212, 177, 252, 74, 74, 74, 74, 9, 16, 141, 7,
	210, 32, 117, 13, 236, 11, 212, 240, 251, 141, 5, 210, 174, 11, 212, 177,
	252, 230, 252, 208, 16, 230, 253, 198, 248, 208, 10, 169, 173, 141, 97, 13,
	141, 56, 13, 169, 8, 9, 16, 141, 7, 210, 32, 117, 13, 236, 11, 212,
	240, 251, 141, 5, 210, 173, 27, 14, 208, 185, 96, 24, 165, 249, 105, 0,
	133, 249, 165, 250, 105, 0, 133, 250, 144, 15, 230, 251, 165, 251, 201, 0,
	208, 7, 140, 121, 13, 140, 127, 13, 96, 177, 250, 36, 249, 48, 4, 74,
	74, 74, 74, 41, 15, 168, 185, 69, 10, 160, 0, 96, 160, 0, 140, 27,
	14, 140, 26, 14, 136, 140, 25, 14, 96 };
static const unsigned char CiBinaryResource_rmt4_obx[2007] = { 255, 255, 144, 3, 96, 11, 128, 0, 128, 32, 128, 64, 0, 192, 128, 128,
	128, 160, 0, 192, 64, 192, 0, 1, 5, 11, 21, 0, 1, 255, 255, 1,
	1, 0, 255, 255, 0, 1, 1, 1, 0, 255, 255, 255, 255, 0, 1, 1,
	0, 0, 0, 0, 0, 0, 242, 51, 150, 226, 56, 140, 0, 106, 232, 106,
	239, 128, 8, 174, 70, 230, 149, 65, 246, 176, 110, 48, 246, 187, 132, 82,
	34, 244, 200, 160, 122, 85, 52, 20, 245, 216, 189, 164, 141, 119, 96, 78,
	56, 39, 21, 6, 247, 232, 219, 207, 195, 184, 172, 162, 154, 144, 136, 127,
	120, 112, 106, 100, 94, 0, 191, 182, 170, 161, 152, 143, 137, 128, 242, 230,
	218, 206, 191, 182, 170, 161, 152, 143, 137, 128, 122, 113, 107, 101, 95, 92,
	86, 80, 77, 71, 68, 62, 60, 56, 53, 50, 47, 45, 42, 40, 37, 35,
	33, 31, 29, 28, 26, 24, 23, 22, 20, 19, 18, 17, 16, 15, 14, 13,
	12, 11, 10, 9, 8, 7, 255, 241, 228, 216, 202, 192, 181, 171, 162, 153,
	142, 135, 127, 121, 115, 112, 102, 97, 90, 85, 82, 75, 72, 67, 63, 60,
	57, 55, 51, 48, 45, 42, 40, 37, 36, 33, 31, 30, 28, 27, 25, 23,
	22, 21, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6,
	5, 4, 3, 2, 1, 0, 243, 230, 217, 204, 193, 181, 173, 162, 153, 144,
	136, 128, 121, 114, 108, 102, 96, 91, 85, 81, 76, 72, 68, 64, 60, 57,
	53, 50, 47, 45, 42, 40, 37, 35, 33, 31, 29, 28, 26, 24, 23, 22,
	20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5,
	4, 3, 2, 1, 0, 0, 13, 13, 12, 11, 11, 10, 10, 9, 8, 8,
	7, 7, 7, 6, 6, 5, 5, 5, 4, 4, 4, 4, 3, 3, 3, 3,
	3, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1,
	1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1,
	1, 1, 2, 2, 2, 2, 0, 0, 0, 1, 1, 1, 1, 1, 2, 2,
	2, 2, 2, 3, 3, 3, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2,
	3, 3, 3, 3, 4, 4, 0, 0, 1, 1, 1, 2, 2, 2, 3, 3,
	3, 4, 4, 4, 5, 5, 0, 0, 1, 1, 2, 2, 2, 3, 3, 4,
	4, 4, 5, 5, 6, 6, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4,
	5, 5, 6, 6, 7, 7, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5,
	5, 6, 6, 7, 7, 8, 0, 1, 1, 2, 2, 3, 4, 4, 5, 5,
	6, 7, 7, 8, 8, 9, 0, 1, 1, 2, 3, 3, 4, 5, 5, 6,
	7, 7, 8, 9, 9, 10, 0, 1, 1, 2, 3, 4, 4, 5, 6, 7,
	7, 8, 9, 10, 10, 11, 0, 1, 2, 2, 3, 4, 5, 6, 6, 7,
	8, 9, 10, 10, 11, 12, 0, 1, 2, 3, 3, 4, 5, 6, 7, 8,
	9, 10, 10, 11, 12, 13, 0, 1, 2, 3, 4, 5, 6, 7, 7, 8,
	9, 10, 11, 12, 13, 14, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,
	10, 11, 12, 13, 14, 15, 76, 15, 6, 76, 252, 7, 76, 33, 8, 76,
	88, 6, 76, 43, 11, 134, 211, 132, 212, 72, 160, 168, 169, 0, 153, 127,
	2, 136, 208, 250, 160, 4, 177, 211, 141, 21, 8, 200, 177, 211, 141, 36,
	3, 200, 177, 211, 141, 5, 8, 141, 38, 3, 160, 8, 177, 211, 153, 195,
	0, 200, 192, 16, 208, 246, 104, 72, 10, 10, 24, 101, 209, 133, 209, 104,
	8, 41, 192, 10, 42, 42, 40, 101, 210, 133, 210, 32, 110, 6, 169, 0,
	141, 8, 210, 160, 3, 140, 15, 210, 160, 8, 153, 0, 210, 136, 16, 250,
	173, 5, 8, 96, 162, 0, 142, 39, 3, 138, 168, 177, 209, 201, 254, 176,
	45, 168, 177, 205, 157, 128, 2, 177, 207, 157, 132, 2, 169, 0, 157, 136,
	2, 169, 1, 157, 140, 2, 169, 128, 157, 180, 2, 232, 224, 4, 208, 217,
	165, 209, 24, 105, 4, 133, 209, 144, 27, 230, 210, 76, 190, 6, 240, 4,
	169, 0, 240, 223, 160, 2, 177, 209, 170, 200, 177, 209, 133, 210, 134, 209,
	162, 0, 240, 181, 173, 36, 3, 141, 22, 7, 162, 255, 232, 222, 140, 2,
	208, 69, 189, 128, 2, 133, 211, 189, 132, 2, 133, 212, 188, 136, 2, 254,
	136, 2, 177, 211, 133, 217, 41, 63, 201, 61, 240, 17, 176, 56, 157, 144,
	2, 157, 16, 3, 200, 177, 211, 74, 41, 126, 157, 180, 2, 169, 1, 157,
	140, 2, 188, 136, 2, 254, 136, 2, 177, 211, 74, 102, 217, 74, 102, 217,
	165, 217, 41, 240, 157, 148, 2, 224, 3, 208, 177, 169, 255, 141, 36, 3,
	141, 37, 3, 76, 101, 7, 201, 63, 240, 27, 165, 217, 41, 192, 240, 9,
	10, 42, 42, 157, 140, 2, 76, 17, 7, 200, 177, 211, 157, 140, 2, 254,
	136, 2, 76, 17, 7, 165, 217, 48, 12, 200, 177, 211, 141, 22, 7, 254,
	136, 2, 76, 214, 6, 201, 255, 240, 9, 200, 177, 211, 157, 136, 2, 76,
	214, 6, 76, 110, 6, 76, 33, 8, 202, 48, 250, 188, 180, 2, 48, 248,
	177, 203, 157, 184, 2, 133, 215, 200, 177, 203, 157, 188, 2, 133, 216, 169,
	1, 157, 20, 3, 168, 177, 215, 157, 4, 3, 200, 177, 215, 157, 196, 2,
	200, 177, 215, 157, 200, 2, 200, 177, 215, 157, 240, 2, 41, 63, 157, 8,
	3, 177, 215, 41, 64, 157, 244, 2, 200, 177, 215, 157, 32, 3, 200, 177,
	215, 157, 208, 2, 200, 177, 215, 157, 216, 2, 200, 177, 215, 157, 220, 2,
	200, 177, 215, 168, 185, 160, 3, 157, 224, 2, 157, 228, 2, 185, 161, 3,
	157, 232, 2, 160, 10, 177, 215, 157, 236, 2, 169, 128, 157, 212, 2, 157,
	180, 2, 10, 157, 204, 2, 157, 156, 2, 168, 177, 215, 157, 0, 3, 105,
	0, 157, 192, 2, 169, 12, 157, 252, 2, 168, 177, 215, 157, 248, 2, 76,
	98, 7, 32, 43, 11, 206, 38, 3, 208, 29, 169, 255, 141, 38, 3, 206,
	37, 3, 208, 19, 238, 39, 3, 173, 39, 3, 201, 255, 240, 3, 76, 190,
	6, 76, 110, 6, 76, 95, 10, 169, 4, 133, 214, 162, 3, 189, 188, 2,
	240, 242, 133, 212, 189, 184, 2, 133, 211, 188, 192, 2, 177, 211, 133, 217,
	200, 177, 211, 133, 218, 200, 177, 211, 133, 219, 200, 152, 221, 196, 2, 144,
	10, 240, 8, 169, 128, 157, 204, 2, 189, 200, 2, 157, 192, 2, 165, 217,
	41, 15, 29, 148, 2, 168, 185, 0, 5, 133, 220, 165, 218, 41, 14, 168,
	185, 144, 3, 133, 213, 165, 220, 25, 145, 3, 157, 28, 3, 189, 220, 2,
	240, 40, 201, 1, 208, 33, 189, 156, 2, 24, 125, 236, 2, 24, 188, 224,
	2, 121, 165, 3, 157, 156, 2, 200, 152, 221, 232, 2, 208, 3, 189, 228,
	2, 157, 224, 2, 76, 164, 8, 222, 220, 2, 188, 0, 3, 192, 13, 144,
	60, 189, 8, 3, 16, 49, 152, 221, 252, 2, 208, 8, 189, 4, 3, 157,
	252, 2, 208, 3, 254, 252, 2, 189, 184, 2, 133, 215, 189, 188, 2, 133,
	216, 188, 252, 2, 177, 215, 188, 244, 2, 240, 4, 24, 125, 248, 2, 157,
	248, 2, 189, 240, 2, 41, 63, 56, 233, 1, 157, 8, 3, 189, 204, 2,
	16, 31, 189, 148, 2, 240, 26, 221, 216, 2, 240, 21, 144, 19, 168, 189,
	212, 2, 24, 125, 208, 2, 157, 212, 2, 144, 6, 152, 233, 16, 157, 148,
	2, 169, 0, 133, 221, 165, 218, 157, 12, 3, 41, 112, 74, 74, 141, 28,
	9, 144, 254, 76, 210, 9, 234, 76, 60, 9, 234, 76, 65, 9, 234, 76,
	75, 9, 234, 76, 87, 9, 234, 76, 102, 9, 234, 76, 169, 9, 234, 76,
	184, 9, 165, 219, 76, 21, 10, 165, 219, 133, 221, 189, 144, 2, 76, 216,
	9, 189, 144, 2, 24, 101, 219, 157, 144, 2, 76, 216, 9, 189, 156, 2,
	24, 101, 219, 157, 156, 2, 189, 144, 2, 76, 216, 9, 189, 240, 2, 16,
	12, 188, 144, 2, 177, 213, 24, 125, 248, 2, 76, 135, 9, 189, 144, 2,
	24, 125, 248, 2, 201, 61, 144, 2, 169, 63, 168, 177, 213, 157, 160, 2,
	164, 219, 208, 3, 157, 164, 2, 152, 74, 74, 74, 74, 157, 168, 2, 157,
	172, 2, 165, 219, 41, 15, 157, 176, 2, 189, 144, 2, 76, 216, 9, 165,
	219, 24, 125, 20, 3, 157, 20, 3, 189, 144, 2, 76, 216, 9, 165, 219,
	201, 128, 240, 6, 157, 144, 2, 76, 216, 9, 189, 28, 3, 9, 240, 157,
	28, 3, 189, 144, 2, 76, 216, 9, 189, 144, 2, 24, 101, 219, 188, 240,
	2, 48, 31, 24, 125, 248, 2, 201, 61, 144, 7, 169, 0, 157, 28, 3,
	169, 63, 157, 16, 3, 168, 177, 213, 24, 125, 156, 2, 24, 101, 221, 76,
	21, 10, 201, 61, 144, 7, 169, 0, 157, 28, 3, 169, 63, 168, 189, 156,
	2, 24, 125, 248, 2, 24, 113, 213, 24, 101, 221, 157, 24, 3, 189, 172,
	2, 240, 50, 222, 172, 2, 208, 45, 189, 168, 2, 157, 172, 2, 189, 164,
	2, 221, 160, 2, 240, 31, 176, 13, 125, 176, 2, 176, 18, 221, 160, 2,
	176, 13, 76, 76, 10, 253, 176, 2, 144, 5, 221, 160, 2, 176, 3, 189,
	160, 2, 157, 164, 2, 165, 218, 41, 1, 240, 10, 189, 164, 2, 24, 125,
	156, 2, 157, 24, 3, 202, 48, 3, 76, 39, 8, 173, 32, 3, 13, 33,
	3, 13, 34, 3, 13, 35, 3, 170, 142, 44, 11, 173, 12, 3, 16, 33,
	173, 28, 3, 41, 15, 240, 26, 173, 24, 3, 24, 109, 20, 3, 141, 26,
	3, 173, 30, 3, 41, 16, 208, 5, 169, 0, 141, 30, 3, 138, 9, 4,
	170, 173, 13, 3, 16, 33, 173, 29, 3, 41, 15, 240, 26, 173, 25, 3,
	24, 109, 21, 3, 141, 27, 3, 173, 31, 3, 41, 16, 208, 5, 169, 0,
	141, 31, 3, 138, 9, 2, 170, 236, 44, 11, 208, 94, 173, 13, 3, 41,
	14, 201, 6, 208, 38, 173, 29, 3, 41, 15, 240, 31, 172, 17, 3, 185,
	192, 3, 141, 24, 3, 185, 192, 4, 141, 25, 3, 173, 28, 3, 41, 16,
	208, 5, 169, 0, 141, 28, 3, 138, 9, 80, 170, 173, 15, 3, 41, 14,
	201, 6, 208, 38, 173, 31, 3, 41, 15, 240, 31, 172, 19, 3, 185, 192,
	3, 141, 26, 3, 185, 192, 4, 141, 27, 3, 173, 30, 3, 41, 16, 208,
	5, 169, 0, 141, 30, 3, 138, 9, 40, 170, 142, 44, 11, 173, 38, 3,
	96, 160, 255, 173, 24, 3, 174, 28, 3, 141, 0, 210, 142, 1, 210, 173,
	25, 3, 174, 29, 3, 141, 2, 210, 142, 3, 210, 173, 26, 3, 174, 30,
	3, 141, 4, 210, 142, 5, 210, 173, 27, 3, 174, 31, 3, 141, 6, 210,
	142, 7, 210, 140, 8, 210, 96 };
static const unsigned char CiBinaryResource_rmt8_obx[2275] = { 255, 255, 144, 3, 108, 12, 128, 0, 128, 32, 128, 64, 0, 192, 128, 128,
	128, 160, 0, 192, 64, 192, 0, 1, 5, 11, 21, 0, 1, 255, 255, 1,
	1, 0, 255, 255, 0, 1, 1, 1, 0, 255, 255, 255, 255, 0, 1, 1,
	0, 0, 0, 0, 0, 0, 242, 51, 150, 226, 56, 140, 0, 106, 232, 106,
	239, 128, 8, 174, 70, 230, 149, 65, 246, 176, 110, 48, 246, 187, 132, 82,
	34, 244, 200, 160, 122, 85, 52, 20, 245, 216, 189, 164, 141, 119, 96, 78,
	56, 39, 21, 6, 247, 232, 219, 207, 195, 184, 172, 162, 154, 144, 136, 127,
	120, 112, 106, 100, 94, 0, 191, 182, 170, 161, 152, 143, 137, 128, 242, 230,
	218, 206, 191, 182, 170, 161, 152, 143, 137, 128, 122, 113, 107, 101, 95, 92,
	86, 80, 77, 71, 68, 62, 60, 56, 53, 50, 47, 45, 42, 40, 37, 35,
	33, 31, 29, 28, 26, 24, 23, 22, 20, 19, 18, 17, 16, 15, 14, 13,
	12, 11, 10, 9, 8, 7, 255, 241, 228, 216, 202, 192, 181, 171, 162, 153,
	142, 135, 127, 121, 115, 112, 102, 97, 90, 85, 82, 75, 72, 67, 63, 60,
	57, 55, 51, 48, 45, 42, 40, 37, 36, 33, 31, 30, 28, 27, 25, 23,
	22, 21, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6,
	5, 4, 3, 2, 1, 0, 243, 230, 217, 204, 193, 181, 173, 162, 153, 144,
	136, 128, 121, 114, 108, 102, 96, 91, 85, 81, 76, 72, 68, 64, 60, 57,
	53, 50, 47, 45, 42, 40, 37, 35, 33, 31, 29, 28, 26, 24, 23, 22,
	20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5,
	4, 3, 2, 1, 0, 0, 13, 13, 12, 11, 11, 10, 10, 9, 8, 8,
	7, 7, 7, 6, 6, 5, 5, 5, 4, 4, 4, 4, 3, 3, 3, 3,
	3, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1,
	1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1,
	1, 1, 2, 2, 2, 2, 0, 0, 0, 1, 1, 1, 1, 1, 2, 2,
	2, 2, 2, 3, 3, 3, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2,
	3, 3, 3, 3, 4, 4, 0, 0, 1, 1, 1, 2, 2, 2, 3, 3,
	3, 4, 4, 4, 5, 5, 0, 0, 1, 1, 2, 2, 2, 3, 3, 4,
	4, 4, 5, 5, 6, 6, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4,
	5, 5, 6, 6, 7, 7, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5,
	5, 6, 6, 7, 7, 8, 0, 1, 1, 2, 2, 3, 4, 4, 5, 5,
	6, 7, 7, 8, 8, 9, 0, 1, 1, 2, 3, 3, 4, 5, 5, 6,
	7, 7, 8, 9, 9, 10, 0, 1, 1, 2, 3, 4, 4, 5, 6, 7,
	7, 8, 9, 10, 10, 11, 0, 1, 2, 2, 3, 4, 5, 6, 6, 7,
	8, 9, 10, 10, 11, 12, 0, 1, 2, 3, 3, 4, 5, 6, 7, 8,
	9, 10, 10, 11, 12, 13, 0, 1, 2, 3, 4, 5, 6, 7, 7, 8,
	9, 10, 11, 12, 13, 14, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,
	10, 11, 12, 13, 14, 15, 76, 15, 6, 76, 9, 8, 76, 46, 8, 76,
	92, 6, 76, 2, 12, 134, 211, 132, 212, 72, 160, 0, 152, 153, 0, 2,
	153, 76, 2, 200, 208, 247, 160, 4, 177, 211, 141, 34, 8, 200, 177, 211,
	141, 72, 3, 200, 177, 211, 141, 18, 8, 141, 74, 3, 160, 8, 177, 211,
	153, 195, 0, 200, 192, 16, 208, 246, 104, 72, 10, 10, 10, 24, 101, 209,
	133, 209, 104, 8, 41, 224, 10, 42, 42, 42, 40, 101, 210, 133, 210, 32,
	123, 6, 169, 0, 141, 8, 210, 141, 24, 210, 160, 3, 140, 15, 210, 140,
	31, 210, 160, 8, 153, 0, 210, 153, 16, 210, 136, 16, 247, 173, 18, 8,
	96, 162, 0, 142, 75, 3, 138, 168, 177, 209, 201, 254, 176, 45, 168, 177,
	205, 157, 0, 2, 177, 207, 157, 8, 2, 169, 0, 157, 16, 2, 169, 1,
	157, 24, 2, 169, 128, 157, 104, 2, 232, 224, 8, 208, 217, 165, 209, 24,
	105, 8, 133, 209, 144, 27, 230, 210, 76, 203, 6, 240, 4, 169, 0, 240,
	223, 160, 2, 177, 209, 170, 200, 177, 209, 133, 210, 134, 209, 162, 0, 240,
	181, 173, 72, 3, 141, 35, 7, 162, 255, 232, 222, 24, 2, 208, 69, 189,
	0, 2, 133, 211, 189, 8, 2, 133, 212, 188, 16, 2, 254, 16, 2, 177,
	211, 133, 217, 41, 63, 201, 61, 240, 17, 176, 56, 157, 32, 2, 157, 32,
	3, 200, 177, 211, 74, 41, 126, 157, 104, 2, 169, 1, 157, 24, 2, 188,
	16, 2, 254, 16, 2, 177, 211, 74, 102, 217, 74, 102, 217, 165, 217, 41,
	240, 157, 40, 2, 224, 7, 208, 177, 169, 255, 141, 72, 3, 141, 73, 3,
	76, 114, 7, 201, 63, 240, 27, 165, 217, 41, 192, 240, 9, 10, 42, 42,
	157, 24, 2, 76, 30, 7, 200, 177, 211, 157, 24, 2, 254, 16, 2, 76,
	30, 7, 165, 217, 48, 12, 200, 177, 211, 141, 35, 7, 254, 16, 2, 76,
	227, 6, 201, 255, 240, 9, 200, 177, 211, 157, 16, 2, 76, 227, 6, 76,
	123, 6, 76, 46, 8, 202, 48, 250, 188, 104, 2, 48, 248, 177, 203, 157,
	112, 2, 133, 215, 200, 177, 203, 157, 120, 2, 133, 216, 169, 1, 157, 40,
	3, 168, 177, 215, 157, 8, 3, 200, 177, 215, 157, 136, 2, 200, 177, 215,
	157, 144, 2, 200, 177, 215, 157, 224, 2, 41, 63, 157, 16, 3, 177, 215,
	41, 64, 157, 232, 2, 200, 177, 215, 157, 64, 3, 200, 177, 215, 157, 160,
	2, 200, 177, 215, 157, 176, 2, 200, 177, 215, 157, 184, 2, 200, 177, 215,
	168, 185, 160, 3, 157, 192, 2, 157, 200, 2, 185, 161, 3, 157, 208, 2,
	160, 10, 177, 215, 157, 216, 2, 169, 128, 157, 168, 2, 157, 104, 2, 10,
	157, 152, 2, 157, 56, 2, 168, 177, 215, 157, 0, 3, 105, 0, 157, 128,
	2, 169, 12, 157, 248, 2, 168, 177, 215, 157, 240, 2, 76, 111, 7, 32,
	2, 12, 206, 74, 3, 208, 29, 169, 255, 141, 74, 3, 206, 73, 3, 208,
	19, 238, 75, 3, 173, 75, 3, 201, 255, 240, 3, 76, 203, 6, 76, 123,
	6, 76, 116, 10, 169, 4, 133, 214, 162, 7, 189, 120, 2, 240, 242, 133,
	212, 189, 112, 2, 133, 211, 188, 128, 2, 177, 211, 133, 217, 200, 177, 211,
	133, 218, 200, 177, 211, 133, 219, 200, 152, 221, 136, 2, 144, 10, 240, 8,
	169, 128, 157, 152, 2, 189, 144, 2, 157, 128, 2, 165, 217, 224, 4, 144,
	4, 74, 74, 74, 74, 41, 15, 29, 40, 2, 168, 185, 0, 5, 133, 220,
	165, 218, 41, 14, 168, 185, 144, 3, 133, 213, 165, 220, 25, 145, 3, 157,
	56, 3, 189, 184, 2, 240, 40, 201, 1, 208, 33, 189, 56, 2, 24, 125,
	216, 2, 24, 188, 192, 2, 121, 165, 3, 157, 56, 2, 200, 152, 221, 208,
	2, 208, 3, 189, 200, 2, 157, 192, 2, 76, 185, 8, 222, 184, 2, 188,
	0, 3, 192, 13, 144, 60, 189, 16, 3, 16, 49, 152, 221, 248, 2, 208,
	8, 189, 8, 3, 157, 248, 2, 208, 3, 254, 248, 2, 189, 112, 2, 133,
	215, 189, 120, 2, 133, 216, 188, 248, 2, 177, 215, 188, 232, 2, 240, 4,
	24, 125, 240, 2, 157, 240, 2, 189, 224, 2, 41, 63, 56, 233, 1, 157,
	16, 3, 189, 152, 2, 16, 31, 189, 40, 2, 240, 26, 221, 176, 2, 240,
	21, 144, 19, 168, 189, 168, 2, 24, 125, 160, 2, 157, 168, 2, 144, 6,
	152, 233, 16, 157, 40, 2, 169, 0, 133, 221, 165, 218, 157, 24, 3, 41,
	112, 74, 74, 141, 49, 9, 144, 254, 76, 231, 9, 234, 76, 81, 9, 234,
	76, 86, 9, 234, 76, 96, 9, 234, 76, 108, 9, 234, 76, 123, 9, 234,
	76, 190, 9, 234, 76, 205, 9, 165, 219, 76, 42, 10, 165, 219, 133, 221,
	189, 32, 2, 76, 237, 9, 189, 32, 2, 24, 101, 219, 157, 32, 2, 76,
	237, 9, 189, 56, 2, 24, 101, 219, 157, 56, 2, 189, 32, 2, 76, 237,
	9, 189, 224, 2, 16, 12, 188, 32, 2, 177, 213, 24, 125, 240, 2, 76,
	156, 9, 189, 32, 2, 24, 125, 240, 2, 201, 61, 144, 2, 169, 63, 168,
	177, 213, 157, 64, 2, 164, 219, 208, 3, 157, 72, 2, 152, 74, 74, 74,
	74, 157, 80, 2, 157, 88, 2, 165, 219, 41, 15, 157, 96, 2, 189, 32,
	2, 76, 237, 9, 165, 219, 24, 125, 40, 3, 157, 40, 3, 189, 32, 2,
	76, 237, 9, 165, 219, 201, 128, 240, 6, 157, 32, 2, 76, 237, 9, 189,
	56, 3, 9, 240, 157, 56, 3, 189, 32, 2, 76, 237, 9, 189, 32, 2,
	24, 101, 219, 188, 224, 2, 48, 31, 24, 125, 240, 2, 201, 61, 144, 7,
	169, 0, 157, 56, 3, 169, 63, 157, 32, 3, 168, 177, 213, 24, 125, 56,
	2, 24, 101, 221, 76, 42, 10, 201, 61, 144, 7, 169, 0, 157, 56, 3,
	169, 63, 168, 189, 56, 2, 24, 125, 240, 2, 24, 113, 213, 24, 101, 221,
	157, 48, 3, 189, 88, 2, 240, 50, 222, 88, 2, 208, 45, 189, 80, 2,
	157, 88, 2, 189, 72, 2, 221, 64, 2, 240, 31, 176, 13, 125, 96, 2,
	176, 18, 221, 64, 2, 176, 13, 76, 97, 10, 253, 96, 2, 144, 5, 221,
	64, 2, 176, 3, 189, 64, 2, 157, 72, 2, 165, 218, 41, 1, 240, 10,
	189, 72, 2, 24, 125, 56, 2, 157, 48, 3, 202, 48, 3, 76, 52, 8,
	173, 64, 3, 13, 65, 3, 13, 66, 3, 13, 67, 3, 170, 142, 101, 12,
	173, 24, 3, 16, 33, 173, 56, 3, 41, 15, 240, 26, 173, 48, 3, 24,
	109, 40, 3, 141, 50, 3, 173, 58, 3, 41, 16, 208, 5, 169, 0, 141,
	58, 3, 138, 9, 4, 170, 173, 25, 3, 16, 33, 173, 57, 3, 41, 15,
	240, 26, 173, 49, 3, 24, 109, 41, 3, 141, 51, 3, 173, 59, 3, 41,
	16, 208, 5, 169, 0, 141, 59, 3, 138, 9, 2, 170, 236, 101, 12, 208,
	94, 173, 25, 3, 41, 14, 201, 6, 208, 38, 173, 57, 3, 41, 15, 240,
	31, 172, 33, 3, 185, 192, 3, 141, 48, 3, 185, 192, 4, 141, 49, 3,
	173, 56, 3, 41, 16, 208, 5, 169, 0, 141, 56, 3, 138, 9, 80, 170,
	173, 27, 3, 41, 14, 201, 6, 208, 38, 173, 59, 3, 41, 15, 240, 31,
	172, 35, 3, 185, 192, 3, 141, 50, 3, 185, 192, 4, 141, 51, 3, 173,
	58, 3, 41, 16, 208, 5, 169, 0, 141, 58, 3, 138, 9, 40, 170, 142,
	101, 12, 173, 68, 3, 13, 69, 3, 13, 70, 3, 13, 71, 3, 170, 142,
	3, 12, 173, 28, 3, 16, 33, 173, 60, 3, 41, 15, 240, 26, 173, 52,
	3, 24, 109, 44, 3, 141, 54, 3, 173, 62, 3, 41, 16, 208, 5, 169,
	0, 141, 62, 3, 138, 9, 4, 170, 173, 29, 3, 16, 33, 173, 61, 3,
	41, 15, 240, 26, 173, 53, 3, 24, 109, 45, 3, 141, 55, 3, 173, 63,
	3, 41, 16, 208, 5, 169, 0, 141, 63, 3, 138, 9, 2, 170, 236, 3,
	12, 208, 94, 173, 29, 3, 41, 14, 201, 6, 208, 38, 173, 61, 3, 41,
	15, 240, 31, 172, 37, 3, 185, 192, 3, 141, 52, 3, 185, 192, 4, 141,
	53, 3, 173, 60, 3, 41, 16, 208, 5, 169, 0, 141, 60, 3, 138, 9,
	80, 170, 173, 31, 3, 41, 14, 201, 6, 208, 38, 173, 63, 3, 41, 15,
	240, 31, 172, 39, 3, 185, 192, 3, 141, 54, 3, 185, 192, 4, 141, 55,
	3, 173, 62, 3, 41, 16, 208, 5, 169, 0, 141, 62, 3, 138, 9, 40,
	170, 142, 3, 12, 173, 74, 3, 96, 160, 255, 173, 52, 3, 174, 48, 3,
	141, 16, 210, 142, 0, 210, 173, 60, 3, 174, 56, 3, 141, 17, 210, 142,
	1, 210, 173, 53, 3, 174, 49, 3, 141, 18, 210, 142, 2, 210, 173, 61,
	3, 174, 57, 3, 141, 19, 210, 142, 3, 210, 173, 54, 3, 174, 50, 3,
	141, 20, 210, 142, 4, 210, 173, 62, 3, 174, 58, 3, 141, 21, 210, 142,
	5, 210, 173, 55, 3, 174, 51, 3, 141, 22, 210, 142, 6, 210, 173, 63,
	3, 174, 59, 3, 141, 23, 210, 142, 7, 210, 169, 255, 140, 24, 210, 141,
	8, 210, 96 };
static const unsigned char CiBinaryResource_tm2_obx[3698] = { 255, 255, 0, 5, 107, 19, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1,
	1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1,
	1, 1, 2, 2, 2, 2, 0, 0, 0, 1, 1, 1, 1, 1, 2, 2,
	2, 2, 2, 3, 3, 3, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2,
	3, 3, 3, 3, 4, 4, 0, 0, 1, 1, 1, 2, 2, 2, 3, 3,
	3, 4, 4, 4, 5, 5, 0, 0, 1, 1, 2, 2, 2, 3, 3, 4,
	4, 4, 5, 5, 6, 6, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4,
	5, 5, 6, 6, 7, 7, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5,
	5, 6, 6, 7, 7, 8, 0, 1, 1, 2, 2, 3, 4, 4, 5, 5,
	6, 7, 7, 8, 8, 9, 0, 1, 1, 2, 3, 3, 4, 5, 5, 6,
	7, 7, 8, 9, 9, 10, 0, 1, 1, 2, 3, 4, 4, 5, 6, 7,
	7, 8, 9, 10, 10, 11, 0, 1, 2, 2, 3, 4, 5, 6, 6, 7,
	8, 9, 10, 10, 11, 12, 0, 1, 2, 3, 3, 4, 5, 6, 7, 8,
	9, 10, 10, 11, 12, 13, 0, 1, 2, 3, 4, 5, 6, 7, 7, 8,
	9, 10, 11, 12, 13, 14, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,
	10, 11, 12, 13, 14, 15, 0, 241, 228, 215, 203, 192, 181, 170, 161, 152,
	143, 135, 127, 120, 114, 107, 101, 95, 90, 85, 80, 75, 71, 67, 63, 60,
	56, 53, 50, 47, 44, 42, 39, 37, 35, 33, 31, 29, 28, 26, 24, 23,
	22, 20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6,
	5, 4, 3, 2, 1, 0, 0, 242, 233, 218, 206, 191, 182, 170, 161, 152,
	143, 137, 128, 122, 113, 107, 101, 95, 92, 86, 80, 77, 71, 68, 62, 60,
	56, 53, 50, 47, 45, 42, 40, 37, 35, 33, 31, 29, 28, 26, 24, 23,
	22, 20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6,
	5, 4, 3, 2, 1, 0, 0, 255, 241, 228, 216, 202, 192, 181, 171, 162,
	153, 142, 135, 127, 121, 115, 112, 102, 97, 90, 85, 82, 75, 72, 67, 63,
	60, 57, 55, 51, 48, 45, 42, 40, 37, 36, 33, 31, 30, 28, 27, 25,
	23, 22, 21, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7,
	6, 5, 4, 3, 2, 1, 0, 243, 230, 217, 204, 193, 181, 173, 162, 153,
	144, 136, 128, 121, 114, 108, 102, 96, 91, 85, 81, 76, 72, 68, 64, 60,
	57, 53, 50, 47, 45, 42, 40, 37, 35, 33, 31, 29, 28, 26, 24, 23,
	22, 20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6,
	5, 4, 3, 2, 1, 0, 226, 56, 140, 0, 106, 232, 106, 239, 128, 8,
	174, 70, 230, 149, 65, 246, 176, 110, 48, 246, 187, 132, 82, 34, 244, 200,
	160, 122, 85, 52, 20, 245, 216, 189, 164, 141, 119, 96, 78, 56, 39, 21,
	6, 247, 232, 219, 207, 195, 184, 172, 162, 154, 144, 136, 127, 120, 112, 106,
	100, 94, 87, 82, 50, 10, 0, 242, 51, 150, 226, 56, 140, 0, 106, 232,
	106, 239, 128, 8, 174, 70, 230, 149, 65, 246, 176, 110, 48, 246, 187, 132,
	82, 34, 244, 200, 160, 122, 85, 52, 20, 245, 216, 189, 164, 141, 119, 96,
	78, 56, 39, 21, 6, 247, 232, 219, 207, 195, 184, 172, 162, 154, 144, 136,
	127, 120, 112, 106, 100, 94, 11, 11, 10, 10, 9, 8, 8, 7, 7, 7,
	6, 6, 5, 5, 5, 4, 4, 4, 4, 3, 3, 3, 3, 3, 2, 2,
	2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 13, 13, 12, 11, 11, 10, 10, 9, 8,
	8, 7, 7, 7, 6, 6, 5, 5, 5, 4, 4, 4, 4, 3, 3, 3,
	3, 3, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 76, 228, 16, 76, 227, 9, 76, 159, 11, 1,
	16, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 5,
	6, 7, 0, 1, 2, 3, 4, 2, 0, 0, 4, 2, 0, 0, 0, 16,
	0, 8, 0, 16, 0, 8, 133, 211, 129, 169, 133, 211, 129, 169, 136, 177,
	250, 141, 23, 8, 162, 0, 134, 252, 10, 38, 252, 10, 38, 252, 10, 38,
	252, 10, 38, 252, 109, 23, 8, 144, 2, 230, 252, 24, 105, 0, 133, 250,
	165, 252, 105, 0, 133, 251, 76, 7, 10, 32, 181, 12, 173, 22, 8, 240,
	5, 206, 28, 8, 48, 3, 76, 162, 11, 206, 29, 8, 208, 82, 162, 0,
	238, 23, 8, 173, 25, 8, 133, 250, 173, 26, 8, 133, 251, 160, 16, 177,
	250, 48, 171, 208, 3, 76, 44, 18, 141, 29, 8, 136, 177, 250, 136, 132,
	252, 168, 185, 255, 255, 157, 80, 8, 185, 255, 255, 157, 88, 8, 169, 0,
	157, 112, 8, 157, 96, 8, 164, 252, 177, 250, 157, 104, 8, 232, 136, 16,
	219, 169, 17, 24, 101, 250, 141, 25, 8, 169, 0, 101, 251, 141, 26, 8,
	173, 27, 8, 141, 28, 8, 162, 7, 222, 112, 8, 48, 6, 202, 16, 248,
	76, 162, 11, 189, 80, 8, 133, 250, 189, 88, 8, 133, 251, 188, 96, 8,
	177, 250, 208, 28, 200, 177, 250, 157, 208, 8, 41, 240, 157, 216, 8, 177,
	250, 10, 10, 10, 10, 157, 224, 8, 200, 152, 157, 96, 8, 76, 87, 10,
	201, 64, 176, 79, 125, 104, 8, 157, 152, 8, 200, 177, 250, 16, 37, 41,
	127, 133, 252, 200, 177, 250, 157, 208, 8, 41, 240, 157, 216, 8, 177, 250,
	10, 10, 10, 10, 157, 224, 8, 200, 152, 157, 96, 8, 164, 252, 32, 156,
	18, 76, 87, 10, 168, 254, 96, 8, 254, 96, 8, 189, 208, 8, 41, 240,
	157, 216, 8, 189, 208, 8, 10, 10, 10, 10, 157, 224, 8, 32, 156, 18,
	76, 87, 10, 201, 128, 176, 37, 41, 63, 24, 125, 104, 8, 157, 152, 8,
	200, 177, 250, 157, 208, 8, 41, 240, 157, 216, 8, 177, 250, 10, 10, 10,
	10, 157, 224, 8, 200, 152, 157, 96, 8, 76, 87, 10, 208, 14, 200, 177,
	250, 157, 112, 8, 200, 152, 157, 96, 8, 76, 87, 10, 201, 192, 176, 15,
	41, 63, 24, 125, 104, 8, 157, 152, 8, 254, 96, 8, 76, 87, 10, 201,
	208, 176, 15, 200, 254, 96, 8, 41, 15, 141, 27, 8, 141, 28, 8, 76,
	106, 10, 201, 224, 176, 22, 177, 250, 133, 252, 200, 177, 250, 133, 253, 200,
	152, 157, 96, 8, 165, 252, 32, 14, 17, 76, 87, 10, 201, 240, 176, 46,
	177, 250, 133, 252, 200, 177, 250, 133, 253, 165, 252, 32, 14, 17, 188, 96,
	8, 200, 200, 177, 250, 157, 208, 8, 41, 240, 157, 216, 8, 177, 250, 10,
	10, 10, 10, 157, 224, 8, 200, 152, 157, 96, 8, 76, 87, 10, 201, 255,
	176, 11, 233, 239, 157, 112, 8, 254, 96, 8, 76, 87, 10, 169, 64, 157,
	112, 8, 76, 87, 10, 32, 181, 12, 162, 7, 189, 120, 8, 240, 115, 76,
	217, 13, 189, 14, 8, 240, 14, 169, 0, 157, 32, 8, 157, 40, 8, 202,
	16, 232, 76, 31, 12, 164, 253, 185, 0, 6, 24, 101, 252, 157, 56, 8,
	152, 157, 160, 8, 189, 176, 8, 61, 168, 9, 240, 40, 165, 253, 41, 127,
	168, 185, 0, 7, 24, 101, 252, 157, 55, 8, 185, 128, 7, 105, 0, 157,
	56, 8, 169, 0, 157, 31, 8, 188, 152, 9, 153, 39, 8, 202, 202, 16,
	169, 76, 31, 12, 189, 176, 8, 61, 160, 9, 240, 22, 189, 104, 9, 24,
	101, 253, 157, 162, 8, 168, 185, 0, 6, 24, 101, 252, 56, 101, 254, 157,
	58, 8, 202, 16, 133, 232, 134, 252, 162, 3, 173, 9, 8, 240, 6, 41,
	64, 208, 60, 162, 7, 138, 168, 185, 32, 8, 208, 12, 188, 152, 9, 185,
	40, 8, 208, 4, 138, 168, 169, 0, 25, 168, 8, 157, 48, 8, 185, 56,
	8, 157, 72, 8, 185, 160, 8, 157, 64, 8, 185, 176, 8, 5, 252, 133,
	252, 224, 4, 208, 3, 141, 31, 8, 202, 16, 202, 141, 30, 8, 96, 189,
	32, 8, 29, 168, 8, 157, 48, 8, 189, 44, 8, 29, 172, 8, 157, 52,
	8, 189, 56, 8, 157, 72, 8, 189, 60, 8, 157, 76, 8, 189, 160, 8,
	157, 64, 8, 189, 164, 8, 157, 68, 8, 202, 16, 211, 173, 176, 8, 13,
	177, 8, 13, 178, 8, 13, 179, 8, 141, 30, 8, 173, 180, 8, 13, 181,
	8, 13, 182, 8, 13, 183, 8, 141, 31, 8, 96, 173, 9, 8, 208, 3,
	76, 144, 13, 48, 3, 76, 72, 13, 173, 13, 8, 170, 74, 74, 41, 1,
	168, 185, 30, 8, 141, 56, 210, 138, 41, 4, 168, 185, 56, 8, 141, 48,
	210, 189, 32, 8, 141, 49, 210, 185, 57, 8, 141, 50, 210, 189, 33, 8,
	141, 51, 210, 185, 58, 8, 141, 52, 210, 189, 34, 8, 141, 53, 210, 185,
	59, 8, 141, 54, 210, 189, 35, 8, 141, 55, 210, 173, 12, 8, 170, 74,
	74, 41, 1, 168, 185, 30, 8, 141, 40, 210, 138, 41, 4, 168, 185, 56,
	8, 141, 32, 210, 189, 32, 8, 141, 33, 210, 185, 57, 8, 141, 34, 210,
	189, 33, 8, 141, 35, 210, 185, 58, 8, 141, 36, 210, 189, 34, 8, 141,
	37, 210, 185, 59, 8, 141, 38, 210, 189, 35, 8, 141, 39, 210, 173, 11,
	8, 170, 74, 74, 41, 1, 168, 185, 30, 8, 141, 24, 210, 138, 172, 9,
	8, 16, 2, 41, 4, 168, 185, 56, 8, 141, 16, 210, 189, 32, 8, 141,
	17, 210, 185, 57, 8, 141, 18, 210, 189, 33, 8, 141, 19, 210, 185, 58,
	8, 141, 20, 210, 189, 34, 8, 141, 21, 210, 185, 59, 8, 141, 22, 210,
	189, 35, 8, 141, 23, 210, 173, 10, 8, 170, 74, 74, 41, 1, 168, 185,
	30, 8, 141, 8, 210, 138, 172, 9, 8, 16, 2, 41, 4, 168, 185, 56,
	8, 141, 0, 210, 189, 32, 8, 141, 1, 210, 185, 57, 8, 141, 2, 210,
	189, 33, 8, 141, 3, 210, 185, 58, 8, 141, 4, 210, 189, 34, 8, 141,
	5, 210, 185, 59, 8, 141, 6, 210, 189, 35, 8, 141, 7, 210, 96, 189,
	128, 8, 133, 250, 189, 136, 8, 133, 251, 189, 128, 9, 133, 252, 189, 136,
	9, 133, 253, 189, 144, 9, 133, 254, 189, 184, 8, 221, 192, 8, 144, 12,
	157, 8, 9, 189, 200, 8, 157, 184, 8, 76, 11, 14, 189, 8, 9, 240,
	48, 189, 232, 8, 240, 19, 222, 248, 8, 208, 14, 157, 248, 8, 189, 216,
	8, 240, 6, 56, 233, 16, 157, 216, 8, 189, 240, 8, 240, 19, 222, 0,
	9, 208, 14, 157, 0, 9, 189, 224, 8, 240, 6, 56, 233, 16, 157, 224,
	8, 188, 72, 9, 177, 250, 24, 125, 152, 8, 24, 101, 253, 133, 253, 222,
	88, 9, 16, 57, 189, 80, 9, 157, 88, 9, 189, 96, 9, 240, 30, 24,
	125, 72, 9, 157, 72, 9, 240, 13, 221, 64, 9, 144, 32, 169, 255, 157,
	96, 9, 76, 135, 14, 169, 1, 157, 96, 9, 76, 135, 14, 254, 72, 9,
	189, 64, 9, 221, 72, 9, 176, 5, 169, 0, 157, 72, 9, 169, 19, 24,
	101, 250, 133, 250, 144, 2, 230, 251, 188, 184, 8, 177, 250, 41, 240, 157,
	168, 8, 177, 250, 41, 15, 29, 216, 8, 168, 185, 0, 5, 5, 255, 168,
	185, 0, 5, 157, 32, 8, 188, 184, 8, 200, 177, 250, 41, 15, 29, 224,
	8, 168, 185, 0, 5, 5, 255, 168, 185, 0, 5, 157, 40, 8, 189, 40,
	9, 208, 39, 189, 16, 9, 141, 212, 14, 16, 254, 76, 209, 15, 234, 76,
	108, 15, 234, 76, 167, 15, 234, 76, 212, 15, 234, 76, 1, 16, 234, 76,
	33, 16, 234, 76, 65, 16, 234, 76, 73, 16, 222, 40, 9, 188, 184, 8,
	200, 177, 250, 41, 112, 74, 74, 74, 141, 34, 15, 177, 250, 48, 6, 189,
	112, 9, 76, 18, 15, 189, 120, 9, 61, 176, 9, 157, 176, 8, 200, 200,
	152, 157, 184, 8, 136, 177, 250, 144, 254, 144, 22, 144, 12, 144, 34, 144,
	24, 144, 46, 144, 36, 144, 50, 144, 52, 125, 128, 9, 157, 128, 9, 177,
	250, 24, 101, 252, 133, 252, 76, 172, 11, 125, 136, 9, 157, 136, 9, 177,
	250, 24, 101, 253, 133, 253, 76, 172, 11, 125, 144, 9, 157, 144, 9, 177,
	250, 24, 101, 254, 133, 254, 76, 172, 11, 133, 252, 169, 0, 133, 253, 76,
	172, 11, 189, 32, 9, 41, 3, 74, 144, 10, 208, 25, 189, 24, 9, 24,
	101, 252, 133, 252, 222, 56, 9, 16, 78, 254, 32, 9, 189, 48, 9, 157,
	56, 9, 76, 247, 14, 165, 252, 253, 24, 9, 133, 252, 222, 56, 9, 16,
	54, 254, 32, 9, 189, 48, 9, 157, 56, 9, 76, 247, 14, 188, 32, 9,
	189, 24, 9, 48, 2, 200, 200, 136, 152, 24, 101, 252, 133, 252, 222, 56,
	9, 16, 20, 152, 157, 32, 9, 221, 24, 9, 208, 5, 73, 255, 157, 24,
	9, 189, 48, 9, 157, 56, 9, 76, 247, 14, 188, 32, 9, 189, 24, 9,
	48, 2, 200, 200, 136, 152, 24, 101, 253, 133, 253, 222, 56, 9, 16, 231,
	152, 157, 32, 9, 221, 24, 9, 208, 216, 73, 255, 157, 24, 9, 189, 48,
	9, 157, 56, 9, 76, 247, 14, 189, 32, 9, 24, 101, 252, 133, 252, 222,
	56, 9, 16, 195, 189, 24, 9, 24, 125, 32, 9, 157, 32, 9, 189, 48,
	9, 157, 56, 9, 76, 247, 14, 165, 253, 56, 253, 32, 9, 133, 253, 222,
	56, 9, 16, 163, 189, 24, 9, 24, 125, 32, 9, 157, 32, 9, 189, 48,
	9, 157, 56, 9, 76, 247, 14, 189, 24, 9, 24, 101, 252, 133, 252, 76,
	247, 14, 160, 16, 169, 0, 133, 250, 169, 0, 133, 251, 169, 0, 141, 23,
	8, 138, 240, 63, 177, 250, 240, 2, 16, 1, 202, 169, 17, 24, 101, 250,
	133, 250, 144, 2, 230, 251, 238, 23, 8, 208, 230, 162, 0, 169, 0, 133,
	252, 138, 141, 23, 8, 10, 38, 252, 10, 38, 252, 10, 38, 252, 10, 38,
	252, 109, 23, 8, 144, 2, 230, 252, 24, 105, 0, 133, 250, 165, 252, 105,
	0, 133, 251, 32, 44, 18, 165, 250, 141, 25, 8, 165, 251, 141, 26, 8,
	162, 7, 169, 255, 157, 208, 8, 169, 240, 157, 216, 8, 157, 224, 8, 202,
	16, 240, 169, 3, 141, 15, 210, 141, 31, 210, 141, 47, 210, 141, 63, 210,
	206, 23, 8, 232, 142, 28, 8, 232, 142, 29, 8, 142, 22, 8, 96, 138,
	41, 15, 141, 27, 8, 96, 142, 22, 8, 96, 201, 16, 176, 3, 76, 76,
	16, 201, 32, 144, 136, 201, 48, 176, 3, 76, 133, 18, 201, 64, 144, 223,
	201, 80, 176, 3, 76, 44, 18, 201, 96, 144, 219, 201, 112, 144, 3, 76,
	180, 17, 132, 253, 41, 15, 10, 141, 23, 17, 165, 253, 144, 254, 144, 30,
	144, 56, 144, 89, 144, 96, 144, 26, 144, 28, 144, 30, 144, 32, 144, 34,
	144, 36, 144, 13, 144, 11, 144, 9, 144, 7, 144, 5, 144, 3, 141, 24,
	8, 96, 157, 104, 9, 96, 157, 112, 9, 96, 157, 120, 9, 96, 157, 144,
	9, 96, 157, 128, 9, 96, 157, 136, 9, 96, 41, 112, 74, 74, 157, 16,
	9, 41, 48, 208, 3, 157, 32, 9, 165, 253, 48, 6, 41, 15, 157, 24,
	9, 96, 41, 15, 73, 255, 24, 105, 1, 157, 24, 9, 96, 41, 63, 157,
	48, 9, 157, 56, 9, 96, 41, 128, 10, 42, 157, 96, 9, 165, 253, 41,
	112, 74, 74, 74, 74, 157, 64, 9, 208, 3, 157, 96, 9, 165, 253, 41,
	15, 157, 80, 9, 157, 88, 9, 189, 72, 9, 221, 64, 9, 144, 143, 189,
	64, 9, 240, 2, 233, 1, 157, 72, 9, 96, 132, 250, 134, 251, 160, 25,
	177, 250, 200, 141, 9, 8, 177, 250, 200, 141, 10, 8, 177, 250, 200, 141,
	11, 8, 177, 250, 200, 141, 12, 8, 177, 250, 200, 141, 13, 8, 177, 250,
	141, 27, 8, 165, 250, 73, 128, 48, 1, 232, 141, 172, 18, 142, 173, 18,
	73, 128, 48, 1, 232, 141, 29, 10, 142, 30, 10, 232, 141, 35, 10, 142,
	36, 10, 232, 141, 162, 18, 142, 163, 18, 73, 128, 48, 1, 232, 141, 25,
	8, 141, 215, 9, 141, 79, 16, 141, 148, 16, 142, 26, 8, 142, 221, 9,
	142, 83, 16, 142, 154, 16, 169, 240, 133, 255, 169, 0, 141, 22, 8, 141,
	24, 8, 162, 7, 169, 0, 141, 22, 8, 157, 120, 8, 157, 176, 8, 157,
	32, 8, 157, 40, 8, 157, 48, 8, 157, 48, 210, 157, 32, 210, 157, 16,
	210, 157, 0, 210, 202, 16, 226, 141, 24, 210, 141, 8, 210, 141, 56, 210,
	141, 40, 210, 141, 30, 8, 141, 31, 8, 96, 157, 32, 8, 157, 40, 8,
	157, 48, 8, 157, 176, 8, 96, 152, 157, 208, 8, 41, 240, 157, 216, 8,
	189, 208, 8, 10, 10, 10, 10, 157, 224, 8, 96, 41, 7, 133, 250, 138,
	166, 250, 41, 63, 240, 225, 157, 152, 8, 152, 48, 238, 189, 208, 8, 32,
	117, 18, 169, 0, 157, 120, 8, 185, 255, 255, 240, 190, 157, 136, 8, 133,
	251, 185, 255, 255, 157, 128, 8, 133, 250, 152, 157, 144, 8, 160, 8, 177,
	250, 200, 157, 192, 8, 177, 250, 200, 157, 200, 8, 177, 250, 200, 157, 104,
	9, 177, 250, 200, 157, 112, 9, 177, 250, 200, 157, 120, 9, 177, 250, 200,
	157, 232, 8, 157, 248, 8, 177, 250, 200, 157, 240, 8, 157, 0, 9, 177,
	250, 41, 112, 74, 74, 157, 16, 9, 177, 250, 200, 48, 8, 41, 15, 157,
	24, 9, 76, 9, 19, 41, 15, 73, 255, 24, 105, 1, 157, 24, 9, 177,
	250, 200, 157, 40, 9, 177, 250, 200, 41, 63, 157, 48, 9, 157, 56, 9,
	177, 250, 41, 128, 10, 42, 157, 96, 9, 177, 250, 41, 112, 74, 74, 74,
	74, 157, 64, 9, 208, 3, 157, 96, 9, 177, 250, 136, 41, 15, 157, 80,
	9, 157, 88, 9, 177, 250, 41, 192, 29, 152, 8, 157, 152, 8, 168, 185,
	0, 6, 157, 56, 8, 169, 0, 157, 184, 8, 157, 32, 9, 157, 8, 9,
	157, 72, 9, 157, 128, 9, 157, 136, 9, 157, 144, 9, 169, 1, 157, 120,
	8, 96 };
static const unsigned char CiBinaryResource_tmc_obx[2671] = { 255, 255, 0, 5, 104, 15, 76, 206, 13, 76, 208, 8, 76, 239, 9, 15,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1,
	1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2,
	2, 2, 0, 0, 0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3,
	3, 3, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3,
	4, 4, 0, 0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4,
	5, 5, 0, 0, 1, 1, 2, 2, 2, 3, 3, 4, 4, 4, 5, 5,
	6, 6, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6,
	7, 7, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7,
	7, 8, 0, 1, 1, 2, 2, 3, 4, 4, 5, 5, 6, 7, 7, 8,
	8, 9, 0, 1, 1, 2, 3, 3, 4, 5, 5, 6, 7, 7, 8, 9,
	9, 10, 0, 1, 1, 2, 3, 4, 4, 5, 6, 7, 7, 8, 9, 10,
	10, 11, 0, 1, 2, 2, 3, 4, 5, 6, 6, 7, 8, 9, 10, 10,
	11, 12, 0, 1, 2, 3, 3, 4, 5, 6, 7, 8, 9, 10, 10, 11,
	12, 13, 0, 1, 2, 3, 4, 5, 6, 7, 7, 8, 9, 10, 11, 12,
	13, 14, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13,
	14, 15, 0, 241, 228, 215, 203, 192, 181, 170, 161, 152, 143, 135, 127, 120,
	114, 107, 101, 95, 90, 85, 80, 75, 71, 67, 63, 60, 56, 53, 50, 47,
	44, 42, 39, 37, 35, 33, 31, 29, 28, 26, 24, 23, 22, 20, 19, 18,
	17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2,
	1, 0, 0, 242, 230, 218, 206, 191, 182, 170, 161, 152, 143, 137, 128, 122,
	113, 107, 101, 95, 92, 86, 80, 77, 71, 68, 62, 60, 56, 53, 50, 47,
	45, 42, 40, 37, 35, 33, 31, 29, 28, 26, 24, 23, 22, 20, 19, 18,
	17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2,
	1, 0, 0, 255, 241, 228, 216, 202, 192, 181, 171, 162, 153, 142, 135, 127,
	121, 115, 112, 102, 97, 90, 85, 82, 75, 72, 67, 63, 60, 57, 55, 51,
	48, 45, 42, 40, 37, 36, 33, 31, 30, 28, 27, 25, 23, 22, 21, 19,
	18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3,
	2, 1, 0, 243, 230, 217, 204, 193, 181, 173, 162, 153, 144, 136, 128, 121,
	114, 108, 102, 96, 91, 85, 81, 76, 72, 68, 64, 60, 57, 53, 50, 47,
	45, 42, 40, 37, 35, 33, 31, 29, 28, 26, 24, 23, 22, 20, 19, 18,
	17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2,
	1, 0, 0, 242, 51, 150, 226, 56, 140, 0, 106, 232, 106, 239, 128, 8,
	174, 70, 230, 149, 65, 246, 176, 110, 48, 246, 187, 132, 82, 34, 244, 200,
	160, 122, 85, 52, 20, 245, 216, 189, 164, 141, 119, 96, 78, 56, 39, 21,
	6, 247, 232, 219, 207, 195, 184, 172, 162, 154, 144, 136, 127, 120, 112, 106,
	100, 94, 0, 13, 13, 12, 11, 11, 10, 10, 9, 8, 8, 7, 7, 7,
	6, 6, 5, 5, 5, 4, 4, 4, 4, 3, 3, 3, 3, 3, 2, 2,
	2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 5,
	6, 7, 0, 1, 2, 3, 4, 2, 0, 0, 4, 2, 0, 0, 0, 16,
	0, 8, 0, 16, 0, 8, 173, 183, 8, 240, 94, 173, 182, 8, 201, 64,
	144, 90, 206, 181, 8, 240, 3, 76, 239, 9, 162, 7, 169, 0, 157, 196,
	7, 157, 204, 7, 202, 16, 247, 141, 182, 8, 170, 160, 15, 177, 254, 16,
	32, 136, 177, 254, 16, 3, 76, 95, 14, 134, 252, 10, 10, 38, 252, 10,
	38, 252, 10, 38, 252, 105, 0, 133, 254, 165, 252, 105, 0, 133, 255, 144,
	218, 157, 212, 7, 136, 177, 254, 157, 220, 7, 232, 136, 16, 207, 24, 165,
	254, 105, 16, 133, 254, 144, 2, 230, 255, 76, 239, 9, 206, 181, 8, 16,
	248, 238, 182, 8, 173, 180, 8, 141, 181, 8, 162, 7, 222, 204, 7, 48,
	3, 76, 233, 9, 188, 212, 7, 185, 255, 255, 133, 252, 185, 255, 255, 133,
	253, 188, 196, 7, 177, 252, 208, 6, 32, 109, 13, 76, 230, 9, 201, 64,
	176, 18, 125, 220, 7, 157, 228, 7, 32, 109, 13, 188, 42, 5, 32, 188,
	14, 76, 230, 9, 208, 34, 200, 254, 196, 7, 177, 252, 16, 7, 133, 251,
	32, 109, 13, 165, 251, 41, 127, 208, 7, 169, 64, 141, 182, 8, 208, 76,
	141, 180, 8, 141, 181, 8, 208, 68, 201, 128, 176, 43, 41, 63, 125, 220,
	7, 157, 228, 7, 200, 254, 196, 7, 177, 252, 41, 127, 208, 7, 169, 64,
	141, 182, 8, 208, 6, 141, 180, 8, 141, 181, 8, 32, 109, 13, 188, 42,
	5, 32, 188, 14, 76, 230, 9, 201, 192, 176, 12, 41, 63, 157, 42, 5,
	200, 254, 196, 7, 76, 94, 9, 41, 63, 157, 204, 7, 254, 196, 7, 202,
	48, 3, 76, 70, 9, 162, 7, 189, 188, 7, 240, 33, 32, 46, 11, 189,
	50, 5, 61, 192, 8, 240, 22, 160, 71, 177, 252, 24, 125, 34, 5, 157,
	36, 5, 168, 185, 60, 6, 56, 125, 100, 8, 157, 246, 7, 202, 16, 215,
	14, 9, 5, 14, 9, 5, 14, 9, 5, 14, 9, 5, 232, 134, 252, 134,
	253, 162, 7, 138, 168, 185, 252, 7, 208, 12, 188, 184, 8, 185, 4, 8,
	208, 4, 138, 168, 169, 0, 133, 250, 152, 157, 26, 5, 185, 244, 7, 157,
	18, 5, 185, 50, 5, 133, 251, 5, 253, 133, 253, 165, 251, 61, 192, 8,
	240, 6, 185, 246, 7, 157, 20, 5, 165, 251, 61, 200, 8, 240, 18, 185,
	34, 5, 41, 63, 168, 200, 132, 252, 185, 123, 7, 157, 18, 5, 76, 137,
	10, 164, 252, 240, 10, 185, 59, 7, 157, 18, 5, 169, 0, 133, 252, 165,
	250, 13, 9, 5, 168, 185, 60, 5, 188, 26, 5, 25, 236, 7, 157, 10,
	5, 224, 4, 208, 9, 165, 253, 141, 59, 5, 169, 0, 133, 253, 202, 16,
	130, 78, 9, 5, 78, 9, 5, 78, 9, 5, 78, 9, 5, 165, 253, 162,
	3, 142, 31, 210, 142, 15, 210, 174, 22, 5, 172, 18, 5, 142, 16, 210,
	140, 0, 210, 174, 14, 5, 172, 10, 5, 142, 17, 210, 140, 1, 210, 174,
	23, 5, 172, 19, 5, 142, 18, 210, 140, 2, 210, 174, 15, 5, 172, 11,
	5, 142, 19, 210, 140, 3, 210, 174, 24, 5, 172, 20, 5, 142, 20, 210,
	140, 4, 210, 174, 16, 5, 172, 12, 5, 142, 21, 210, 140, 5, 210, 174,
	25, 5, 172, 21, 5, 142, 22, 210, 140, 6, 210, 174, 17, 5, 172, 13,
	5, 142, 23, 210, 140, 7, 210, 141, 58, 5, 174, 59, 5, 142, 24, 210,
	141, 8, 210, 96, 189, 28, 8, 133, 252, 189, 36, 8, 133, 253, 188, 44,
	8, 192, 63, 240, 123, 254, 44, 8, 254, 44, 8, 254, 44, 8, 177, 252,
	41, 240, 157, 236, 7, 177, 252, 41, 15, 56, 253, 12, 8, 16, 2, 169,
	0, 157, 252, 7, 200, 177, 252, 41, 15, 56, 253, 20, 8, 16, 2, 169,
	0, 157, 4, 8, 177, 252, 41, 240, 240, 116, 16, 11, 160, 73, 177, 252,
	188, 44, 8, 136, 136, 16, 2, 169, 0, 157, 50, 5, 177, 252, 41, 112,
	240, 99, 74, 74, 141, 154, 11, 169, 0, 157, 100, 8, 200, 177, 252, 144,
	254, 234, 234, 234, 234, 76, 56, 13, 234, 76, 53, 13, 234, 76, 60, 13,
	234, 76, 74, 13, 234, 76, 84, 13, 234, 76, 95, 13, 234, 76, 81, 13,
	189, 52, 8, 240, 18, 222, 68, 8, 208, 13, 157, 68, 8, 189, 252, 7,
	41, 15, 240, 3, 222, 252, 7, 189, 60, 8, 240, 18, 222, 76, 8, 208,
	13, 157, 76, 8, 189, 4, 8, 41, 15, 240, 3, 222, 4, 8, 160, 72,
	177, 252, 157, 50, 5, 189, 148, 8, 24, 105, 63, 168, 177, 252, 125, 228,
	7, 157, 34, 5, 168, 185, 60, 6, 157, 244, 7, 222, 164, 8, 16, 51,
	189, 156, 8, 157, 164, 8, 189, 172, 8, 240, 24, 24, 125, 148, 8, 157,
	148, 8, 240, 7, 221, 140, 8, 208, 26, 169, 254, 24, 105, 1, 157, 172,
	8, 208, 16, 254, 148, 8, 189, 140, 8, 221, 148, 8, 176, 5, 169, 0,
	157, 148, 8, 189, 116, 8, 240, 4, 222, 116, 8, 96, 189, 108, 8, 133,
	250, 189, 92, 8, 133, 251, 32, 105, 12, 222, 132, 8, 16, 16, 165, 250,
	157, 108, 8, 165, 251, 157, 92, 8, 189, 124, 8, 157, 132, 8, 96, 189,
	84, 8, 141, 112, 12, 16, 254, 76, 167, 12, 234, 76, 144, 12, 234, 76,
	174, 12, 234, 76, 180, 12, 234, 76, 190, 12, 234, 76, 210, 12, 234, 76,
	226, 12, 234, 76, 244, 12, 165, 250, 230, 250, 41, 3, 74, 144, 15, 208,
	71, 165, 251, 157, 100, 8, 24, 125, 244, 7, 157, 244, 7, 96, 169, 0,
	157, 100, 8, 96, 32, 29, 13, 76, 157, 12, 32, 29, 13, 24, 125, 34,
	5, 76, 84, 13, 165, 250, 157, 100, 8, 24, 125, 244, 7, 157, 244, 7,
	165, 250, 24, 101, 251, 133, 250, 96, 189, 34, 5, 56, 229, 250, 157, 34,
	5, 168, 185, 60, 6, 76, 199, 12, 189, 244, 7, 56, 229, 251, 157, 244,
	7, 56, 169, 0, 229, 251, 157, 100, 8, 96, 189, 132, 8, 208, 174, 165,
	251, 16, 16, 189, 4, 8, 240, 165, 189, 252, 7, 201, 15, 240, 158, 254,
	252, 7, 96, 189, 252, 7, 240, 149, 189, 4, 8, 201, 15, 240, 142, 254,
	4, 8, 96, 164, 250, 165, 251, 48, 2, 200, 200, 136, 152, 133, 250, 197,
	251, 208, 6, 165, 251, 73, 255, 133, 251, 152, 96, 125, 244, 7, 157, 244,
	7, 96, 188, 228, 7, 121, 60, 6, 157, 244, 7, 152, 157, 34, 5, 96,
	45, 10, 210, 157, 244, 7, 96, 125, 228, 7, 157, 34, 5, 168, 185, 60,
	6, 157, 244, 7, 96, 157, 34, 5, 168, 189, 244, 7, 121, 60, 6, 157,
	244, 7, 96, 200, 254, 196, 7, 177, 252, 74, 74, 74, 74, 157, 12, 8,
	177, 252, 41, 15, 157, 20, 8, 96, 32, 95, 14, 160, 15, 169, 0, 133,
	254, 169, 0, 133, 255, 138, 240, 46, 177, 254, 16, 1, 202, 24, 165, 254,
	105, 16, 133, 254, 144, 239, 230, 255, 176, 235, 32, 95, 14, 169, 0, 133,
	252, 138, 10, 10, 38, 252, 10, 38, 252, 10, 38, 252, 105, 0, 133, 254,
	165, 252, 105, 0, 133, 255, 169, 64, 141, 182, 8, 169, 1, 141, 181, 8,
	141, 183, 8, 96, 201, 16, 144, 176, 201, 32, 144, 206, 201, 48, 176, 3,
	76, 174, 14, 201, 64, 176, 9, 138, 41, 15, 240, 3, 141, 180, 8, 96,
	201, 80, 144, 113, 201, 96, 176, 6, 169, 0, 141, 183, 8, 96, 201, 112,
	144, 248, 169, 1, 141, 181, 8, 169, 64, 141, 182, 8, 132, 252, 134, 253,
	160, 30, 177, 252, 141, 180, 8, 165, 252, 24, 105, 32, 141, 194, 14, 144,
	1, 232, 142, 195, 14, 24, 105, 64, 141, 202, 14, 144, 1, 232, 142, 203,
	14, 24, 105, 64, 141, 82, 9, 144, 1, 232, 142, 83, 9, 24, 105, 128,
	141, 87, 9, 144, 1, 232, 142, 88, 9, 24, 105, 128, 133, 254, 141, 16,
	9, 141, 136, 13, 141, 183, 13, 144, 1, 232, 134, 255, 142, 22, 9, 142,
	140, 13, 142, 189, 13, 160, 7, 169, 0, 141, 183, 8, 153, 0, 210, 153,
	16, 210, 153, 10, 5, 153, 252, 7, 153, 4, 8, 153, 50, 5, 153, 188,
	7, 136, 16, 232, 141, 8, 210, 141, 24, 210, 141, 58, 5, 141, 59, 5,
	96, 157, 252, 7, 157, 4, 8, 157, 50, 5, 189, 228, 7, 157, 34, 5,
	96, 152, 73, 240, 74, 74, 74, 74, 157, 12, 8, 152, 41, 15, 73, 15,
	157, 20, 8, 96, 41, 7, 133, 252, 138, 166, 252, 41, 63, 240, 226, 157,
	228, 7, 169, 0, 157, 188, 7, 185, 255, 255, 157, 28, 8, 133, 252, 185,
	255, 255, 157, 36, 8, 133, 253, 5, 252, 240, 182, 160, 74, 177, 252, 157,
	52, 8, 157, 68, 8, 200, 177, 252, 157, 60, 8, 157, 76, 8, 200, 177,
	252, 41, 112, 74, 74, 157, 84, 8, 177, 252, 41, 15, 157, 92, 8, 177,
	252, 16, 11, 189, 92, 8, 73, 255, 24, 105, 1, 157, 92, 8, 200, 177,
	252, 157, 116, 8, 200, 177, 252, 41, 63, 157, 124, 8, 157, 132, 8, 200,
	177, 252, 41, 128, 240, 2, 169, 1, 157, 172, 8, 177, 252, 41, 112, 74,
	74, 74, 74, 157, 140, 8, 208, 3, 157, 172, 8, 177, 252, 41, 15, 157,
	156, 8, 157, 164, 8, 136, 177, 252, 41, 192, 24, 125, 228, 7, 157, 228,
	7, 157, 34, 5, 168, 185, 60, 6, 157, 244, 7, 169, 0, 157, 44, 8,
	157, 100, 8, 157, 108, 8, 157, 148, 8, 169, 1, 157, 188, 7, 96 };

static int ASAPWriter_FormatXexInfoText(unsigned char *dest, int destLen, int endColumn, const char *src, cibool author);
static int ASAPWriter_PadXexInfo(unsigned char *dest, int offset, int endColumn);
static cibool ASAPWriter_SecondsToString(unsigned char *result, int offset, int value);
static void ASAPWriter_TwoDigitsToString(unsigned char *result, int offset, int value);
static void ASAPWriter_WriteBytes(ByteWriter w, unsigned char const *array, int startIndex, int endIndex);
static void ASAPWriter_WriteCmcInit(ByteWriter w, int *initAndPlayer, ASAPInfo const *info);
static void ASAPWriter_WriteDec(ByteWriter w, int value);
static void ASAPWriter_WriteDecSapTag(ByteWriter w, const char *tag, int value);
static cibool ASAPWriter_WriteExecutable(ByteWriter w, int *initAndPlayer, ASAPInfo const *info, unsigned char const *module, int moduleLen);
static void ASAPWriter_WriteExecutableFromSap(ByteWriter w, int *initAndPlayer, ASAPInfo const *info, int type, unsigned char const *module, int moduleLen);
static void ASAPWriter_WriteExecutableHeader(ByteWriter w, int *initAndPlayer, ASAPInfo const *info, int type, int init, int player);
static int ASAPWriter_WriteExecutableHeaderForSongPos(ByteWriter w, int *initAndPlayer, ASAPInfo const *info, int player, int codeForOneSong, int codeForManySongs, int playerOffset);
static void ASAPWriter_WriteHexSapTag(ByteWriter w, const char *tag, int value);
static cibool ASAPWriter_WriteNative(ByteWriter w, ASAPInfo const *info, unsigned char const *module, int moduleLen);
static int ASAPWriter_WriteNativeHeader(ByteWriter w, ASAPInfo const *info, unsigned char const *module);
static void ASAPWriter_WritePlaTaxLda0(ByteWriter w);
static void ASAPWriter_WriteRelocatedBytes(ByteWriter w, int diff, unsigned char const *module, int lowOffset, int highOffset, int len, int shift);
static void ASAPWriter_WriteRelocatedLowHigh(ByteWriter w, int diff, unsigned char const *module, int lowOffset, int len);
static void ASAPWriter_WriteRelocatedWords(ByteWriter w, int diff, unsigned char const *module, int offset, int len);
static void ASAPWriter_WriteSapHeader(ByteWriter w, ASAPInfo const *info, int type, int init, int player);
static void ASAPWriter_WriteString(ByteWriter w, const char *s);
static void ASAPWriter_WriteTextSapTag(ByteWriter w, const char *tag, const char *value);
static void ASAPWriter_WriteWord(ByteWriter w, int value);
static void ASAPWriter_WriteXexInfo(ByteWriter w, ASAPInfo const *info);
static void ASAPWriter_WriteXexInfoTextDl(ByteWriter w, int address, int len, int verticalScrollAt);
static const unsigned char CiBinaryResource_xexb_obx[183] = { 255, 255, 36, 1, 223, 1, 120, 160, 0, 140, 14, 212, 173, 11, 212, 208,
	251, 141, 0, 212, 162, 29, 157, 0, 208, 202, 16, 250, 162, 8, 157, 16,
	210, 157, 0, 210, 202, 16, 247, 169, 3, 141, 31, 210, 141, 0, 210, 169,
	130, 205, 11, 212, 208, 251, 141, 10, 212, 141, 10, 212, 141, 10, 212, 173,
	11, 212, 208, 3, 238, 145, 1, 173, 218, 1, 32, 212, 1, 169, 254, 141,
	1, 211, 169, 206, 174, 53, 1, 240, 2, 169, 194, 141, 250, 255, 169, 1,
	141, 251, 255, 169, 64, 141, 14, 212, 169, 125, 205, 11, 212, 208, 251, 32,
	215, 1, 162, 0, 173, 219, 1, 74, 144, 6, 169, 0, 238, 153, 1, 74,
	189, 220, 1, 105, 125, 176, 5, 221, 210, 1, 144, 4, 253, 210, 1, 56,
	141, 162, 1, 189, 222, 1, 105, 0, 141, 181, 1, 201, 0, 208, 252, 173,
	162, 1, 176, 198, 72, 138, 72, 174, 145, 1, 32, 152, 252, 104, 170, 104,
	238, 186, 1, 64, 156, 131, 76 };
static const unsigned char CiBinaryResource_xexd_obx[117] = { 255, 255, 36, 1, 152, 1, 120, 160, 0, 140, 14, 212, 173, 11, 212, 208,
	251, 141, 0, 212, 162, 29, 157, 0, 208, 202, 16, 250, 141, 14, 210, 162,
	8, 157, 16, 210, 157, 0, 210, 202, 16, 247, 169, 3, 141, 31, 210, 141,
	0, 210, 169, 254, 141, 1, 211, 173, 149, 1, 201, 96, 240, 15, 169, 114,
	141, 250, 255, 169, 1, 141, 251, 255, 169, 64, 141, 14, 212, 173, 152, 1,
	88, 76, 146, 1, 40, 8, 72, 138, 72, 152, 72, 32, 149, 1, 174, 53,
	1, 240, 11, 174, 20, 208, 202, 240, 2, 162, 1, 32, 152, 252, 104, 168,
	104, 170, 104, 64, 76 };
static const unsigned char CiBinaryResource_xexinfo_obx[178] = { 255, 255, 112, 252, 221, 252, 65, 80, 252, 173, 11, 212, 208, 251, 141, 5,
	212, 162, 38, 142, 22, 208, 162, 10, 142, 23, 208, 162, 33, 142, 0, 212,
	162, 80, 142, 2, 212, 162, 252, 142, 3, 212, 142, 9, 212, 96, 216, 189,
	218, 252, 24, 105, 0, 141, 158, 252, 189, 220, 252, 105, 0, 141, 166, 252,
	144, 18, 173, 75, 252, 13, 76, 252, 13, 78, 252, 13, 79, 252, 201, 49,
	162, 4, 176, 13, 96, 169, 57, 224, 3, 208, 2, 169, 53, 157, 75, 252,
	202, 189, 75, 252, 201, 49, 144, 237, 201, 58, 240, 244, 222, 75, 252, 96,
	34, 69, 5, 4, 0, 1, 57, 1, 120, 160, 0, 140, 14, 212, 173, 11,
	212, 208, 251, 141, 0, 212, 162, 29, 157, 0, 208, 202, 16, 250, 142, 1,
	211, 185, 0, 224, 72, 185, 0, 225, 72, 185, 0, 227, 202, 142, 1, 211,
	232, 153, 0, 255, 104, 153, 0, 254, 104, 153, 0, 253, 200, 208, 223, 32,
	115, 252 };

struct FlashPackItem {
	FlashPackItemType type;
	int value;
};
static int FlashPackItem_WriteValueTo(FlashPackItem const *self, unsigned char *buffer, int index);

struct FlashPack {
	int compressedLength;
	int itemsCount;
	int loadAddress;
	int loadEndAddress;
	FlashPackLoadState loadState;
	FlashPackItem items[64];
	unsigned char compressed[65536];
	int memory[65536];
};
static void FlashPack_Construct(FlashPack *self);
static cibool FlashPack_Compress(FlashPack *self, ByteWriter w);
static void FlashPack_CompressMemoryArea(FlashPack *self, int startAddress, int endAddress);
static int FlashPack_FindHole(FlashPack const *self);
static int FlashPack_GetInnerFlags(FlashPack const *self, int index);
static cibool FlashPack_IsLiteralPreferred(FlashPack const *self);
static void FlashPack_LoadByte(FlashPack *self, int data);
static void FlashPack_PutItem(FlashPack *self, FlashPackItemType type, int value);
static void FlashPack_PutItems(FlashPack *self);
static void FlashPack_PutPoke(FlashPack *self, int address, int value);

static void ASAP_Construct(ASAP *self)
{
	PokeyPair_Construct(&self->pokeys);
	self->silenceCycles = 0;
}

ASAP *ASAP_New(void)
{
	ASAP *self = (ASAP *) malloc(sizeof(ASAP));
	if (self != NULL)
		ASAP_Construct(self);
	return self;
}

void ASAP_Delete(ASAP *self)
{
	free(self);
}

static void ASAP_Call6502(ASAP *self, int addr)
{
	self->memory[53760] = 32;
	self->memory[53761] = (unsigned char) addr;
	self->memory[53762] = addr >> 8;
	self->memory[53763] = 210;
	self->cpu.pc = 53760;
}

static void ASAP_Call6502Player(ASAP *self)
{
	int player = self->moduleInfo.player;
	switch (self->moduleInfo.type) {
		int i;
	case ASAPModuleType_SAP_B:
		ASAP_Call6502(self, player);
		break;
	case ASAPModuleType_SAP_C:
	case ASAPModuleType_CMC:
	case ASAPModuleType_CM3:
	case ASAPModuleType_CMR:
	case ASAPModuleType_CMS:
		ASAP_Call6502(self, player + 6);
		break;
	case ASAPModuleType_SAP_D:
		if (player >= 0) {
			int s = self->cpu.s;
			self->memory[256 + s] = self->cpu.pc >> 8;
			s = (s - 1) & 255;
			self->memory[256 + s] = (unsigned char) self->cpu.pc;
			self->cpu.s = (s - 1) & 255;
			self->memory[53760] = 8;
			self->memory[53761] = 72;
			self->memory[53762] = 138;
			self->memory[53763] = 72;
			self->memory[53764] = 152;
			self->memory[53765] = 72;
			self->memory[53766] = 32;
			self->memory[53767] = (unsigned char) player;
			self->memory[53768] = player >> 8;
			self->memory[53769] = 104;
			self->memory[53770] = 168;
			self->memory[53771] = 104;
			self->memory[53772] = 170;
			self->memory[53773] = 104;
			self->memory[53774] = 64;
			self->cpu.pc = 53760;
		}
		break;
	case ASAPModuleType_SAP_S:
		i = self->memory[69] - 1;
		self->memory[69] = (unsigned char) i;
		if (i == 0)
			self->memory[45179] = (unsigned char) (self->memory[45179] + 1);
		break;
	case ASAPModuleType_DLT:
		ASAP_Call6502(self, player + 259);
		break;
	case ASAPModuleType_MPT:
	case ASAPModuleType_RMT:
	case ASAPModuleType_TM2:
	case ASAPModuleType_FC:
		ASAP_Call6502(self, player + 3);
		break;
	case ASAPModuleType_TMC:
		if (--self->tmcPerFrameCounter <= 0) {
			self->tmcPerFrameCounter = self->memory[self->moduleInfo.music + 31];
			ASAP_Call6502(self, player + 3);
		}
		else
			ASAP_Call6502(self, player + 6);
		break;
	}
}

void ASAP_DetectSilence(ASAP *self, int seconds)
{
	self->silenceCyclesCounter = self->silenceCycles = seconds * 1773447;
}

static int ASAP_Do6502Frame(ASAP *self)
{
	int cycles;
	self->nextEventCycle = 0;
	self->nextScanlineCycle = 0;
	self->nmist = self->nmist == NmiStatus_RESET ? NmiStatus_ON_V_BLANK : NmiStatus_WAS_V_BLANK;
	cycles = self->moduleInfo.ntsc ? 29868 : 35568;
	Cpu6502_DoFrame(&self->cpu, self, cycles);
	self->cycle -= cycles;
	if (self->nextPlayerCycle != 8388608)
		self->nextPlayerCycle -= cycles;
	if (self->pokeys.timer1Cycle != 8388608)
		self->pokeys.timer1Cycle -= cycles;
	if (self->pokeys.timer2Cycle != 8388608)
		self->pokeys.timer2Cycle -= cycles;
	if (self->pokeys.timer4Cycle != 8388608)
		self->pokeys.timer4Cycle -= cycles;
	return cycles;
}

static cibool ASAP_Do6502Init(ASAP *self, int pc, int a, int x, int y)
{
	self->cpu.pc = pc;
	self->cpu.a = a & 255;
	self->cpu.x = x & 255;
	self->cpu.y = y & 255;
	self->memory[53760] = 210;
	self->memory[510] = 255;
	self->memory[511] = 209;
	self->cpu.s = 253;
	{
		int frame;
		for (frame = 0; frame < 50; frame++) {
			ASAP_Do6502Frame(self);
			if (self->cpu.pc == 53760)
				return TRUE;
		}
	}
	return FALSE;
}

static int ASAP_DoFrame(ASAP *self)
{
	int cycles;
	PokeyPair_StartFrame(&self->pokeys);
	cycles = ASAP_Do6502Frame(self);
	PokeyPair_EndFrame(&self->pokeys, cycles);
	return cycles;
}

int ASAP_Generate(ASAP *self, unsigned char *buffer, int bufferLen, ASAPSampleFormat format)
{
	return ASAP_GenerateAt(self, buffer, 0, bufferLen, format);
}

static int ASAP_GenerateAt(ASAP *self, unsigned char *buffer, int bufferOffset, int bufferLen, ASAPSampleFormat format)
{
	int blockShift;
	int bufferBlocks;
	int block;
	if (self->silenceCycles > 0 && self->silenceCyclesCounter <= 0)
		return 0;
	blockShift = self->moduleInfo.channels - 1 + (format != ASAPSampleFormat_U8 ? 1 : 0);
	bufferBlocks = bufferLen >> blockShift;
	if (self->currentDuration > 0) {
		int totalBlocks = ASAP_MillisecondsToBlocks(self->currentDuration);
		if (bufferBlocks > totalBlocks - self->blocksPlayed)
			bufferBlocks = totalBlocks - self->blocksPlayed;
	}
	block = 0;
	for (;;) {
		int blocks = PokeyPair_Generate(&self->pokeys, buffer, bufferOffset + (block << blockShift), bufferBlocks - block, format);
		int cycles;
		self->blocksPlayed += blocks;
		block += blocks;
		if (block >= bufferBlocks)
			break;
		cycles = ASAP_DoFrame(self);
		if (self->silenceCycles > 0) {
			if (PokeyPair_IsSilent(&self->pokeys)) {
				self->silenceCyclesCounter -= cycles;
				if (self->silenceCyclesCounter <= 0)
					break;
			}
			else
				self->silenceCyclesCounter = self->silenceCycles;
		}
	}
	return block << blockShift;
}

int ASAP_GetBlocksPlayed(ASAP const *self)
{
	return self->blocksPlayed;
}

ASAPInfo const *ASAP_GetInfo(ASAP const *self)
{
	return &self->moduleInfo;
}

int ASAP_GetPokeyChannelVolume(ASAP const *self, int channel)
{
	switch (channel) {
	case 0:
		return self->pokeys.basePokey.audc1 & 15;
	case 1:
		return self->pokeys.basePokey.audc2 & 15;
	case 2:
		return self->pokeys.basePokey.audc3 & 15;
	case 3:
		return self->pokeys.basePokey.audc4 & 15;
	case 4:
		return self->pokeys.extraPokey.audc1 & 15;
	case 5:
		return self->pokeys.extraPokey.audc2 & 15;
	case 6:
		return self->pokeys.extraPokey.audc3 & 15;
	case 7:
		return self->pokeys.extraPokey.audc4 & 15;
	default:
		return 0;
	}
}

int ASAP_GetPosition(ASAP const *self)
{
	return self->blocksPlayed * 10 / 441;
}

int ASAP_GetWavHeader(ASAP const *self, unsigned char *buffer, ASAPSampleFormat format, cibool metadata)
{
	int use16bit = format != ASAPSampleFormat_U8 ? 1 : 0;
	int blockSize = self->moduleInfo.channels << use16bit;
	int bytesPerSecond = 44100 * blockSize;
	int totalBlocks = ASAP_MillisecondsToBlocks(self->currentDuration);
	int nBytes = (totalBlocks - self->blocksPlayed) * blockSize;
	int i;
	ASAP_PutLittleEndian(buffer, 8, 1163280727);
	ASAP_PutLittleEndians(buffer, 12, 544501094, 16);
	buffer[20] = 1;
	buffer[21] = 0;
	buffer[22] = self->moduleInfo.channels;
	buffer[23] = 0;
	ASAP_PutLittleEndians(buffer, 24, 44100, bytesPerSecond);
	buffer[32] = blockSize;
	buffer[33] = 0;
	buffer[34] = 8 << use16bit;
	buffer[35] = 0;
	i = 36;
	if (metadata) {
		int year = ASAPInfo_GetYear(&self->moduleInfo);
		if (self->moduleInfo.title[0] != '\0' || self->moduleInfo.author[0] != '\0' || year > 0) {
			ASAP_PutLittleEndian(buffer, 44, 1330007625);
			i = ASAP_PutWavMetadata(buffer, 48, 1296125513, self->moduleInfo.title);
			i = ASAP_PutWavMetadata(buffer, i, 1414676809, self->moduleInfo.author);
			if (year > 0) {
				ASAP_PutLittleEndians(buffer, i, 1146241865, 6);
				{
					int j;
					for (j = 3; j >= 0; j--) {
						buffer[i + 8 + j] = 48 + year % 10;
						year /= 10;
					}
				}
				buffer[i + 12] = 0;
				buffer[i + 13] = 0;
				i += 14;
			}
			ASAP_PutLittleEndians(buffer, 36, 1414744396, i - 44);
		}
	}
	ASAP_PutLittleEndians(buffer, 0, 1179011410, i + nBytes);
	ASAP_PutLittleEndians(buffer, i, 1635017060, nBytes);
	return i + 8;
}

static void ASAP_HandleEvent(ASAP *self)
{
	int cycle = self->cycle;
	int nextEventCycle;
	if (cycle >= self->nextScanlineCycle) {
		if (cycle - self->nextScanlineCycle < 50)
			self->cycle = cycle += 9;
		self->nextScanlineCycle += 114;
		if (cycle >= self->nextPlayerCycle) {
			ASAP_Call6502Player(self);
			self->nextPlayerCycle += 114 * self->moduleInfo.fastplay;
		}
	}
	nextEventCycle = self->nextScanlineCycle;
	if (cycle >= self->pokeys.timer1Cycle) {
		self->pokeys.irqst &= ~1;
		self->pokeys.timer1Cycle = 8388608;
	}
	else if (nextEventCycle > self->pokeys.timer1Cycle)
		nextEventCycle = self->pokeys.timer1Cycle;
	if (cycle >= self->pokeys.timer2Cycle) {
		self->pokeys.irqst &= ~2;
		self->pokeys.timer2Cycle = 8388608;
	}
	else if (nextEventCycle > self->pokeys.timer2Cycle)
		nextEventCycle = self->pokeys.timer2Cycle;
	if (cycle >= self->pokeys.timer4Cycle) {
		self->pokeys.irqst &= ~4;
		self->pokeys.timer4Cycle = 8388608;
	}
	else if (nextEventCycle > self->pokeys.timer4Cycle)
		nextEventCycle = self->pokeys.timer4Cycle;
	self->nextEventCycle = nextEventCycle;
}

cibool ASAP_Load(ASAP *self, const char *filename, unsigned char const *module, int moduleLen)
{
	unsigned char const *playerRoutine;
	int moduleIndex;
	if (!ASAPInfo_Load(&self->moduleInfo, filename, module, moduleLen))
		return FALSE;
	playerRoutine = ASAP6502_GetPlayerRoutine(&self->moduleInfo);
	if (playerRoutine != NULL) {
		int player = ASAPInfo_GetWord(playerRoutine, 2);
		int playerLastByte = ASAPInfo_GetWord(playerRoutine, 4);
		if (self->moduleInfo.music <= playerLastByte)
			return FALSE;
		self->memory[19456] = 0;
		if (self->moduleInfo.type == ASAPModuleType_FC)
			memcpy(self->memory + self->moduleInfo.music, module + 0, moduleLen);
		else
			memcpy(self->memory + self->moduleInfo.music, module + 6, moduleLen - 6);
		memcpy(self->memory + player, playerRoutine + 6, playerLastByte + 1 - player);
		if (self->moduleInfo.player < 0)
			self->moduleInfo.player = player;
		return TRUE;
	}
	memset(self->memory, 0, sizeof(self->memory));
	moduleIndex = self->moduleInfo.headerLen + 2;
	while (moduleIndex + 5 <= moduleLen) {
		int startAddr = ASAPInfo_GetWord(module, moduleIndex);
		int blockLen = ASAPInfo_GetWord(module, moduleIndex + 2) + 1 - startAddr;
		if (blockLen <= 0 || moduleIndex + blockLen > moduleLen)
			return FALSE;
		moduleIndex += 4;
		memcpy(self->memory + startAddr, module + moduleIndex, blockLen);
		moduleIndex += blockLen;
		if (moduleIndex == moduleLen)
			return TRUE;
		if (moduleIndex + 7 <= moduleLen && module[moduleIndex] == 255 && module[moduleIndex + 1] == 255)
			moduleIndex += 2;
	}
	return FALSE;
}

static int ASAP_MillisecondsToBlocks(int milliseconds)
{
	return milliseconds * 441 / 10;
}

void ASAP_MutePokeyChannels(ASAP *self, int mask)
{
	Pokey_Mute(&self->pokeys.basePokey, mask);
	Pokey_Mute(&self->pokeys.extraPokey, mask >> 4);
}

static int ASAP_PeekHardware(ASAP const *self, int addr)
{
	switch (addr & 65311) {
	case 53268:
		return self->moduleInfo.ntsc ? 15 : 1;
	case 53279:
		return ~self->consol & 15;
	case 53770:
	case 53786:
		return PokeyPair_GetRandom(&self->pokeys, addr, self->cycle);
	case 53774:
		return self->pokeys.irqst;
	case 53790:
		if (self->pokeys.extraPokeyMask != 0) {
			return 255;
		}
		return self->pokeys.irqst;
	case 53772:
	case 53788:
	case 53775:
	case 53791:
		return 255;
	case 54283:
	case 54299:
		if (self->cycle > (self->moduleInfo.ntsc ? 29868 : 35568))
			return 0;
		return self->cycle / 228;
	case 54287:
	case 54303:
		switch (self->nmist) {
		case NmiStatus_RESET:
			return 31;
		case NmiStatus_WAS_V_BLANK:
			return 95;
		default:
			return self->cycle < 28291 ? 31 : 95;
		}
	default:
		return self->memory[addr];
	}
}

cibool ASAP_PlaySong(ASAP *self, int song, int duration)
{
	if (song < 0 || song >= self->moduleInfo.songs)
		return FALSE;
	self->currentSong = song;
	self->currentDuration = duration;
	self->nextPlayerCycle = 8388608;
	self->blocksPlayed = 0;
	self->silenceCyclesCounter = self->silenceCycles;
	self->cycle = 0;
	self->cpu.nz = 0;
	self->cpu.c = 0;
	self->cpu.vdi = 0;
	self->nmist = NmiStatus_ON_V_BLANK;
	self->consol = 8;
	self->covox[0] = 128;
	self->covox[1] = 128;
	self->covox[2] = 128;
	self->covox[3] = 128;
	PokeyPair_Initialize(&self->pokeys, self->moduleInfo.ntsc, self->moduleInfo.channels > 1);
	ASAP_MutePokeyChannels(self, 255);
	switch (self->moduleInfo.type) {
	case ASAPModuleType_SAP_B:
		if (!ASAP_Do6502Init(self, self->moduleInfo.init, song, 0, 0))
			return FALSE;
		break;
	case ASAPModuleType_SAP_C:
	case ASAPModuleType_CMC:
	case ASAPModuleType_CM3:
	case ASAPModuleType_CMR:
	case ASAPModuleType_CMS:
		if (!ASAP_Do6502Init(self, self->moduleInfo.player + 3, 112, self->moduleInfo.music, self->moduleInfo.music >> 8))
			return FALSE;
		if (!ASAP_Do6502Init(self, self->moduleInfo.player + 3, 0, song, 0))
			return FALSE;
		break;
	case ASAPModuleType_SAP_D:
	case ASAPModuleType_SAP_S:
		self->cpu.pc = self->moduleInfo.init;
		self->cpu.a = song;
		self->cpu.x = 0;
		self->cpu.y = 0;
		self->cpu.s = 255;
		break;
	case ASAPModuleType_DLT:
		if (!ASAP_Do6502Init(self, self->moduleInfo.player + 256, 0, 0, self->moduleInfo.songPos[song]))
			return FALSE;
		break;
	case ASAPModuleType_MPT:
		if (!ASAP_Do6502Init(self, self->moduleInfo.player, 0, self->moduleInfo.music >> 8, self->moduleInfo.music))
			return FALSE;
		if (!ASAP_Do6502Init(self, self->moduleInfo.player, 2, self->moduleInfo.songPos[song], 0))
			return FALSE;
		break;
	case ASAPModuleType_RMT:
		if (!ASAP_Do6502Init(self, self->moduleInfo.player, self->moduleInfo.songPos[song], self->moduleInfo.music, self->moduleInfo.music >> 8))
			return FALSE;
		break;
	case ASAPModuleType_TMC:
	case ASAPModuleType_TM2:
		if (!ASAP_Do6502Init(self, self->moduleInfo.player, 112, self->moduleInfo.music >> 8, self->moduleInfo.music))
			return FALSE;
		if (!ASAP_Do6502Init(self, self->moduleInfo.player, 0, song, 0))
			return FALSE;
		self->tmcPerFrameCounter = 1;
		break;
	case ASAPModuleType_FC:
		if (!ASAP_Do6502Init(self, self->moduleInfo.player, song, 0, 0))
			return FALSE;
		break;
	}
	ASAP_MutePokeyChannels(self, 0);
	self->nextPlayerCycle = 0;
	return TRUE;
}

static void ASAP_PokeHardware(ASAP *self, int addr, int data)
{
	if (addr >> 8 == 210) {
		if ((addr & (self->pokeys.extraPokeyMask + 15)) == 14) {
			self->pokeys.irqst |= data ^ 255;
			if ((data & self->pokeys.irqst & 1) != 0) {
				if (self->pokeys.timer1Cycle == 8388608) {
					int t = self->pokeys.basePokey.tickCycle1;
					while (t < self->cycle)
						t += self->pokeys.basePokey.periodCycles1;
					self->pokeys.timer1Cycle = t;
					if (self->nextEventCycle > t)
						self->nextEventCycle = t;
				}
			}
			else
				self->pokeys.timer1Cycle = 8388608;
			if ((data & self->pokeys.irqst & 2) != 0) {
				if (self->pokeys.timer2Cycle == 8388608) {
					int t = self->pokeys.basePokey.tickCycle2;
					while (t < self->cycle)
						t += self->pokeys.basePokey.periodCycles2;
					self->pokeys.timer2Cycle = t;
					if (self->nextEventCycle > t)
						self->nextEventCycle = t;
				}
			}
			else
				self->pokeys.timer2Cycle = 8388608;
			if ((data & self->pokeys.irqst & 4) != 0) {
				if (self->pokeys.timer4Cycle == 8388608) {
					int t = self->pokeys.basePokey.tickCycle4;
					while (t < self->cycle)
						t += self->pokeys.basePokey.periodCycles4;
					self->pokeys.timer4Cycle = t;
					if (self->nextEventCycle > t)
						self->nextEventCycle = t;
				}
			}
			else
				self->pokeys.timer4Cycle = 8388608;
		}
		else
			PokeyPair_Poke(&self->pokeys, addr, data, self->cycle);
	}
	else if ((addr & 65295) == 54282) {
		int x = self->cycle % 114;
		self->cycle += (x <= 106 ? 106 : 220) - x;
	}
	else if ((addr & 65295) == 54287) {
		self->nmist = self->cycle < 28292 ? NmiStatus_ON_V_BLANK : NmiStatus_RESET;
	}
	else if ((addr & 65280) == self->moduleInfo.covoxAddr) {
		Pokey *pokey;
		addr &= 3;
		if (addr == 0 || addr == 3)
			pokey = &self->pokeys.basePokey;
		else
			pokey = &self->pokeys.extraPokey;
		Pokey_AddDelta(pokey, &self->pokeys, self->cycle, (data - self->covox[addr]) << 17);
		self->covox[addr] = data;
	}
	else if ((addr & 65311) == 53279) {
		int delta = ((self->consol & 8) - (data & 8)) << 20;
		Pokey_AddDelta(&self->pokeys.basePokey, &self->pokeys, self->cycle, delta);
		Pokey_AddDelta(&self->pokeys.extraPokey, &self->pokeys, self->cycle, delta);
		self->consol = data;
	}
	else
		self->memory[addr] = data;
}

static void ASAP_PutLittleEndian(unsigned char *buffer, int offset, int value)
{
	buffer[offset] = (unsigned char) value;
	buffer[offset + 1] = (unsigned char) (value >> 8);
	buffer[offset + 2] = (unsigned char) (value >> 16);
	buffer[offset + 3] = (unsigned char) (value >> 24);
}

static void ASAP_PutLittleEndians(unsigned char *buffer, int offset, int value1, int value2)
{
	ASAP_PutLittleEndian(buffer, offset, value1);
	ASAP_PutLittleEndian(buffer, offset + 4, value2);
}

static int ASAP_PutWavMetadata(unsigned char *buffer, int offset, int fourCC, const char *value)
{
	int len = (int) strlen(value);
	if (len > 0) {
		ASAP_PutLittleEndians(buffer, offset, fourCC, (len | 1) + 1);
		offset += 8;
		{
			int i;
			for (i = 0; i < len; i++)
				buffer[offset++] = value[i];
		}
		buffer[offset++] = 0;
		if ((len & 1) == 0)
			buffer[offset++] = 0;
	}
	return offset;
}

cibool ASAP_Seek(ASAP *self, int position)
{
	return ASAP_SeekSample(self, ASAP_MillisecondsToBlocks(position));
}

cibool ASAP_SeekSample(ASAP *self, int block)
{
	if (block < self->blocksPlayed)
		if (!ASAP_PlaySong(self, self->currentSong, self->currentDuration))
			return FALSE;
	while (self->blocksPlayed + self->pokeys.readySamplesEnd < block) {
		self->blocksPlayed += self->pokeys.readySamplesEnd;
		ASAP_DoFrame(self);
	}
	self->pokeys.readySamplesStart = block - self->blocksPlayed;
	self->blocksPlayed = block;
	return TRUE;
}

static unsigned char const *ASAP6502_GetPlayerRoutine(ASAPInfo const *info)
{
	switch (info->type) {
	case ASAPModuleType_CMC:
		return CiBinaryResource_cmc_obx;
	case ASAPModuleType_CM3:
		return CiBinaryResource_cm3_obx;
	case ASAPModuleType_CMR:
		return CiBinaryResource_cmr_obx;
	case ASAPModuleType_CMS:
		return CiBinaryResource_cms_obx;
	case ASAPModuleType_DLT:
		return CiBinaryResource_dlt_obx;
	case ASAPModuleType_MPT:
		return CiBinaryResource_mpt_obx;
	case ASAPModuleType_RMT:
		return info->channels == 1 ? CiBinaryResource_rmt4_obx : CiBinaryResource_rmt8_obx;
	case ASAPModuleType_TMC:
		return CiBinaryResource_tmc_obx;
	case ASAPModuleType_TM2:
		return CiBinaryResource_tm2_obx;
	case ASAPModuleType_FC:
		return CiBinaryResource_fc_obx;
	default:
		return NULL;
	}
}

ASAPInfo *ASAPInfo_New(void)
{
	ASAPInfo *self = (ASAPInfo *) malloc(sizeof(ASAPInfo));
	return self;
}

void ASAPInfo_Delete(ASAPInfo *self)
{
	free(self);
}

static void ASAPInfo_AddSong(ASAPInfo *self, int playerCalls)
{
	self->durations[self->songs++] = (int) ((double) (playerCalls * self->fastplay) * 38000 / 591149);
}

static int ASAPInfo_AfterFF(unsigned char const *module, int moduleLen, int currentOffset)
{
	while (currentOffset < moduleLen) {
		if (module[currentOffset++] == 255)
			return currentOffset;
	}
	return -1;
}

static int ASAPInfo_CheckDate(ASAPInfo const *self)
{
	int n = (int) strlen(self->date);
	switch (n) {
	case 10:
		if (!ASAPInfo_CheckTwoDateDigits(self, 0) || self->date[2] != 47)
			return -1;
	case 7:
		if (!ASAPInfo_CheckTwoDateDigits(self, n - 7) || self->date[n - 5] != 47)
			return -1;
	case 4:
		if (!ASAPInfo_CheckTwoDateDigits(self, n - 4) || !ASAPInfo_CheckTwoDateDigits(self, n - 2))
			return -1;
		return n;
	default:
		return -1;
	}
}

static cibool ASAPInfo_CheckTwoDateDigits(ASAPInfo const *self, int i)
{
	int d1 = self->date[i];
	int d2 = self->date[i + 1];
	return d1 >= 48 && d1 <= 57 && d2 >= 48 && d2 <= 57;
}

static cibool ASAPInfo_CheckValidChar(int c)
{
	if (!ASAPInfo_IsValidChar(c))
		return FALSE;
	return TRUE;
}

static cibool ASAPInfo_CheckValidText(const char *s)
{
	int n = (int) strlen(s);
	if (n > 127)
		return FALSE;
	{
		int i;
		for (i = 0; i < n; i++)
			if (!ASAPInfo_CheckValidChar(s[i]))
				return FALSE;
	}
	return TRUE;
}

const char *ASAPInfo_GetAuthor(ASAPInfo const *self)
{
	return self->author;
}

int ASAPInfo_GetChannels(ASAPInfo const *self)
{
	return self->channels;
}

int ASAPInfo_GetCovoxAddress(ASAPInfo const *self)
{
	return self->covoxAddr;
}

const char *ASAPInfo_GetDate(ASAPInfo const *self)
{
	return self->date;
}

int ASAPInfo_GetDayOfMonth(ASAPInfo const *self)
{
	int n = ASAPInfo_CheckDate(self);
	if (n != 10)
		return -1;
	return ASAPInfo_GetTwoDateDigits(self, 0);
}

int ASAPInfo_GetDefaultSong(ASAPInfo const *self)
{
	return self->defaultSong;
}

int ASAPInfo_GetDuration(ASAPInfo const *self, int song)
{
	return self->durations[song];
}

const char *ASAPInfo_GetExtDescription(const char *ext)
{
	switch ((int) strlen(ext) >> 1 == 1 ? (ext[0] + (ext[1] << 8) + ((int) strlen(ext) == 3 ? ext[2] << 16 : 0)) | 2105376 : 0) {
	case 7364979:
		return "Slight Atari Player";
	case 6516067:
		return "Chaos Music Composer";
	case 3370339:
		return "CMC \"3/4\"";
	case 7499107:
		return "CMC \"Rzog\"";
	case 7564643:
		return "Stereo Double CMC";
	case 6516068:
		return "DoublePlay CMC";
	case 7629924:
		return "Delta Music Composer";
	case 7630957:
		return "Music ProTracker";
	case 6582381:
		return "MPT DoublePlay";
	case 7630194:
		return "Raster Music Tracker";
	case 6516084:
	case 3698036:
		return "Theta Music Composer 1.x";
	case 3304820:
		return "Theta Music Composer 2.x";
	case 2122598:
		return "Future Composer";
	case 7890296:
		return "Atari 8-bit executable";
	default:
		return NULL;
	}
}

int ASAPInfo_GetInitAddress(ASAPInfo const *self)
{
	return self->init;
}

const char *ASAPInfo_GetInstrumentName(ASAPInfo const *self, unsigned char const *module, int moduleLen, int i)
{
	if (self->type != ASAPModuleType_RMT)
		return NULL;
	{
		int offset;
		for (offset = ASAPInfo_GetWord(module, 4) - ASAPInfo_GetWord(module, 2) + 12; offset < moduleLen; offset++) {
			if (module[offset - 1] == 0 && --i == -1) {
				
					return (const char *) module + offset;
				}
		}
	}
	return NULL;
}

cibool ASAPInfo_GetLoop(ASAPInfo const *self, int song)
{
	return self->loops[song];
}

int ASAPInfo_GetMonth(ASAPInfo const *self)
{
	int n = ASAPInfo_CheckDate(self);
	if (n < 7)
		return -1;
	return ASAPInfo_GetTwoDateDigits(self, n - 7);
}

int ASAPInfo_GetMusicAddress(ASAPInfo const *self)
{
	return self->music;
}

const char *ASAPInfo_GetOriginalModuleExt(ASAPInfo const *self, unsigned char const *module, int moduleLen)
{
	switch (self->type) {
	case ASAPModuleType_SAP_B:
		if ((self->init == 1019 || self->init == 1017) && self->player == 1283)
			return "dlt";
		if (((self->init == 1267 || self->init == 1263) && self->player == 1283) || (self->init == 62707 && self->player == 62723))
			return self->fastplay == 156 ? "mpd" : "mpt";
		if (self->init == 3200 || ASAPInfo_GetRmtSapOffset(self, module, moduleLen) > 0)
			return "rmt";
		if (self->init == 1269 || self->init == 62709 || self->init == 1266 || ((self->init == 1255 || self->init == 62695 || self->init == 1252) && self->fastplay == 156) || ((self->init == 1253 || self->init == 62693 || self->init == 1250) && (self->fastplay == 104 || self->fastplay == 78)))
			return "tmc";
		if ((self->init == 4224 && self->player == 1283) || (self->init == 4992 && self->player == 2051))
			return "tm2";
		if (self->init == 1024 && self->player == 1027)
			return "fc";
		return NULL;
	case ASAPModuleType_SAP_C:
		if ((self->player == 1280 || self->player == 62720) && moduleLen >= 1024) {
			if (self->fastplay == 156)
				return "dmc";
			if (self->channels > 1)
				return "cms";
			if (module[moduleLen - 170] == 30)
				return "cmr";
			if (module[moduleLen - 909] == 48)
				return "cm3";
			return "cmc";
		}
		return NULL;
	case ASAPModuleType_CMC:
		return self->fastplay == 156 ? "dmc" : "cmc";
	case ASAPModuleType_CM3:
		return "cm3";
	case ASAPModuleType_CMR:
		return "cmr";
	case ASAPModuleType_CMS:
		return "cms";
	case ASAPModuleType_DLT:
		return "dlt";
	case ASAPModuleType_MPT:
		return self->fastplay == 156 ? "mpd" : "mpt";
	case ASAPModuleType_RMT:
		return "rmt";
	case ASAPModuleType_TMC:
		return "tmc";
	case ASAPModuleType_TM2:
		return "tm2";
	case ASAPModuleType_FC:
		return "fc";
	default:
		return NULL;
	}
}

static int ASAPInfo_GetPackedExt(const char *filename)
{
	int ext = 0;
	{
		int i;
		for (i = (int) strlen(filename); --i > 0;) {
			int c = filename[i];
			if (c <= 32 || c > 122)
				return 0;
			if (c == 46)
				return ext | 2105376;
			ext = (ext << 8) + c;
		}
	}
	return 0;
}

int ASAPInfo_GetPlayerAddress(ASAPInfo const *self)
{
	return self->player;
}

int ASAPInfo_GetPlayerRateHz(ASAPInfo const *self)
{
	int scanlineClock = self->ntsc ? 15699 : 15556;
	return (scanlineClock + (self->fastplay >> 1)) / self->fastplay;
}

int ASAPInfo_GetPlayerRateScanlines(ASAPInfo const *self)
{
	return self->fastplay;
}

static int ASAPInfo_GetRmtInstrumentFrames(unsigned char const *module, int instrument, int volume, int volumeFrame, cibool onExtraPokey)
{
	int addrToOffset = ASAPInfo_GetWord(module, 2) - 6;
	int perFrame;
	int playerCall;
	int playerCalls;
	int index;
	int indexEnd;
	int indexLoop;
	int volumeSlideDepth;
	int volumeMin;
	static const unsigned char rmtVolumeSilent[16] = { 16, 8, 4, 3, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1 };
	int volumeSlide;
	cibool silentLoop;
	instrument = ASAPInfo_GetWord(module, 14) - addrToOffset + (instrument << 1);
	if (module[instrument + 1] == 0)
		return 0;
	instrument = ASAPInfo_GetWord(module, instrument) - addrToOffset;
	perFrame = module[12];
	playerCall = volumeFrame * perFrame;
	playerCalls = playerCall;
	index = module[instrument] + 1 + playerCall * 3;
	indexEnd = module[instrument + 2] + 3;
	indexLoop = module[instrument + 3];
	if (indexLoop >= indexEnd)
		return 0;
	volumeSlideDepth = module[instrument + 6];
	volumeMin = module[instrument + 7];
	if (index >= indexEnd)
		index = (index - indexEnd) % (indexEnd - indexLoop) + indexLoop;
	else {
		do {
			int vol = module[instrument + index];
			if (onExtraPokey)
				vol >>= 4;
			if ((vol & 15) >= rmtVolumeSilent[volume])
				playerCalls = playerCall + 1;
			playerCall++;
			index += 3;
		}
		while (index < indexEnd);
	}
	if (volumeSlideDepth == 0)
		return playerCalls / perFrame;
	volumeSlide = 128;
	silentLoop = FALSE;
	for (;;) {
		int vol;
		if (index >= indexEnd) {
			if (silentLoop)
				break;
			silentLoop = TRUE;
			index = indexLoop;
		}
		vol = module[instrument + index];
		if (onExtraPokey)
			vol >>= 4;
		if ((vol & 15) >= rmtVolumeSilent[volume]) {
			playerCalls = playerCall + 1;
			silentLoop = FALSE;
		}
		playerCall++;
		index += 3;
		volumeSlide -= volumeSlideDepth;
		if (volumeSlide < 0) {
			volumeSlide += 256;
			if (--volume <= volumeMin)
				break;
		}
	}
	return playerCalls / perFrame;
}

static int ASAPInfo_GetRmtSapOffset(ASAPInfo const *self, unsigned char const *module, int moduleLen)
{
	int offset;
	if (self->player != 13315)
		return -1;
	offset = self->headerLen + ASAPInfo_GetWord(module, self->headerLen + 4) - ASAPInfo_GetWord(module, self->headerLen + 2) + 7;
	if (offset + 6 >= moduleLen || module[offset + 4] != 82 || module[offset + 5] != 77 || module[offset + 6] != 84)
		return -1;
	return offset;
}

int ASAPInfo_GetSapHeaderLength(ASAPInfo const *self)
{
	return self->headerLen;
}

int ASAPInfo_GetSongs(ASAPInfo const *self)
{
	return self->songs;
}

const char *ASAPInfo_GetTitle(ASAPInfo const *self)
{
	return self->title;
}

const char *ASAPInfo_GetTitleOrFilename(ASAPInfo const *self)
{
	return self->title[0] != '\0' ? self->title : self->filename;
}

static int ASAPInfo_GetTwoDateDigits(ASAPInfo const *self, int i)
{
	return (self->date[i] - 48) * 10 + self->date[i + 1] - 48;
}

int ASAPInfo_GetTypeLetter(ASAPInfo const *self)
{
	switch (self->type) {
	case ASAPModuleType_SAP_B:
		return 66;
	case ASAPModuleType_SAP_C:
		return 67;
	case ASAPModuleType_SAP_D:
		return 68;
	case ASAPModuleType_SAP_S:
		return 83;
	default:
		return 0;
	}
}

static int ASAPInfo_GetWord(unsigned char const *array, int i)
{
	return array[i] + (array[i + 1] << 8);
}

int ASAPInfo_GetYear(ASAPInfo const *self)
{
	int n = ASAPInfo_CheckDate(self);
	if (n < 0)
		return -1;
	return ASAPInfo_GetTwoDateDigits(self, n - 4) * 100 + ASAPInfo_GetTwoDateDigits(self, n - 2);
}

static int ASAPInfo_GuessPackedExt(unsigned char const *module, int moduleLen)
{
	if (ASAPInfo_ValidateSap(module, moduleLen))
		return 7364979;
	if (ASAPInfo_ValidateFc(module, moduleLen))
		return 2122598;
	if (ASAPInfo_ValidateRmt(module, moduleLen))
		return 7630194;
	return -1;
}

static cibool ASAPInfo_HasStringAt(unsigned char const *module, int moduleIndex, const char *s)
{
	int n = (int) strlen(s);
	{
		int i;
		for (i = 0; i < n; i++)
			if (module[moduleIndex + i] != s[i])
				return FALSE;
	}
	return TRUE;
}

static cibool ASAPInfo_IsDltPatternEnd(unsigned char const *module, int pos, int i)
{
	{
		int ch;
		for (ch = 0; ch < 4; ch++) {
			int pattern = module[8198 + (ch << 8) + pos];
			if (pattern < 64) {
				int offset = 6 + (pattern << 7) + (i << 1);
				if ((module[offset] & 128) == 0 && (module[offset + 1] & 128) != 0)
					return TRUE;
			}
		}
	}
	return FALSE;
}

static cibool ASAPInfo_IsDltTrackEmpty(unsigned char const *module, int pos)
{
	return module[8198 + pos] >= 67 && module[8454 + pos] >= 64 && module[8710 + pos] >= 64 && module[8966 + pos] >= 64;
}

static cibool ASAPInfo_IsFcSongEnd(unsigned char const *module, int const *trackPos)
{
	cibool allLoop = TRUE;
	{
		int n;
		for (n = 0; n < 3; n++) {
			if (trackPos[n] >= 256)
				return TRUE;
			switch (module[3 + (n << 8) + trackPos[n]]) {
			case 254:
				return TRUE;
			case 255:
				break;
			default:
				allLoop = FALSE;
				break;
			}
		}
	}
	return allLoop;
}

cibool ASAPInfo_IsNtsc(ASAPInfo const *self)
{
	return self->ntsc;
}

cibool ASAPInfo_IsOurExt(const char *ext)
{
	return ASAPInfo_IsOurPackedExt((int) strlen(ext) >> 1 == 1 ? (ext[0] + (ext[1] << 8) + ((int) strlen(ext) == 3 ? ext[2] << 16 : 0)) | 2105376 : 0);
}

cibool ASAPInfo_IsOurFile(const char *filename)
{
	return ASAPInfo_IsOurPackedExt(ASAPInfo_GetPackedExt(filename));
}

static cibool ASAPInfo_IsOurPackedExt(int ext)
{
	switch (ext) {
	case 7364979:
	case 6516067:
	case 3370339:
	case 7499107:
	case 7564643:
	case 6516068:
	case 7629924:
	case 7630957:
	case 6582381:
	case 7630194:
	case 6516084:
	case 3698036:
	case 3304820:
	case 2122598:
		return TRUE;
	default:
		return FALSE;
	}
}

static cibool ASAPInfo_IsValidChar(int c)
{
	return c >= 32 && c <= 124 && c != 96 && c != 123;
}

cibool ASAPInfo_Load(ASAPInfo *self, const char *filename, unsigned char const *module, int moduleLen)
{
	int ext;
	if (filename != NULL) {
		int len = (int) strlen(filename);
		int basename = 0;
		ext = -1;
		{
			int i;
			for (i = len; --i >= 0;) {
				int c = filename[i];
				if (c == 47 || c == 92) {
					basename = i + 1;
					break;
				}
				if (c == 46)
					ext = i;
			}
		}
		if (ext < 0)
			return FALSE;
		ext -= basename;
		if (ext > 127)
			ext = 127;
		((char *) memcpy(self->filename, filename + basename, ext))[ext] = '\0';
		ext = ASAPInfo_GetPackedExt(filename);
	}
	else {
		self->filename[0] = '\0';
		if ((ext = ASAPInfo_GuessPackedExt(module, moduleLen)) == -1)
			return FALSE;
	}
	self->author[0] = '\0';
	self->title[0] = '\0';
	self->date[0] = '\0';
	self->channels = 1;
	self->songs = 1;
	self->defaultSong = 0;
	{
		int i;
		for (i = 0; i < 32; i++) {
			self->durations[i] = -1;
			self->loops[i] = FALSE;
		}
	}
	self->ntsc = FALSE;
	self->fastplay = 312;
	self->music = -1;
	self->init = -1;
	self->player = -1;
	self->covoxAddr = -1;
	self->headerLen = 0;
	switch (ext) {
	case 7364979:
		return ASAPInfo_ParseSap(self, module, moduleLen);
	case 6516067:
		return ASAPInfo_ParseCmc(self, module, moduleLen, ASAPModuleType_CMC);
	case 3370339:
		return ASAPInfo_ParseCmc(self, module, moduleLen, ASAPModuleType_CM3);
	case 7499107:
		return ASAPInfo_ParseCmc(self, module, moduleLen, ASAPModuleType_CMR);
	case 7564643:
		self->channels = 2;
		return ASAPInfo_ParseCmc(self, module, moduleLen, ASAPModuleType_CMS);
	case 6516068:
		self->fastplay = 156;
		return ASAPInfo_ParseCmc(self, module, moduleLen, ASAPModuleType_CMC);
	case 7629924:
		return ASAPInfo_ParseDlt(self, module, moduleLen);
	case 7630957:
		return ASAPInfo_ParseMpt(self, module, moduleLen);
	case 6582381:
		self->fastplay = 156;
		return ASAPInfo_ParseMpt(self, module, moduleLen);
	case 7630194:
		return ASAPInfo_ParseRmt(self, module, moduleLen);
	case 6516084:
	case 3698036:
		return ASAPInfo_ParseTmc(self, module, moduleLen);
	case 3304820:
		return ASAPInfo_ParseTm2(self, module, moduleLen);
	case 2122598:
		return ASAPInfo_ParseFc(self, module, moduleLen);
	default:
		return FALSE;
	}
}

static cibool ASAPInfo_ParseCmc(ASAPInfo *self, unsigned char const *module, int moduleLen, ASAPModuleType type)
{
	int lastPos;
	if (moduleLen < 774)
		return FALSE;
	self->type = type;
	if (!ASAPInfo_ParseModule(self, module, moduleLen))
		return FALSE;
	lastPos = 84;
	while (--lastPos >= 0) {
		if (module[518 + lastPos] < 176 || module[603 + lastPos] < 64 || module[688 + lastPos] < 64)
			break;
		if (self->channels == 2) {
			if (module[774 + lastPos] < 176 || module[859 + lastPos] < 64 || module[944 + lastPos] < 64)
				break;
		}
	}
	self->songs = 0;
	ASAPInfo_ParseCmcSong(self, module, 0);
	{
		int pos;
		for (pos = 0; pos < lastPos && self->songs < 32; pos++)
			if (module[518 + pos] == 143 || module[518 + pos] == 239)
				ASAPInfo_ParseCmcSong(self, module, pos + 1);
	}
	return TRUE;
}

static void ASAPInfo_ParseCmcSong(ASAPInfo *self, unsigned char const *module, int pos)
{
	int tempo = module[25];
	int playerCalls = 0;
	int repStartPos = 0;
	int repEndPos = 0;
	int repTimes = 0;
	unsigned char seen[85];
	memset(seen, 0, sizeof(seen));
	while (pos >= 0 && pos < 85) {
		int p1;
		int p2;
		int p3;
		if (pos == repEndPos && repTimes > 0) {
			{
				int i;
				for (i = 0; i < 85; i++)
					if (seen[i] == 1 || seen[i] == 3)
						seen[i] = 0;
			}
			repTimes--;
			pos = repStartPos;
		}
		if (seen[pos] != 0) {
			if (seen[pos] != 1)
				self->loops[self->songs] = TRUE;
			break;
		}
		seen[pos] = 1;
		p1 = module[518 + pos];
		p2 = module[603 + pos];
		p3 = module[688 + pos];
		if (p1 == 254 || p2 == 254 || p3 == 254) {
			pos++;
			continue;
		}
		p1 |= self->type == ASAPModuleType_CMS ? 7 : 15;
		switch (p1) {
		case 135:
		case 167:
			pos++;
			break;
		case 143:
			pos = -1;
			break;
		case 151:
			if (p2 < 128) {
				playerCalls += p2;
				if (p3 < 128)
					playerCalls += p3 * 50;
			}
			pos++;
			break;
		case 159:
			pos = p2;
			break;
		case 175:
			pos -= p2;
			break;
		case 191:
			pos += p2;
			break;
		case 207:
			if (p2 < 128) {
				tempo = p2;
				pos++;
			}
			else
				pos = -1;
			break;
		case 223:
			pos++;
			repStartPos = pos;
			repEndPos = pos + p2;
			repTimes = p3 - 1;
			break;
		case 239:
			self->loops[self->songs] = TRUE;
			pos = -1;
			break;
		default:
			p2 = repTimes > 0 ? 3 : 2;
			for (p1 = 0; p1 < 85; p1++)
				if (seen[p1] == 1)
					seen[p1] = p2;
			playerCalls += tempo * (self->type == ASAPModuleType_CM3 ? 48 : 64);
			pos++;
			break;
		}
	}
	ASAPInfo_AddSong(self, playerCalls);
}

static int ASAPInfo_ParseDec(unsigned char const *module, int moduleIndex, int maxVal)
{
	if (module[moduleIndex] == 13)
		return -1;
	{
		int r;
		for (r = 0;;) {
			int c = module[moduleIndex++];
			if (c == 13)
				return r;
			if (c < 48 || c > 57)
				return -1;
			r = 10 * r + c - 48;
			if (r > maxVal)
				return -1;
		}
	}
}

static cibool ASAPInfo_ParseDlt(ASAPInfo *self, unsigned char const *module, int moduleLen)
{
	cibool seen[128];
	if (moduleLen != 11270 && moduleLen != 11271)
		return FALSE;
	self->type = ASAPModuleType_DLT;
	if (!ASAPInfo_ParseModule(self, module, moduleLen))
		return FALSE;
	if (self->music != 8192)
		return FALSE;
	memset(seen, 0, sizeof(seen));
	self->songs = 0;
	{
		int pos;
		for (pos = 0; pos < 128 && self->songs < 32; pos++) {
			if (!seen[pos])
				ASAPInfo_ParseDltSong(self, module, seen, pos);
		}
	}
	if (self->songs == 0)
		return FALSE;
	return TRUE;
}

static void ASAPInfo_ParseDltSong(ASAPInfo *self, unsigned char const *module, cibool *seen, int pos)
{
	int playerCalls;
	cibool loop;
	int tempo;
	while (pos < 128 && !seen[pos] && ASAPInfo_IsDltTrackEmpty(module, pos))
		seen[pos++] = TRUE;
	self->songPos[self->songs] = pos;
	playerCalls = 0;
	loop = FALSE;
	tempo = 6;
	while (pos < 128) {
		int p1;
		if (seen[pos]) {
			loop = TRUE;
			break;
		}
		seen[pos] = TRUE;
		p1 = module[8198 + pos];
		if (p1 == 64 || ASAPInfo_IsDltTrackEmpty(module, pos))
			break;
		if (p1 == 65)
			pos = module[8326 + pos];
		else if (p1 == 66)
			tempo = module[8326 + pos++];
		else {
			{
				int i;
				for (i = 0; i < 64 && !ASAPInfo_IsDltPatternEnd(module, pos, i); i++)
					playerCalls += tempo;
			}
			pos++;
		}
	}
	if (playerCalls > 0) {
		self->loops[self->songs] = loop;
		ASAPInfo_AddSong(self, playerCalls);
	}
}

int ASAPInfo_ParseDuration(const char *s)
{
	int i = 0;
	int n = (int) strlen(s);
	int d;
	int r;
	if (i >= n)
		return -1;
	d = s[i] - 48;
	if (d < 0 || d > 9)
		return -1;
	i++;
	r = d;
	if (i < n) {
		d = s[i] - 48;
		if (d >= 0 && d <= 9) {
			i++;
			r = 10 * r + d;
		}
		if (i < n && s[i] == 58) {
			i++;
			if (i >= n)
				return -1;
			d = s[i] - 48;
			if (d < 0 || d > 5)
				return -1;
			i++;
			r = (6 * r + d) * 10;
			if (i >= n)
				return -1;
			d = s[i] - 48;
			if (d < 0 || d > 9)
				return -1;
			i++;
			r += d;
		}
	}
	r *= 1000;
	if (i >= n)
		return r;
	if (s[i] != 46)
		return -1;
	i++;
	if (i >= n)
		return -1;
	d = s[i] - 48;
	if (d < 0 || d > 9)
		return -1;
	i++;
	r += 100 * d;
	if (i >= n)
		return r;
	d = s[i] - 48;
	if (d < 0 || d > 9)
		return -1;
	i++;
	r += 10 * d;
	if (i >= n)
		return r;
	d = s[i] - 48;
	if (d < 0 || d > 9)
		return -1;
	i++;
	r += d;
	return r;
}

static cibool ASAPInfo_ParseFc(ASAPInfo *self, unsigned char const *module, int moduleLen)
{
	int patternOffsets[64];
	int currentOffset;
	if (!ASAPInfo_ValidateFc(module, moduleLen))
		return FALSE;
	self->type = ASAPModuleType_FC;
	self->player = 1024;
	self->music = 2560;
	self->songs = 0;
	self->headerLen = -1;
	currentOffset = 899;
	{
		int i;
		for (i = 0; i < 64; i++) {
			patternOffsets[i] = currentOffset;
			if ((currentOffset = ASAPInfo_AfterFF(module, moduleLen, currentOffset)) == -1)
				return FALSE;
		}
	}
	{
		int i;
		for (i = 0; i < 32; i++)
			if ((currentOffset = ASAPInfo_AfterFF(module, moduleLen, currentOffset)) == -1)
				return FALSE;
	}
	{
		int pos;
		for (pos = 0; pos < 256 && self->songs < 32;) {
			int trackPos[3];
			int patternDelay[3];
			int noteDuration[3];
			int patternPos[3];
			int playerCalls;
			{
				int n;
				for (n = 0; n < 3; n++)
					trackPos[n] = pos;
			}
			memset(patternDelay, 0, sizeof(patternDelay));
			memset(noteDuration, 0, sizeof(noteDuration));
			memset(patternPos, 0, sizeof(patternPos));
			playerCalls = 0;
			self->loops[self->songs] = TRUE;
			while (!ASAPInfo_IsFcSongEnd(module, trackPos)) {
				{
					int n;
					for (n = 0; n < 3; n++) {
						int trackCmd = module[3 + (n << 8) + trackPos[n]];
						if (trackCmd != 255 && patternDelay[n]-- <= 0) {
							while (trackPos[n] < 256) {
								trackCmd = module[3 + (n << 8) + trackPos[n]];
								if (trackCmd < 64) {
									int patternCmd = module[patternOffsets[trackCmd] + patternPos[n]++];
									if (patternCmd < 64) {
										patternDelay[n] = noteDuration[n];
										break;
									}
									else if (patternCmd < 96)
										noteDuration[n] = patternCmd - 64;
									else if (patternCmd == 255) {
										patternDelay[n] = 0;
										noteDuration[n] = 0;
										patternPos[n] = 0;
										trackPos[n]++;
									}
								}
								else if (trackCmd == 64)
									trackPos[n] += 2;
								else if (trackCmd == 254) {
									self->loops[self->songs] = FALSE;
									break;
								}
								else if (trackCmd == 255)
									break;
								else
									trackPos[n]++;
							}
						}
					}
				}
				if (ASAPInfo_IsFcSongEnd(module, trackPos))
					break;
				playerCalls += module[2];
			}
			pos = -1;
			{
				int n;
				for (n = 0; n < 3; n++) {
					int nxtrkpos = trackPos[n];
					if (patternPos[n] > 0)
						nxtrkpos++;
					if (pos < nxtrkpos)
						pos = nxtrkpos;
				}
			}
			pos++;
			if (pos <= 256)
				ASAPInfo_AddSong(self, playerCalls);
		}
	}
	return TRUE;
}

static int ASAPInfo_ParseHex(unsigned char const *module, int moduleIndex)
{
	if (module[moduleIndex] == 13)
		return -1;
	{
		int r;
		for (r = 0;;) {
			int c = module[moduleIndex++];
			if (c == 13)
				return r;
			if (r > 4095)
				return -1;
			r <<= 4;
			if (c >= 48 && c <= 57)
				r += c - 48;
			else if (c >= 65 && c <= 70)
				r += c - 65 + 10;
			else if (c >= 97 && c <= 102)
				r += c - 97 + 10;
			else
				return -1;
		}
	}
}

static cibool ASAPInfo_ParseModule(ASAPInfo *self, unsigned char const *module, int moduleLen)
{
	int musicLastByte;
	int blockLen;
	if ((module[0] != 255 || module[1] != 255) && (module[0] != 0 || module[1] != 0))
		return FALSE;
	self->music = ASAPInfo_GetWord(module, 2);
	musicLastByte = ASAPInfo_GetWord(module, 4);
	if (self->music <= 55295 && musicLastByte >= 53248)
		return FALSE;
	blockLen = musicLastByte + 1 - self->music;
	if (6 + blockLen != moduleLen) {
		int infoAddr;
		int infoLen;
		if (self->type != ASAPModuleType_RMT || 11 + blockLen > moduleLen)
			return FALSE;
		infoAddr = ASAPInfo_GetWord(module, 6 + blockLen);
		if (infoAddr != self->music + blockLen)
			return FALSE;
		infoLen = ASAPInfo_GetWord(module, 8 + blockLen) + 1 - infoAddr;
		if (10 + blockLen + infoLen != moduleLen)
			return FALSE;
	}
	return TRUE;
}

static cibool ASAPInfo_ParseMpt(ASAPInfo *self, unsigned char const *module, int moduleLen)
{
	int track0Addr;
	int songLen;
	cibool globalSeen[256];
	if (moduleLen < 464)
		return FALSE;
	self->type = ASAPModuleType_MPT;
	if (!ASAPInfo_ParseModule(self, module, moduleLen))
		return FALSE;
	track0Addr = ASAPInfo_GetWord(module, 2) + 458;
	if (module[454] + (module[458] << 8) != track0Addr)
		return FALSE;
	songLen = (module[455] + (module[459] << 8) - track0Addr) >> 1;
	if (songLen > 254)
		return FALSE;
	memset(globalSeen, 0, sizeof(globalSeen));
	self->songs = 0;
	{
		int pos;
		for (pos = 0; pos < songLen && self->songs < 32; pos++) {
			if (!globalSeen[pos]) {
				self->songPos[self->songs] = pos;
				ASAPInfo_ParseMptSong(self, module, globalSeen, songLen, pos);
			}
		}
	}
	if (self->songs == 0)
		return FALSE;
	return TRUE;
}

static void ASAPInfo_ParseMptSong(ASAPInfo *self, unsigned char const *module, cibool *globalSeen, int songLen, int pos)
{
	int addrToOffset = ASAPInfo_GetWord(module, 2) - 6;
	int tempo = module[463];
	int playerCalls = 0;
	unsigned char seen[256];
	int patternOffset[4];
	int blankRows[4];
	int blankRowsCounter[4];
	memset(seen, 0, sizeof(seen));
	memset(blankRows, 0, sizeof(blankRows));
	while (pos < songLen) {
		int i;
		int ch;
		if (seen[pos] != 0) {
			if (seen[pos] != 1)
				self->loops[self->songs] = TRUE;
			break;
		}
		seen[pos] = 1;
		globalSeen[pos] = TRUE;
		i = module[464 + pos * 2];
		if (i == 255) {
			pos = module[465 + pos * 2];
			continue;
		}
		for (ch = 3; ch >= 0; ch--) {
			i = module[454 + ch] + (module[458 + ch] << 8) - addrToOffset;
			i = module[i + pos * 2];
			if (i >= 64)
				break;
			i <<= 1;
			i = ASAPInfo_GetWord(module, 70 + i);
			patternOffset[ch] = i == 0 ? 0 : i - addrToOffset;
			blankRowsCounter[ch] = 0;
		}
		if (ch >= 0)
			break;
		for (i = 0; i < songLen; i++)
			if (seen[i] == 1)
				seen[i] = 2;
		{
			int patternRows;
			for (patternRows = module[462]; --patternRows >= 0;) {
				for (ch = 3; ch >= 0; ch--) {
					if (patternOffset[ch] == 0 || --blankRowsCounter[ch] >= 0)
						continue;
					for (;;) {
						i = module[patternOffset[ch]++];
						if (i < 64 || i == 254)
							break;
						if (i < 128)
							continue;
						if (i < 192) {
							blankRows[ch] = i - 128;
							continue;
						}
						if (i < 208)
							continue;
						if (i < 224) {
							tempo = i - 207;
							continue;
						}
						patternRows = 0;
					}
					blankRowsCounter[ch] = blankRows[ch];
				}
				playerCalls += tempo;
			}
		}
		pos++;
	}
	if (playerCalls > 0)
		ASAPInfo_AddSong(self, playerCalls);
}

static cibool ASAPInfo_ParseRmt(ASAPInfo *self, unsigned char const *module, int moduleLen)
{
	int posShift;
	int perFrame;
	int blockLen;
	int songLen;
	cibool globalSeen[256];
	unsigned char title[127];
	int titleLen;
	if (!ASAPInfo_ValidateRmt(module, moduleLen))
		return FALSE;
	switch (module[9]) {
	case 52:
		posShift = 2;
		break;
	case 56:
		self->channels = 2;
		posShift = 3;
		break;
	default:
		return FALSE;
	}
	perFrame = module[12];
	if (perFrame < 1 || perFrame > 4)
		return FALSE;
	self->type = ASAPModuleType_RMT;
	if (!ASAPInfo_ParseModule(self, module, moduleLen))
		return FALSE;
	blockLen = ASAPInfo_GetWord(module, 4) + 1 - self->music;
	songLen = ASAPInfo_GetWord(module, 4) + 1 - ASAPInfo_GetWord(module, 20);
	if (posShift == 3 && (songLen & 4) != 0 && module[6 + blockLen - 4] == 254)
		songLen += 4;
	songLen >>= posShift;
	if (songLen >= 256)
		return FALSE;
	memset(globalSeen, 0, sizeof(globalSeen));
	self->songs = 0;
	{
		int pos;
		for (pos = 0; pos < songLen && self->songs < 32; pos++) {
			if (!globalSeen[pos]) {
				self->songPos[self->songs] = pos;
				ASAPInfo_ParseRmtSong(self, module, globalSeen, songLen, posShift, pos);
			}
		}
	}
	self->fastplay = 312 / perFrame;
	self->player = 1536;
	if (self->songs == 0)
		return FALSE;
	for (titleLen = 0; titleLen < 127 && 10 + blockLen + titleLen < moduleLen; titleLen++) {
		unsigned char c = module[10 + blockLen + titleLen];
		if (c == 0)
			break;
		title[titleLen] = ASAPInfo_IsValidChar(c) ? c : 32;
	}
	((char *) memcpy(self->title, title + 0, titleLen))[titleLen] = '\0';
	return TRUE;
}

static void ASAPInfo_ParseRmtSong(ASAPInfo *self, unsigned char const *module, cibool *globalSeen, int songLen, int posShift, int pos)
{
	int addrToOffset = ASAPInfo_GetWord(module, 2) - 6;
	int tempo = module[11];
	int frames = 0;
	int songOffset = ASAPInfo_GetWord(module, 20) - addrToOffset;
	int patternLoOffset = ASAPInfo_GetWord(module, 16) - addrToOffset;
	int patternHiOffset = ASAPInfo_GetWord(module, 18) - addrToOffset;
	unsigned char seen[256];
	int patternBegin[8];
	int patternOffset[8];
	int blankRows[8];
	int instrumentNo[8];
	int instrumentFrame[8];
	int volumeValue[8];
	int volumeFrame[8];
	int instrumentFrames;
	memset(seen, 0, sizeof(seen));
	memset(instrumentNo, 0, sizeof(instrumentNo));
	memset(instrumentFrame, 0, sizeof(instrumentFrame));
	memset(volumeValue, 0, sizeof(volumeValue));
	memset(volumeFrame, 0, sizeof(volumeFrame));
	while (pos < songLen) {
		if (seen[pos] != 0) {
			if (seen[pos] != 1)
				self->loops[self->songs] = TRUE;
			break;
		}
		seen[pos] = 1;
		globalSeen[pos] = TRUE;
		if (module[songOffset + (pos << posShift)] == 254) {
			pos = module[songOffset + (pos << posShift) + 1];
			continue;
		}
		{
			int ch;
			for (ch = 0; ch < 1 << posShift; ch++) {
				int p = module[songOffset + (pos << posShift) + ch];
				if (p == 255)
					blankRows[ch] = 256;
				else {
					patternOffset[ch] = patternBegin[ch] = module[patternLoOffset + p] + (module[patternHiOffset + p] << 8) - addrToOffset;
					if (patternOffset[ch] < 0)
						return;
					blankRows[ch] = 0;
				}
			}
		}
		{
			int i;
			for (i = 0; i < songLen; i++)
				if (seen[i] == 1)
					seen[i] = 2;
		}
		{
			int patternRows;
			for (patternRows = module[10]; --patternRows >= 0;) {
				{
					int ch;
					for (ch = 0; ch < 1 << posShift; ch++) {
						if (--blankRows[ch] > 0)
							continue;
						for (;;) {
							int i = module[patternOffset[ch]++];
							if ((i & 63) < 62) {
								i += module[patternOffset[ch]++] << 8;
								if ((i & 63) != 61) {
									instrumentNo[ch] = i >> 10;
									instrumentFrame[ch] = frames;
								}
								volumeValue[ch] = (i >> 6) & 15;
								volumeFrame[ch] = frames;
								break;
							}
							if (i == 62) {
								blankRows[ch] = module[patternOffset[ch]++];
								break;
							}
							if ((i & 63) == 62) {
								blankRows[ch] = i >> 6;
								break;
							}
							if ((i & 191) == 63) {
								tempo = module[patternOffset[ch]++];
								continue;
							}
							if (i == 191) {
								patternOffset[ch] = patternBegin[ch] + module[patternOffset[ch]];
								continue;
							}
							patternRows = -1;
							break;
						}
						if (patternRows < 0)
							break;
					}
				}
				if (patternRows >= 0)
					frames += tempo;
			}
		}
		pos++;
	}
	instrumentFrames = 0;
	{
		int ch;
		for (ch = 0; ch < 1 << posShift; ch++) {
			int frame = instrumentFrame[ch];
			frame += ASAPInfo_GetRmtInstrumentFrames(module, instrumentNo[ch], volumeValue[ch], volumeFrame[ch] - frame, ch >= 4);
			if (instrumentFrames < frame)
				instrumentFrames = frame;
		}
	}
	if (frames > instrumentFrames) {
		if (frames - instrumentFrames > 100)
			self->loops[self->songs] = FALSE;
		frames = instrumentFrames;
	}
	if (frames > 0)
		ASAPInfo_AddSong(self, frames);
}

static cibool ASAPInfo_ParseSap(ASAPInfo *self, unsigned char const *module, int moduleLen)
{
	int type;
	int moduleIndex;
	int durationIndex;
	if (!ASAPInfo_ValidateSap(module, moduleLen))
		return FALSE;
	self->fastplay = -1;
	type = 0;
	moduleIndex = 5;
	durationIndex = 0;
	while (module[moduleIndex] != 255) {
		if (moduleIndex + 8 >= moduleLen)
			return FALSE;
		if (ASAPInfo_HasStringAt(module, moduleIndex, "AUTHOR ")) {
			int len;
			if ((len = ASAPInfo_ParseText(module, moduleIndex + 7)) == -1)
				return FALSE;
			if (len > 0)
				((char *) memcpy(self->author, module + moduleIndex + 7 + 1, len))[len] = '\0';
		}
		else if (ASAPInfo_HasStringAt(module, moduleIndex, "NAME ")) {
			int len;
			if ((len = ASAPInfo_ParseText(module, moduleIndex + 5)) == -1)
				return FALSE;
			if (len > 0)
				((char *) memcpy(self->title, module + moduleIndex + 5 + 1, len))[len] = '\0';
		}
		else if (ASAPInfo_HasStringAt(module, moduleIndex, "DATE ")) {
			int len;
			if ((len = ASAPInfo_ParseText(module, moduleIndex + 5)) == -1)
				return FALSE;
			if (len > 0)
				((char *) memcpy(self->date, module + moduleIndex + 5 + 1, len))[len] = '\0';
		}
		else if (ASAPInfo_HasStringAt(module, moduleIndex, "SONGS ")) {
			if ((self->songs = ASAPInfo_ParseDec(module, moduleIndex + 6, 32)) == -1)
				return FALSE;
			if (self->songs < 1)
				return FALSE;
		}
		else if (ASAPInfo_HasStringAt(module, moduleIndex, "DEFSONG ")) {
			if ((self->defaultSong = ASAPInfo_ParseDec(module, moduleIndex + 8, 31)) == -1)
				return FALSE;
			if (self->defaultSong < 0)
				return FALSE;
		}
		else if (ASAPInfo_HasStringAt(module, moduleIndex, "STEREO\r"))
			self->channels = 2;
		else if (ASAPInfo_HasStringAt(module, moduleIndex, "NTSC\r"))
			self->ntsc = TRUE;
		else if (ASAPInfo_HasStringAt(module, moduleIndex, "TIME ")) {
			int len;
			char s[10];
			int duration;
			if (durationIndex >= 32)
				return FALSE;
			moduleIndex += 5;
			for (len = 0; module[moduleIndex + len] != 13; len++) {
			}
			if (len > 5 && ASAPInfo_HasStringAt(module, moduleIndex + len - 5, " LOOP")) {
				self->loops[durationIndex] = TRUE;
				len -= 5;
			}
			if (len > 9)
				return FALSE;
			((char *) memcpy(s, module + moduleIndex, len))[len] = '\0';
			if ((duration = ASAPInfo_ParseDuration(s)) == -1)
				return FALSE;
			self->durations[durationIndex++] = duration;
		}
		else if (ASAPInfo_HasStringAt(module, moduleIndex, "TYPE "))
			type = module[moduleIndex + 5];
		else if (ASAPInfo_HasStringAt(module, moduleIndex, "FASTPLAY ")) {
			if ((self->fastplay = ASAPInfo_ParseDec(module, moduleIndex + 9, 32767)) == -1)
				return FALSE;
			if (self->fastplay < 1)
				return FALSE;
		}
		else if (ASAPInfo_HasStringAt(module, moduleIndex, "MUSIC ")) {
			if ((self->music = ASAPInfo_ParseHex(module, moduleIndex + 6)) == -1)
				return FALSE;
		}
		else if (ASAPInfo_HasStringAt(module, moduleIndex, "INIT ")) {
			if ((self->init = ASAPInfo_ParseHex(module, moduleIndex + 5)) == -1)
				return FALSE;
		}
		else if (ASAPInfo_HasStringAt(module, moduleIndex, "PLAYER ")) {
			if ((self->player = ASAPInfo_ParseHex(module, moduleIndex + 7)) == -1)
				return FALSE;
		}
		else if (ASAPInfo_HasStringAt(module, moduleIndex, "COVOX ")) {
			if ((self->covoxAddr = ASAPInfo_ParseHex(module, moduleIndex + 6)) == -1)
				return FALSE;
			if (self->covoxAddr != 54784)
				return FALSE;
			self->channels = 2;
		}
		while (module[moduleIndex++] != 13) {
			if (moduleIndex >= moduleLen)
				return FALSE;
		}
		if (module[moduleIndex++] != 10)
			return FALSE;
	}
	if (self->defaultSong >= self->songs)
		return FALSE;
	switch (type) {
	case 66:
		if (self->player < 0)
			return FALSE;
		if (self->init < 0)
			return FALSE;
		self->type = ASAPModuleType_SAP_B;
		break;
	case 67:
		if (self->player < 0)
			return FALSE;
		if (self->music < 0)
			return FALSE;
		self->type = ASAPModuleType_SAP_C;
		break;
	case 68:
		if (self->init < 0)
			return FALSE;
		self->type = ASAPModuleType_SAP_D;
		break;
	case 83:
		if (self->init < 0)
			return FALSE;
		self->type = ASAPModuleType_SAP_S;
		if (self->fastplay < 0)
			self->fastplay = 78;
		break;
	default:
		return FALSE;
	}
	if (self->fastplay < 0)
		self->fastplay = self->ntsc ? 262 : 312;
	if (module[moduleIndex + 1] != 255)
		return FALSE;
	self->headerLen = moduleIndex;
	return TRUE;
}

static int ASAPInfo_ParseText(unsigned char const *module, int moduleIndex)
{
	if (module[moduleIndex] != 34)
		return -1;
	if (ASAPInfo_HasStringAt(module, moduleIndex + 1, "<?>\"\r"))
		return 0;
	{
		int len;
		for (len = 0;; len++) {
			int c = module[moduleIndex + 1 + len];
			if (c == 34 && module[moduleIndex + 2 + len] == 13)
				return len;
			if (!ASAPInfo_CheckValidChar(c))
				return -1;
		}
	}
}

static cibool ASAPInfo_ParseTm2(ASAPInfo *self, unsigned char const *module, int moduleLen)
{
	int i;
	int lastPos;
	int c;
	unsigned char title[127];
	int titleLen;
	if (moduleLen < 932)
		return FALSE;
	self->type = ASAPModuleType_TM2;
	if (!ASAPInfo_ParseModule(self, module, moduleLen))
		return FALSE;
	i = module[37];
	if (i < 1 || i > 4)
		return FALSE;
	self->fastplay = 312 / i;
	self->player = 2048;
	if (module[31] != 0)
		self->channels = 2;
	lastPos = 65535;
	for (i = 0; i < 128; i++) {
		int instrAddr = module[134 + i] + (module[774 + i] << 8);
		if (instrAddr != 0 && instrAddr < lastPos)
			lastPos = instrAddr;
	}
	for (i = 0; i < 256; i++) {
		int patternAddr = module[262 + i] + (module[518 + i] << 8);
		if (patternAddr != 0 && patternAddr < lastPos)
			lastPos = patternAddr;
	}
	lastPos -= ASAPInfo_GetWord(module, 2) + 896;
	if (902 + lastPos >= moduleLen)
		return FALSE;
	do {
		if (lastPos <= 0)
			return FALSE;
		lastPos -= 17;
		c = module[918 + lastPos];
	}
	while (c == 0 || c >= 128);
	self->songs = 0;
	ASAPInfo_ParseTm2Song(self, module, 0);
	for (i = 0; i < lastPos && self->songs < 32; i += 17) {
		c = module[918 + i];
		if (c == 0 || c >= 128)
			ASAPInfo_ParseTm2Song(self, module, i + 17);
	}
	titleLen = ASAPInfo_ParseTmcTitle(title, 0, module, 39);
	titleLen = ASAPInfo_ParseTmcTitle(title, titleLen, module, 71);
	titleLen = ASAPInfo_ParseTmcTitle(title, titleLen, module, 103);
	((char *) memcpy(self->title, title + 0, titleLen))[titleLen] = '\0';
	return TRUE;
}

static void ASAPInfo_ParseTm2Song(ASAPInfo *self, unsigned char const *module, int pos)
{
	int addrToOffset = ASAPInfo_GetWord(module, 2) - 6;
	int tempo = module[36] + 1;
	int playerCalls = 0;
	int patternOffset[8];
	int blankRows[8];
	for (;;) {
		int patternRows = module[918 + pos];
		if (patternRows == 0)
			break;
		if (patternRows >= 128) {
			self->loops[self->songs] = TRUE;
			break;
		}
		{
			int ch;
			for (ch = 7; ch >= 0; ch--) {
				int pat = module[917 + pos - 2 * ch];
				patternOffset[ch] = module[262 + pat] + (module[518 + pat] << 8) - addrToOffset;
				blankRows[ch] = 0;
			}
		}
		while (--patternRows >= 0) {
			{
				int ch;
				for (ch = 7; ch >= 0; ch--) {
					if (--blankRows[ch] >= 0)
						continue;
					for (;;) {
						int i = module[patternOffset[ch]++];
						if (i == 0) {
							patternOffset[ch]++;
							break;
						}
						if (i < 64) {
							if (module[patternOffset[ch]++] >= 128)
								patternOffset[ch]++;
							break;
						}
						if (i < 128) {
							patternOffset[ch]++;
							break;
						}
						if (i == 128) {
							blankRows[ch] = module[patternOffset[ch]++];
							break;
						}
						if (i < 192)
							break;
						if (i < 208) {
							tempo = i - 191;
							continue;
						}
						if (i < 224) {
							patternOffset[ch]++;
							break;
						}
						if (i < 240) {
							patternOffset[ch] += 2;
							break;
						}
						if (i < 255) {
							blankRows[ch] = i - 240;
							break;
						}
						blankRows[ch] = 64;
						break;
					}
				}
			}
			playerCalls += tempo;
		}
		pos += 17;
	}
	ASAPInfo_AddSong(self, playerCalls);
}

static cibool ASAPInfo_ParseTmc(ASAPInfo *self, unsigned char const *module, int moduleLen)
{
	int i;
	int lastPos;
	unsigned char title[127];
	int titleLen;
	if (moduleLen < 464)
		return FALSE;
	self->type = ASAPModuleType_TMC;
	if (!ASAPInfo_ParseModule(self, module, moduleLen))
		return FALSE;
	self->channels = 2;
	i = 0;
	while (module[102 + i] == 0) {
		if (++i >= 64)
			return FALSE;
	}
	lastPos = (module[102 + i] << 8) + module[38 + i] - ASAPInfo_GetWord(module, 2) - 432;
	if (437 + lastPos >= moduleLen)
		return FALSE;
	do {
		if (lastPos <= 0)
			return FALSE;
		lastPos -= 16;
	}
	while (module[437 + lastPos] >= 128);
	self->songs = 0;
	ASAPInfo_ParseTmcSong(self, module, 0);
	for (i = 0; i < lastPos && self->songs < 32; i += 16)
		if (module[437 + i] >= 128)
			ASAPInfo_ParseTmcSong(self, module, i + 16);
	i = module[37];
	if (i < 1 || i > 4)
		return FALSE;
	self->fastplay = 312 / i;
	titleLen = ASAPInfo_ParseTmcTitle(title, 0, module, 6);
	((char *) memcpy(self->title, title + 0, titleLen))[titleLen] = '\0';
	return TRUE;
}

static void ASAPInfo_ParseTmcSong(ASAPInfo *self, unsigned char const *module, int pos)
{
	int addrToOffset = ASAPInfo_GetWord(module, 2) - 6;
	int tempo = module[36] + 1;
	int frames = 0;
	int patternOffset[8];
	int blankRows[8];
	while (module[437 + pos] < 128) {
		{
			int ch;
			for (ch = 7; ch >= 0; ch--) {
				int pat = module[437 + pos - 2 * ch];
				patternOffset[ch] = module[166 + pat] + (module[294 + pat] << 8) - addrToOffset;
				blankRows[ch] = 0;
			}
		}
		{
			int patternRows;
			for (patternRows = 64; --patternRows >= 0;) {
				{
					int ch;
					for (ch = 7; ch >= 0; ch--) {
						if (--blankRows[ch] >= 0)
							continue;
						for (;;) {
							int i = module[patternOffset[ch]++];
							if (i < 64) {
								patternOffset[ch]++;
								break;
							}
							if (i == 64) {
								i = module[patternOffset[ch]++];
								if ((i & 127) == 0)
									patternRows = 0;
								else
									tempo = (i & 127) + 1;
								if (i >= 128)
									patternOffset[ch]++;
								break;
							}
							if (i < 128) {
								i = module[patternOffset[ch]++] & 127;
								if (i == 0)
									patternRows = 0;
								else
									tempo = i + 1;
								patternOffset[ch]++;
								break;
							}
							if (i < 192)
								continue;
							blankRows[ch] = i - 191;
							break;
						}
					}
				}
				frames += tempo;
			}
		}
		pos += 16;
	}
	if (module[436 + pos] < 128)
		self->loops[self->songs] = TRUE;
	ASAPInfo_AddSong(self, frames);
}

static int ASAPInfo_ParseTmcTitle(unsigned char *title, int titleLen, unsigned char const *module, int moduleOffset)
{
	int lastOffset = moduleOffset + 29;
	while (module[lastOffset] == 32) {
		if (--lastOffset < moduleOffset)
			return titleLen;
	}
	if (titleLen > 0) {
		title[titleLen++] = 32;
		title[titleLen++] = 124;
		title[titleLen++] = 32;
	}
	while (moduleOffset <= lastOffset) {
		int c = module[moduleOffset++] & 127;
		switch (c) {
		case 20:
			c = 42;
			break;
		case 1:
		case 3:
		case 5:
		case 12:
		case 14:
		case 15:
		case 19:
			c += 96;
			break;
		case 24:
		case 26:
			c = 122;
			break;
		default:
			if (!ASAPInfo_IsValidChar(c))
				c = 32;
			break;
		}
		title[titleLen++] = c;
	}
	return titleLen;
}

cibool ASAPInfo_SetAuthor(ASAPInfo *self, const char *value)
{
	if (!ASAPInfo_CheckValidText(value))
		return FALSE;
	strcpy(self->author, value);
	return TRUE;
}

cibool ASAPInfo_SetDate(ASAPInfo *self, const char *value)
{
	if (!ASAPInfo_CheckValidText(value))
		return FALSE;
	strcpy(self->date, value);
	return TRUE;
}

cibool ASAPInfo_SetDuration(ASAPInfo *self, int song, int duration)
{
	if (song < 0 || song >= self->songs)
		return FALSE;
	self->durations[song] = duration;
	return TRUE;
}

cibool ASAPInfo_SetLoop(ASAPInfo *self, int song, cibool loop)
{
	if (song < 0 || song >= self->songs)
		return FALSE;
	self->loops[song] = loop;
	return TRUE;
}

cibool ASAPInfo_SetMusicAddress(ASAPInfo *self, int address)
{
	if (address < 0 || address >= 65535)
		return FALSE;
	self->music = address;
	return TRUE;
}

cibool ASAPInfo_SetTitle(ASAPInfo *self, const char *value)
{
	if (!ASAPInfo_CheckValidText(value))
		return FALSE;
	strcpy(self->title, value);
	return TRUE;
}

static cibool ASAPInfo_ValidateFc(unsigned char const *module, int moduleLen)
{
	if (moduleLen < 899)
		return FALSE;
	if (module[0] != 38 || module[1] != 35)
		return FALSE;
	return TRUE;
}

static cibool ASAPInfo_ValidateRmt(unsigned char const *module, int moduleLen)
{
	if (moduleLen < 48)
		return FALSE;
	if (module[6] != 82 || module[7] != 77 || module[8] != 84 || module[13] != 1)
		return FALSE;
	return TRUE;
}

static cibool ASAPInfo_ValidateSap(unsigned char const *module, int moduleLen)
{
	return moduleLen >= 30 && ASAPInfo_HasStringAt(module, 0, "SAP\r\n");
}

int ASAPWriter_DurationToString(unsigned char *result, int value)
{
	if (!ASAPWriter_SecondsToString(result, 0, value))
		return 0;
	value %= 1000;
	if (value == 0)
		return 5;
	result[5] = 46;
	ASAPWriter_TwoDigitsToString(result, 6, value / 10);
	value %= 10;
	if (value == 0)
		return 8;
	result[8] = 48 + value;
	return 9;
}

void ASAPWriter_EnumSaveExts(StringConsumer output, ASAPInfo const *info, unsigned char const *module, int moduleLen)
{
	switch (info->type) {
		const char *ext;
	case ASAPModuleType_SAP_B:
	case ASAPModuleType_SAP_C:
		output.func(output.obj, "sap");
		ext = ASAPInfo_GetOriginalModuleExt(info, module, moduleLen);
		if (ext != NULL)
			output.func(output.obj, ext);
		output.func(output.obj, "xex");
		break;
	case ASAPModuleType_SAP_D:
		output.func(output.obj, "sap");
		if (info->fastplay == 312)
			output.func(output.obj, "xex");
		break;
	case ASAPModuleType_SAP_S:
		output.func(output.obj, "sap");
		break;
	default:
		output.func(output.obj, ASAPInfo_GetOriginalModuleExt(info, module, moduleLen));
		output.func(output.obj, "sap");
		output.func(output.obj, "xex");
		break;
	}
}

static int ASAPWriter_FormatXexInfoText(unsigned char *dest, int destLen, int endColumn, const char *src, cibool author)
{
	int srcLen = (int) strlen(src);
	{
		int srcOffset;
		for (srcOffset = 0; srcOffset < srcLen;) {
			int c = src[srcOffset++];
			if (c == 32) {
				int wordLen;
				if (author && srcOffset < srcLen && src[srcOffset] == 38) {
					int authorLen;
					for (authorLen = 1; srcOffset + authorLen < srcLen; authorLen++) {
						if (src[srcOffset + authorLen] == 32 && srcOffset + authorLen + 1 < srcLen && src[srcOffset + authorLen + 1] == 38)
							break;
					}
					if (authorLen <= 32 && destLen % 32 + 1 + authorLen > 32) {
						destLen = ASAPWriter_PadXexInfo(dest, destLen, 1);
						continue;
					}
				}
				for (wordLen = 0; srcOffset + wordLen < srcLen && src[srcOffset + wordLen] != 32; wordLen++) {
				}
				if (wordLen <= 32 && destLen % 32 + 1 + wordLen > 32) {
					destLen = ASAPWriter_PadXexInfo(dest, destLen, 0);
					continue;
				}
			}
			dest[destLen++] = c;
		}
	}
	return ASAPWriter_PadXexInfo(dest, destLen, endColumn);
}

static int ASAPWriter_PadXexInfo(unsigned char *dest, int offset, int endColumn)
{
	while (offset % 32 != endColumn)
		dest[offset++] = 32;
	return offset;
}

static cibool ASAPWriter_SecondsToString(unsigned char *result, int offset, int value)
{
	if (value < 0 || value >= 6000000)
		return FALSE;
	value /= 1000;
	ASAPWriter_TwoDigitsToString(result, offset, value / 60);
	result[offset + 2] = 58;
	ASAPWriter_TwoDigitsToString(result, offset + 3, value % 60);
	return TRUE;
}

static void ASAPWriter_TwoDigitsToString(unsigned char *result, int offset, int value)
{
	result[offset] = 48 + value / 10;
	result[offset + 1] = 48 + value % 10;
}

cibool ASAPWriter_Write(const char *targetFilename, ByteWriter w, ASAPInfo const *info, unsigned char const *module, int moduleLen, cibool tag)
{
	int destExt = ASAPInfo_GetPackedExt(targetFilename);
	switch (destExt) {
		const char *possibleExt;
	case 7364979:
		return ASAPWriter_WriteExecutable(w, NULL, info, module, moduleLen);
	case 7890296:
		{
			FlashPack flashPack;
			ByteWriter resultWriter;
			int initAndPlayer[2];
			FlashPack_Construct(&flashPack);
			resultWriter = w;
			
					w.obj = &flashPack;
					w.func = (void (*)(void *, int)) FlashPack_LoadByte;
				;
			if (!ASAPWriter_WriteExecutable(w, initAndPlayer, info, module, moduleLen))
				return FALSE;
			switch (info->type) {
			case ASAPModuleType_SAP_D:
				if (info->fastplay != 312)
					return FALSE;
				ASAPWriter_WriteBytes(w, CiBinaryResource_xexd_obx, 2, 117);
				ASAPWriter_WriteWord(w, initAndPlayer[0]);
				if (initAndPlayer[1] < 0) {
					w.func(w.obj, 96);
					w.func(w.obj, 96);
					w.func(w.obj, 96);
				}
				else {
					w.func(w.obj, 76);
					ASAPWriter_WriteWord(w, initAndPlayer[1]);
				}
				w.func(w.obj, info->defaultSong);
				break;
			case ASAPModuleType_SAP_S:
				return FALSE;
			default:
				ASAPWriter_WriteBytes(w, CiBinaryResource_xexb_obx, 2, 183);
				ASAPWriter_WriteWord(w, initAndPlayer[0]);
				w.func(w.obj, 76);
				ASAPWriter_WriteWord(w, initAndPlayer[1]);
				w.func(w.obj, info->defaultSong);
				w.func(w.obj, info->fastplay & 1);
				w.func(w.obj, (info->fastplay >> 1) % 156);
				w.func(w.obj, (info->fastplay >> 1) % 131);
				w.func(w.obj, info->fastplay / 312);
				w.func(w.obj, info->fastplay / 262);
				break;
			}
			if (tag)
				ASAPWriter_WriteXexInfo(w, info);
			ASAPWriter_WriteWord(w, 736);
			ASAPWriter_WriteWord(w, 737);
			ASAPWriter_WriteWord(w, tag ? 256 : 292);
			return FlashPack_Compress(&flashPack, resultWriter);
		}
	default:
		possibleExt = ASAPInfo_GetOriginalModuleExt(info, module, moduleLen);
		if (possibleExt != NULL) {
			int packedPossibleExt = (possibleExt[0] + (possibleExt[1] << 8) + (possibleExt[2] << 16)) | 2105376;
			if (destExt == packedPossibleExt || (destExt == 3698036 && packedPossibleExt == 6516084)) {
				return ASAPWriter_WriteNative(w, info, module, moduleLen);
			}
		}
		return FALSE;
	}
}

static void ASAPWriter_WriteBytes(ByteWriter w, unsigned char const *array, int startIndex, int endIndex)
{
	while (startIndex < endIndex)
		w.func(w.obj, array[startIndex++]);
}

static void ASAPWriter_WriteCmcInit(ByteWriter w, int *initAndPlayer, ASAPInfo const *info)
{
	if (initAndPlayer == NULL)
		return;
	ASAPWriter_WriteWord(w, 4064);
	ASAPWriter_WriteWord(w, 4080);
	w.func(w.obj, 72);
	w.func(w.obj, 162);
	w.func(w.obj, info->music & 255);
	w.func(w.obj, 160);
	w.func(w.obj, info->music >> 8);
	w.func(w.obj, 169);
	w.func(w.obj, 112);
	w.func(w.obj, 32);
	ASAPWriter_WriteWord(w, initAndPlayer[1] + 3);
	ASAPWriter_WritePlaTaxLda0(w);
	w.func(w.obj, 76);
	ASAPWriter_WriteWord(w, initAndPlayer[1] + 3);
	initAndPlayer[0] = 4064;
	initAndPlayer[1] += 6;
}

static void ASAPWriter_WriteDec(ByteWriter w, int value)
{
	if (value >= 10) {
		ASAPWriter_WriteDec(w, value / 10);
		value %= 10;
	}
	w.func(w.obj, 48 + value);
}

static void ASAPWriter_WriteDecSapTag(ByteWriter w, const char *tag, int value)
{
	ASAPWriter_WriteString(w, tag);
	ASAPWriter_WriteDec(w, value);
	w.func(w.obj, 13);
	w.func(w.obj, 10);
}

static cibool ASAPWriter_WriteExecutable(ByteWriter w, int *initAndPlayer, ASAPInfo const *info, unsigned char const *module, int moduleLen)
{
	unsigned char const *playerRoutine = ASAP6502_GetPlayerRoutine(info);
	int player = -1;
	int playerLastByte = -1;
	int startAddr;
	if (playerRoutine != NULL) {
		player = ASAPInfo_GetWord(playerRoutine, 2);
		playerLastByte = ASAPInfo_GetWord(playerRoutine, 4);
		if (info->music <= playerLastByte)
			return FALSE;
	}
	switch (info->type) {
		static const int tmcPlayerOffset[4] = { 3, -9, -10, -10 };
		int player2;
		static const int tmcInitOffset[4] = { -14, -16, -17, -17 };
	case ASAPModuleType_SAP_B:
		ASAPWriter_WriteExecutableFromSap(w, initAndPlayer, info, 66, module, moduleLen);
		break;
	case ASAPModuleType_SAP_C:
		ASAPWriter_WriteExecutableFromSap(w, initAndPlayer, info, 67, module, moduleLen);
		ASAPWriter_WriteCmcInit(w, initAndPlayer, info);
		break;
	case ASAPModuleType_SAP_D:
		ASAPWriter_WriteExecutableFromSap(w, initAndPlayer, info, 68, module, moduleLen);
		break;
	case ASAPModuleType_SAP_S:
		ASAPWriter_WriteExecutableFromSap(w, initAndPlayer, info, 83, module, moduleLen);
		break;
	case ASAPModuleType_CMC:
	case ASAPModuleType_CM3:
	case ASAPModuleType_CMR:
	case ASAPModuleType_CMS:
		ASAPWriter_WriteExecutableHeader(w, initAndPlayer, info, 67, -1, player);
		w.func(w.obj, 255);
		w.func(w.obj, 255);
		ASAPWriter_WriteBytes(w, module, 2, moduleLen);
		ASAPWriter_WriteBytes(w, playerRoutine, 2, playerLastByte - player + 7);
		ASAPWriter_WriteCmcInit(w, initAndPlayer, info);
		break;
	case ASAPModuleType_DLT:
		startAddr = ASAPWriter_WriteExecutableHeaderForSongPos(w, initAndPlayer, info, player, 5, 7, 259);
		if (moduleLen == 11270) {
			ASAPWriter_WriteBytes(w, module, 0, 4);
			ASAPWriter_WriteWord(w, 19456);
			ASAPWriter_WriteBytes(w, module, 6, moduleLen);
			w.func(w.obj, 0);
		}
		else
			ASAPWriter_WriteBytes(w, module, 0, moduleLen);
		ASAPWriter_WriteWord(w, startAddr);
		ASAPWriter_WriteWord(w, playerLastByte);
		if (info->songs != 1) {
			ASAPWriter_WriteBytes(w, info->songPos, 0, info->songs);
			w.func(w.obj, 170);
			w.func(w.obj, 188);
			ASAPWriter_WriteWord(w, startAddr);
		}
		else {
			w.func(w.obj, 160);
			w.func(w.obj, 0);
		}
		w.func(w.obj, 76);
		ASAPWriter_WriteWord(w, player + 256);
		ASAPWriter_WriteBytes(w, playerRoutine, 6, playerLastByte - player + 7);
		break;
	case ASAPModuleType_MPT:
		startAddr = ASAPWriter_WriteExecutableHeaderForSongPos(w, initAndPlayer, info, player, 13, 17, 3);
		ASAPWriter_WriteBytes(w, module, 0, moduleLen);
		ASAPWriter_WriteWord(w, startAddr);
		ASAPWriter_WriteWord(w, playerLastByte);
		if (info->songs != 1) {
			ASAPWriter_WriteBytes(w, info->songPos, 0, info->songs);
			w.func(w.obj, 72);
		}
		w.func(w.obj, 160);
		w.func(w.obj, info->music & 255);
		w.func(w.obj, 162);
		w.func(w.obj, info->music >> 8);
		w.func(w.obj, 169);
		w.func(w.obj, 0);
		w.func(w.obj, 32);
		ASAPWriter_WriteWord(w, player);
		if (info->songs != 1) {
			w.func(w.obj, 104);
			w.func(w.obj, 168);
			w.func(w.obj, 190);
			ASAPWriter_WriteWord(w, startAddr);
		}
		else {
			w.func(w.obj, 162);
			w.func(w.obj, 0);
		}
		w.func(w.obj, 169);
		w.func(w.obj, 2);
		ASAPWriter_WriteBytes(w, playerRoutine, 6, playerLastByte - player + 7);
		break;
	case ASAPModuleType_RMT:
		ASAPWriter_WriteExecutableHeader(w, initAndPlayer, info, 66, 3200, 1539);
		ASAPWriter_WriteBytes(w, module, 0, ASAPInfo_GetWord(module, 4) - info->music + 7);
		ASAPWriter_WriteWord(w, 3200);
		if (info->songs != 1) {
			ASAPWriter_WriteWord(w, 3210 + info->songs);
			w.func(w.obj, 168);
			w.func(w.obj, 185);
			ASAPWriter_WriteWord(w, 3211);
		}
		else {
			ASAPWriter_WriteWord(w, 3208);
			w.func(w.obj, 169);
			w.func(w.obj, 0);
		}
		w.func(w.obj, 162);
		w.func(w.obj, info->music & 255);
		w.func(w.obj, 160);
		w.func(w.obj, info->music >> 8);
		w.func(w.obj, 76);
		ASAPWriter_WriteWord(w, 1536);
		if (info->songs != 1)
			ASAPWriter_WriteBytes(w, info->songPos, 0, info->songs);
		ASAPWriter_WriteBytes(w, playerRoutine, 2, playerLastByte - player + 7);
		break;
	case ASAPModuleType_TMC:
		player2 = player + tmcPlayerOffset[module[37] - 1];
		startAddr = player2 + tmcInitOffset[module[37] - 1];
		if (info->songs != 1)
			startAddr -= 3;
		ASAPWriter_WriteExecutableHeader(w, initAndPlayer, info, 66, startAddr, player2);
		ASAPWriter_WriteBytes(w, module, 0, moduleLen);
		ASAPWriter_WriteWord(w, startAddr);
		ASAPWriter_WriteWord(w, playerLastByte);
		if (info->songs != 1)
			w.func(w.obj, 72);
		w.func(w.obj, 160);
		w.func(w.obj, info->music & 255);
		w.func(w.obj, 162);
		w.func(w.obj, info->music >> 8);
		w.func(w.obj, 169);
		w.func(w.obj, 112);
		w.func(w.obj, 32);
		ASAPWriter_WriteWord(w, player);
		if (info->songs != 1)
			ASAPWriter_WritePlaTaxLda0(w);
		else {
			w.func(w.obj, 169);
			w.func(w.obj, 96);
		}
		switch (module[37]) {
		case 2:
			w.func(w.obj, 6);
			w.func(w.obj, 0);
			w.func(w.obj, 76);
			ASAPWriter_WriteWord(w, player);
			w.func(w.obj, 165);
			w.func(w.obj, 0);
			w.func(w.obj, 230);
			w.func(w.obj, 0);
			w.func(w.obj, 74);
			w.func(w.obj, 144);
			w.func(w.obj, 5);
			w.func(w.obj, 176);
			w.func(w.obj, 6);
			break;
		case 3:
		case 4:
			w.func(w.obj, 160);
			w.func(w.obj, 1);
			w.func(w.obj, 132);
			w.func(w.obj, 0);
			w.func(w.obj, 208);
			w.func(w.obj, 10);
			w.func(w.obj, 198);
			w.func(w.obj, 0);
			w.func(w.obj, 208);
			w.func(w.obj, 12);
			w.func(w.obj, 160);
			w.func(w.obj, module[37]);
			w.func(w.obj, 132);
			w.func(w.obj, 0);
			w.func(w.obj, 208);
			w.func(w.obj, 3);
			break;
		}
		ASAPWriter_WriteBytes(w, playerRoutine, 6, playerLastByte - player + 7);
		break;
	case ASAPModuleType_TM2:
		ASAPWriter_WriteExecutableHeader(w, initAndPlayer, info, 66, 4992, 2051);
		ASAPWriter_WriteBytes(w, module, 0, moduleLen);
		ASAPWriter_WriteWord(w, 4992);
		if (info->songs != 1) {
			ASAPWriter_WriteWord(w, 5008);
			w.func(w.obj, 72);
		}
		else
			ASAPWriter_WriteWord(w, 5006);
		w.func(w.obj, 160);
		w.func(w.obj, info->music & 255);
		w.func(w.obj, 162);
		w.func(w.obj, info->music >> 8);
		w.func(w.obj, 169);
		w.func(w.obj, 112);
		w.func(w.obj, 32);
		ASAPWriter_WriteWord(w, 2048);
		if (info->songs != 1)
			ASAPWriter_WritePlaTaxLda0(w);
		else {
			w.func(w.obj, 169);
			w.func(w.obj, 0);
			w.func(w.obj, 170);
		}
		w.func(w.obj, 76);
		ASAPWriter_WriteWord(w, 2048);
		ASAPWriter_WriteBytes(w, playerRoutine, 2, playerLastByte - player + 7);
		break;
	case ASAPModuleType_FC:
		ASAPWriter_WriteExecutableHeader(w, initAndPlayer, info, 66, player, player + 3);
		ASAPWriter_WriteWord(w, 65535);
		ASAPWriter_WriteWord(w, info->music);
		ASAPWriter_WriteWord(w, info->music + moduleLen - 1);
		ASAPWriter_WriteBytes(w, module, 0, moduleLen);
		ASAPWriter_WriteBytes(w, playerRoutine, 2, playerLastByte - player + 7);
		break;
	}
	return TRUE;
}

static void ASAPWriter_WriteExecutableFromSap(ByteWriter w, int *initAndPlayer, ASAPInfo const *info, int type, unsigned char const *module, int moduleLen)
{
	ASAPWriter_WriteExecutableHeader(w, initAndPlayer, info, type, info->init, info->player);
	ASAPWriter_WriteBytes(w, module, info->headerLen, moduleLen);
}

static void ASAPWriter_WriteExecutableHeader(ByteWriter w, int *initAndPlayer, ASAPInfo const *info, int type, int init, int player)
{
	if (initAndPlayer == NULL)
		ASAPWriter_WriteSapHeader(w, info, type, init, player);
	else {
		initAndPlayer[0] = init;
		initAndPlayer[1] = player;
	}
}

static int ASAPWriter_WriteExecutableHeaderForSongPos(ByteWriter w, int *initAndPlayer, ASAPInfo const *info, int player, int codeForOneSong, int codeForManySongs, int playerOffset)
{
	if (info->songs != 1) {
		ASAPWriter_WriteExecutableHeader(w, initAndPlayer, info, 66, player - codeForManySongs, player + playerOffset);
		return player - codeForManySongs - info->songs;
	}
	ASAPWriter_WriteExecutableHeader(w, initAndPlayer, info, 66, player - codeForOneSong, player + playerOffset);
	return player - codeForOneSong;
}

static void ASAPWriter_WriteHexSapTag(ByteWriter w, const char *tag, int value)
{
	if (value < 0)
		return;
	ASAPWriter_WriteString(w, tag);
	{
		int i;
		for (i = 12; i >= 0; i -= 4) {
			int digit = (value >> i) & 15;
			w.func(w.obj, digit + (digit < 10 ? 48 : 55));
		}
	}
	w.func(w.obj, 13);
	w.func(w.obj, 10);
}

static cibool ASAPWriter_WriteNative(ByteWriter w, ASAPInfo const *info, unsigned char const *module, int moduleLen)
{
	int diff;
	switch (info->type) {
		int offset;
		int blockLen;
		int music;
		int patternLowAddress;
		int pointersAndInstrumentsLen;
		int patterns;
		int songOffset;
		int songEnd;
	case ASAPModuleType_SAP_B:
	case ASAPModuleType_SAP_C:
		offset = ASAPInfo_GetRmtSapOffset(info, module, moduleLen);
		if (offset > 0) {
			w.func(w.obj, 255);
			w.func(w.obj, 255);
			ASAPWriter_WriteBytes(w, module, offset, moduleLen);
			break;
		}
		blockLen = ASAPInfo_GetWord(module, info->headerLen + 4) - ASAPInfo_GetWord(module, info->headerLen + 2) + 7;
		if (blockLen < 7 || info->headerLen + blockLen >= moduleLen)
			return FALSE;
		if (info->init == 1024 && info->player == 1027)
			ASAPWriter_WriteBytes(w, module, info->headerLen + 6, info->headerLen + blockLen);
		else
			ASAPWriter_WriteBytes(w, module, info->headerLen, info->headerLen + blockLen);
		break;
	case ASAPModuleType_CMC:
	case ASAPModuleType_CM3:
	case ASAPModuleType_CMR:
	case ASAPModuleType_CMS:
		if ((diff = ASAPWriter_WriteNativeHeader(w, info, module)) == -1)
			return FALSE;
		ASAPWriter_WriteBytes(w, module, 6, 26);
		ASAPWriter_WriteRelocatedLowHigh(w, diff, module, 26, 64);
		ASAPWriter_WriteBytes(w, module, 154, moduleLen);
		break;
	case ASAPModuleType_DLT:
		if ((diff = ASAPWriter_WriteNativeHeader(w, info, module)) == -1)
			return FALSE;
		ASAPWriter_WriteBytes(w, module, 6, moduleLen);
		break;
	case ASAPModuleType_MPT:
		if ((diff = ASAPWriter_WriteNativeHeader(w, info, module)) == -1)
			return FALSE;
		ASAPWriter_WriteRelocatedWords(w, diff, module, 6, 192);
		ASAPWriter_WriteBytes(w, module, 198, 454);
		ASAPWriter_WriteRelocatedLowHigh(w, diff, module, 454, 4);
		ASAPWriter_WriteBytes(w, module, 462, moduleLen);
		break;
	case ASAPModuleType_RMT:
		if ((diff = ASAPWriter_WriteNativeHeader(w, info, module)) == -1)
			return FALSE;
		ASAPWriter_WriteBytes(w, module, 6, 14);
		music = ASAPInfo_GetWord(module, 2);
		patternLowAddress = ASAPInfo_GetWord(module, 16);
		pointersAndInstrumentsLen = patternLowAddress - music - 8;
		ASAPWriter_WriteRelocatedWords(w, diff, module, 14, pointersAndInstrumentsLen);
		patterns = ASAPInfo_GetWord(module, 18) - patternLowAddress;
		ASAPWriter_WriteRelocatedLowHigh(w, diff, module, 14 + pointersAndInstrumentsLen, patterns);
		songOffset = 6 + ASAPInfo_GetWord(module, 20) - music;
		ASAPWriter_WriteBytes(w, module, 14 + pointersAndInstrumentsLen + (patterns << 1), songOffset);
		songEnd = 7 + ASAPInfo_GetWord(module, 4) - music;
		while (songOffset + 3 < songEnd) {
			int nextSongOffset = songOffset + module[9] - 48;
			if (module[songOffset] == 254) {
				w.func(w.obj, 254);
				w.func(w.obj, module[songOffset + 1]);
				ASAPWriter_WriteWord(w, ASAPInfo_GetWord(module, songOffset + 2) + diff);
				songOffset += 4;
			}
			if (nextSongOffset > songEnd)
				nextSongOffset = songEnd;
			ASAPWriter_WriteBytes(w, module, songOffset, nextSongOffset);
			songOffset = nextSongOffset;
		}
		ASAPWriter_WriteBytes(w, module, songOffset, songEnd);
		if (moduleLen >= songEnd + 5) {
			ASAPWriter_WriteRelocatedWords(w, diff, module, songEnd, 4);
			ASAPWriter_WriteBytes(w, module, songEnd + 4, moduleLen);
		}
		break;
	case ASAPModuleType_TMC:
		if ((diff = ASAPWriter_WriteNativeHeader(w, info, module)) == -1)
			return FALSE;
		ASAPWriter_WriteBytes(w, module, 6, 38);
		ASAPWriter_WriteRelocatedLowHigh(w, diff, module, 38, 64);
		ASAPWriter_WriteRelocatedLowHigh(w, diff, module, 166, 128);
		ASAPWriter_WriteBytes(w, module, 422, moduleLen);
		break;
	case ASAPModuleType_TM2:
		if ((diff = ASAPWriter_WriteNativeHeader(w, info, module)) == -1)
			return FALSE;
		ASAPWriter_WriteBytes(w, module, 6, 134);
		ASAPWriter_WriteRelocatedBytes(w, diff, module, 134, 774, 128, 0);
		ASAPWriter_WriteRelocatedLowHigh(w, diff, module, 262, 256);
		ASAPWriter_WriteRelocatedBytes(w, diff, module, 134, 774, 128, 8);
		ASAPWriter_WriteBytes(w, module, 902, moduleLen);
		break;
	case ASAPModuleType_FC:
		ASAPWriter_WriteBytes(w, module, 0, moduleLen);
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

static int ASAPWriter_WriteNativeHeader(ByteWriter w, ASAPInfo const *info, unsigned char const *module)
{
	int diff = info->music - ASAPInfo_GetWord(module, 2);
	int last = ASAPInfo_GetWord(module, 4) + diff;
	if (last > 65535)
		return -1;
	w.func(w.obj, 255);
	w.func(w.obj, 255);
	ASAPWriter_WriteWord(w, info->music);
	ASAPWriter_WriteWord(w, last);
	return diff;
}

static void ASAPWriter_WritePlaTaxLda0(ByteWriter w)
{
	w.func(w.obj, 104);
	w.func(w.obj, 170);
	w.func(w.obj, 169);
	w.func(w.obj, 0);
}

static void ASAPWriter_WriteRelocatedBytes(ByteWriter w, int diff, unsigned char const *module, int lowOffset, int highOffset, int len, int shift)
{
	{
		int i;
		for (i = 0; i < len; i++) {
			int address = module[lowOffset + i] + (module[highOffset + i] << 8);
			if (address != 0 && address != 65535)
				address += diff;
			w.func(w.obj, (address >> shift) & 255);
		}
	}
}

static void ASAPWriter_WriteRelocatedLowHigh(ByteWriter w, int diff, unsigned char const *module, int lowOffset, int len)
{
	ASAPWriter_WriteRelocatedBytes(w, diff, module, lowOffset, lowOffset + len, len, 0);
	ASAPWriter_WriteRelocatedBytes(w, diff, module, lowOffset, lowOffset + len, len, 8);
}

static void ASAPWriter_WriteRelocatedWords(ByteWriter w, int diff, unsigned char const *module, int offset, int len)
{
	{
		int i;
		for (i = 0; i < len; i += 2) {
			int address = module[offset + i] + (module[offset + i + 1] << 8);
			if (address != 0 && address != 65535)
				address += diff;
			ASAPWriter_WriteWord(w, address);
		}
	}
}

static void ASAPWriter_WriteSapHeader(ByteWriter w, ASAPInfo const *info, int type, int init, int player)
{
	ASAPWriter_WriteString(w, "SAP\r\n");
	ASAPWriter_WriteTextSapTag(w, "AUTHOR ", info->author);
	ASAPWriter_WriteTextSapTag(w, "NAME ", info->title);
	ASAPWriter_WriteTextSapTag(w, "DATE ", info->date);
	if (info->songs > 1) {
		ASAPWriter_WriteDecSapTag(w, "SONGS ", info->songs);
		if (info->defaultSong > 0)
			ASAPWriter_WriteDecSapTag(w, "DEFSONG ", info->defaultSong);
	}
	if (info->channels > 1)
		ASAPWriter_WriteString(w, "STEREO\r\n");
	if (info->ntsc)
		ASAPWriter_WriteString(w, "NTSC\r\n");
	ASAPWriter_WriteString(w, "TYPE ");
	w.func(w.obj, type);
	w.func(w.obj, 13);
	w.func(w.obj, 10);
	if (info->fastplay != 312 || info->ntsc)
		ASAPWriter_WriteDecSapTag(w, "FASTPLAY ", info->fastplay);
	if (type == 67)
		ASAPWriter_WriteHexSapTag(w, "MUSIC ", info->music);
	ASAPWriter_WriteHexSapTag(w, "INIT ", init);
	ASAPWriter_WriteHexSapTag(w, "PLAYER ", player);
	ASAPWriter_WriteHexSapTag(w, "COVOX ", info->covoxAddr);
	{
		int song;
		for (song = 0; song < info->songs; song++) {
			unsigned char s[9];
			if (info->durations[song] < 0)
				break;
			ASAPWriter_WriteString(w, "TIME ");
			ASAPWriter_WriteBytes(w, s, 0, ASAPWriter_DurationToString(s, info->durations[song]));
			if (info->loops[song])
				ASAPWriter_WriteString(w, " LOOP");
			w.func(w.obj, 13);
			w.func(w.obj, 10);
		}
	}
}

static void ASAPWriter_WriteString(ByteWriter w, const char *s)
{
	int n = (int) strlen(s);
	{
		int i;
		for (i = 0; i < n; i++)
			w.func(w.obj, s[i]);
	}
}

static void ASAPWriter_WriteTextSapTag(ByteWriter w, const char *tag, const char *value)
{
	ASAPWriter_WriteString(w, tag);
	w.func(w.obj, 34);
	if (value[0] == '\0')
		value = "<?>";
	ASAPWriter_WriteString(w, value);
	w.func(w.obj, 34);
	w.func(w.obj, 13);
	w.func(w.obj, 10);
}

static void ASAPWriter_WriteWord(ByteWriter w, int value)
{
	w.func(w.obj, value & 255);
	w.func(w.obj, (value >> 8) & 255);
}

static void ASAPWriter_WriteXexInfo(ByteWriter w, ASAPInfo const *info)
{
	unsigned char title[256];
	int titleLen = ASAPWriter_FormatXexInfoText(title, 0, 0, info->title[0] == '\0' ? "(untitled)" : info->title, FALSE);
	unsigned char author[256];
	int authorLen;
	unsigned char other[256];
	int otherLen;
	int duration;
	int totalCharacters;
	int totalLines;
	int otherAddress;
	int titleAddress;
	if (info->author[0] != '\0') {
		author[0] = 98;
		author[1] = 121;
		author[2] = 32;
		authorLen = ASAPWriter_FormatXexInfoText(author, 3, 0, info->author, TRUE);
	}
	else
		authorLen = 0;
	otherLen = ASAPWriter_FormatXexInfoText(other, 0, 19, info->date, FALSE);
	otherLen = ASAPWriter_FormatXexInfoText(other, otherLen, 27, info->channels > 1 ? " STEREO" : "   MONO", FALSE);
	duration = info->durations[info->defaultSong];
	if (duration > 0 && ASAPWriter_SecondsToString(other, otherLen, duration + 999))
		otherLen += 5;
	else
		otherLen = ASAPWriter_PadXexInfo(other, otherLen, 0);
	totalCharacters = titleLen + authorLen + otherLen;
	totalLines = totalCharacters / 32;
	otherAddress = 64592 - otherLen;
	titleAddress = otherAddress - authorLen - 8 - titleLen;
	ASAPWriter_WriteWord(w, titleAddress);
	ASAPWriter_WriteBytes(w, CiBinaryResource_xexinfo_obx, 4, 6);
	ASAPWriter_WriteBytes(w, title, 0, titleLen);
	{
		int i;
		for (i = 0; i < 8; i++)
			w.func(w.obj, 85);
	}
	ASAPWriter_WriteBytes(w, author, 0, authorLen);
	ASAPWriter_WriteBytes(w, other, 0, otherLen);
	{
		int i;
		for (i = totalLines; i < 26; i++)
			w.func(w.obj, 112);
	}
	w.func(w.obj, 48);
	ASAPWriter_WriteXexInfoTextDl(w, titleAddress, titleLen, titleLen - 32);
	w.func(w.obj, 8);
	w.func(w.obj, 0);
	{
		int i;
		for (i = 0; i < authorLen; i += 32)
			w.func(w.obj, 2);
	}
	w.func(w.obj, 16);
	{
		int i;
		for (i = 0; i < otherLen; i += 32)
			w.func(w.obj, 2);
	}
	ASAPWriter_WriteBytes(w, CiBinaryResource_xexinfo_obx, 6, 178);
}

static void ASAPWriter_WriteXexInfoTextDl(ByteWriter w, int address, int len, int verticalScrollAt)
{
	w.func(w.obj, verticalScrollAt == 0 ? 98 : 66);
	ASAPWriter_WriteWord(w, address);
	{
		int i;
		for (i = 32; i < len; i += 32)
			w.func(w.obj, i == verticalScrollAt ? 34 : 2);
	}
}

static void Cpu6502_DoFrame(Cpu6502 *self, ASAP *asap, int cycleLimit)
{
	int pc = self->pc;
	int nz = self->nz;
	int a = self->a;
	int x = self->x;
	int y = self->y;
	int c = self->c;
	int s = self->s;
	int vdi = self->vdi;
	while (asap->cycle < cycleLimit) {
		int data;
		static const int opcodeCycles[256] = { 7, 6, 2, 8, 3, 3, 5, 5, 3, 2, 2, 2, 4, 4, 6, 6,
			2, 5, 2, 8, 4, 4, 6, 6, 2, 4, 2, 7, 4, 4, 7, 7,
			6, 6, 2, 8, 3, 3, 5, 5, 4, 2, 2, 2, 4, 4, 6, 6,
			2, 5, 2, 8, 4, 4, 6, 6, 2, 4, 2, 7, 4, 4, 7, 7,
			6, 6, 2, 8, 3, 3, 5, 5, 3, 2, 2, 2, 3, 4, 6, 6,
			2, 5, 2, 8, 4, 4, 6, 6, 2, 4, 2, 7, 4, 4, 7, 7,
			6, 6, 2, 8, 3, 3, 5, 5, 4, 2, 2, 2, 5, 4, 6, 6,
			2, 5, 2, 8, 4, 4, 6, 6, 2, 4, 2, 7, 4, 4, 7, 7,
			2, 6, 2, 6, 3, 3, 3, 3, 2, 2, 2, 2, 4, 4, 4, 4,
			2, 6, 2, 6, 4, 4, 4, 4, 2, 5, 2, 5, 5, 5, 5, 5,
			2, 6, 2, 6, 3, 3, 3, 3, 2, 2, 2, 2, 4, 4, 4, 4,
			2, 5, 2, 5, 4, 4, 4, 4, 2, 4, 2, 4, 4, 4, 4, 4,
			2, 6, 2, 8, 3, 3, 5, 5, 2, 2, 2, 2, 4, 4, 6, 6,
			2, 5, 2, 8, 4, 4, 6, 6, 2, 4, 2, 7, 4, 4, 7, 7,
			2, 6, 2, 8, 3, 3, 5, 5, 2, 2, 2, 2, 4, 4, 6, 6,
			2, 5, 2, 8, 4, 4, 6, 6, 2, 4, 2, 7, 4, 4, 7, 7 };
		int addr;
		if (asap->cycle >= asap->nextEventCycle) {
			self->pc = pc;
			self->s = s;
			ASAP_HandleEvent(asap);
			pc = self->pc;
			s = self->s;
			if ((vdi & 4) == 0 && asap->pokeys.irqst != 255) {
				asap->memory[256 + s] = pc >> 8;
				s = (s - 1) & 255;
				asap->memory[256 + s] = (unsigned char) pc;
				s = (s - 1) & 255;
				asap->memory[256 + s] = ((nz | (nz >> 1)) & 128) + vdi + ((nz & 255) == 0 ? 2 : 0) + c + 32;
				s = (s - 1) & 255;
				vdi |= 4;
				pc = asap->memory[65534] + (asap->memory[65535] << 8);
				asap->cycle += 7;
			}
		}
		data = asap->memory[pc++];
		asap->cycle += opcodeCycles[data];
		switch (data) {
		case 0:
			pc++;
			asap->memory[256 + s] = pc >> 8;
			s = (s - 1) & 255;
			asap->memory[256 + s] = (unsigned char) pc;
			s = (s - 1) & 255;
			asap->memory[256 + s] = ((nz | (nz >> 1)) & 128) + vdi + ((nz & 255) == 0 ? 2 : 0) + c + 48;
			s = (s - 1) & 255;
			vdi |= 4;
			pc = asap->memory[65534] + (asap->memory[65535] << 8);
			break;
		case 1:
			addr = (asap->memory[pc++] + x) & 255;
			addr = asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8);
			nz = a |= (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 2:
		case 18:
		case 34:
		case 50:
		case 66:
		case 82:
		case 98:
		case 114:
		case 146:
		case 178:
		case 210:
		case 242:
			pc--;
			asap->cycle = asap->nextEventCycle;
			break;
		case 5:
			addr = asap->memory[pc++];
			nz = a |= asap->memory[addr];
			break;
		case 6:
			addr = asap->memory[pc++];
			nz = asap->memory[addr];
			c = nz >> 7;
			nz = (nz << 1) & 255;
			asap->memory[addr] = nz;
			break;
		case 8:
			asap->memory[256 + s] = ((nz | (nz >> 1)) & 128) + vdi + ((nz & 255) == 0 ? 2 : 0) + c + 48;
			s = (s - 1) & 255;
			break;
		case 9:
			nz = a |= asap->memory[pc++];
			break;
		case 10:
			c = a >> 7;
			nz = a = (a << 1) & 255;
			break;
		case 13:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			nz = a |= (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 14:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			c = nz >> 7;
			nz = (nz << 1) & 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			break;
		case 16:
			if (nz < 128) {
				addr = (signed char) asap->memory[pc];
				pc++;
				addr += pc;
				if ((addr ^ pc) >> 8 != 0)
					asap->cycle++;
				asap->cycle++;
				pc = addr;
				break;
			}
			pc++;
			break;
		case 17:
			addr = asap->memory[pc++];
			addr = (asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8) + y) & 65535;
			if ((addr & 255) < y)
				asap->cycle++;
			nz = a |= (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 21:
			addr = (asap->memory[pc++] + x) & 255;
			nz = a |= asap->memory[addr];
			break;
		case 22:
			addr = (asap->memory[pc++] + x) & 255;
			nz = asap->memory[addr];
			c = nz >> 7;
			nz = (nz << 1) & 255;
			asap->memory[addr] = nz;
			break;
		case 24:
			c = 0;
			break;
		case 25:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + y) & 65535;
			if ((addr & 255) < y)
				asap->cycle++;
			nz = a |= (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 29:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + x) & 65535;
			if ((addr & 255) < x)
				asap->cycle++;
			nz = a |= (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 30:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + x) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			c = nz >> 7;
			nz = (nz << 1) & 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			break;
		case 32:
			addr = asap->memory[pc++];
			asap->memory[256 + s] = pc >> 8;
			s = (s - 1) & 255;
			asap->memory[256 + s] = (unsigned char) pc;
			s = (s - 1) & 255;
			pc = addr + (asap->memory[pc] << 8);
			break;
		case 33:
			addr = (asap->memory[pc++] + x) & 255;
			addr = asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8);
			nz = a &= (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 36:
			addr = asap->memory[pc++];
			nz = asap->memory[addr];
			vdi = (vdi & 12) + (nz & 64);
			nz = ((nz & 128) << 1) + (nz & a);
			break;
		case 37:
			addr = asap->memory[pc++];
			nz = a &= asap->memory[addr];
			break;
		case 38:
			addr = asap->memory[pc++];
			nz = asap->memory[addr];
			nz = (nz << 1) + c;
			c = nz >> 8;
			nz &= 255;
			asap->memory[addr] = nz;
			break;
		case 40:
			s = (s + 1) & 255;
			vdi = asap->memory[256 + s];
			nz = ((vdi & 128) << 1) + (~vdi & 2);
			c = vdi & 1;
			vdi &= 76;
			if ((vdi & 4) == 0 && asap->pokeys.irqst != 255) {
				asap->memory[256 + s] = pc >> 8;
				s = (s - 1) & 255;
				asap->memory[256 + s] = (unsigned char) pc;
				s = (s - 1) & 255;
				asap->memory[256 + s] = ((nz | (nz >> 1)) & 128) + vdi + ((nz & 255) == 0 ? 2 : 0) + c + 32;
				s = (s - 1) & 255;
				vdi |= 4;
				pc = asap->memory[65534] + (asap->memory[65535] << 8);
				asap->cycle += 7;
			}
			break;
		case 41:
			nz = a &= asap->memory[pc++];
			break;
		case 42:
			a = (a << 1) + c;
			c = a >> 8;
			nz = a &= 255;
			break;
		case 44:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			nz = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			vdi = (vdi & 12) + (nz & 64);
			nz = ((nz & 128) << 1) + (nz & a);
			break;
		case 45:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			nz = a &= (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 46:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz = (nz << 1) + c;
			c = nz >> 8;
			nz &= 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			break;
		case 48:
			if (nz >= 128) {
				addr = (signed char) asap->memory[pc];
				pc++;
				addr += pc;
				if ((addr ^ pc) >> 8 != 0)
					asap->cycle++;
				asap->cycle++;
				pc = addr;
				break;
			}
			pc++;
			break;
		case 49:
			addr = asap->memory[pc++];
			addr = (asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8) + y) & 65535;
			if ((addr & 255) < y)
				asap->cycle++;
			nz = a &= (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 53:
			addr = (asap->memory[pc++] + x) & 255;
			nz = a &= asap->memory[addr];
			break;
		case 54:
			addr = (asap->memory[pc++] + x) & 255;
			nz = asap->memory[addr];
			nz = (nz << 1) + c;
			c = nz >> 8;
			nz &= 255;
			asap->memory[addr] = nz;
			break;
		case 56:
			c = 1;
			break;
		case 57:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + y) & 65535;
			if ((addr & 255) < y)
				asap->cycle++;
			nz = a &= (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 61:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + x) & 65535;
			if ((addr & 255) < x)
				asap->cycle++;
			nz = a &= (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 62:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + x) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz = (nz << 1) + c;
			c = nz >> 8;
			nz &= 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			break;
		case 64:
			s = (s + 1) & 255;
			vdi = asap->memory[256 + s];
			nz = ((vdi & 128) << 1) + (~vdi & 2);
			c = vdi & 1;
			vdi &= 76;
			s = (s + 1) & 255;
			pc = asap->memory[256 + s];
			s = (s + 1) & 255;
			addr = asap->memory[256 + s];
			pc += addr << 8;
			if ((vdi & 4) == 0 && asap->pokeys.irqst != 255) {
				asap->memory[256 + s] = pc >> 8;
				s = (s - 1) & 255;
				asap->memory[256 + s] = (unsigned char) pc;
				s = (s - 1) & 255;
				asap->memory[256 + s] = ((nz | (nz >> 1)) & 128) + vdi + ((nz & 255) == 0 ? 2 : 0) + c + 32;
				s = (s - 1) & 255;
				vdi |= 4;
				pc = asap->memory[65534] + (asap->memory[65535] << 8);
				asap->cycle += 7;
			}
			break;
		case 65:
			addr = (asap->memory[pc++] + x) & 255;
			addr = asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8);
			nz = a ^= (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 69:
			addr = asap->memory[pc++];
			nz = a ^= asap->memory[addr];
			break;
		case 70:
			addr = asap->memory[pc++];
			nz = asap->memory[addr];
			c = nz & 1;
			nz >>= 1;
			asap->memory[addr] = nz;
			break;
		case 72:
			asap->memory[256 + s] = a;
			s = (s - 1) & 255;
			break;
		case 73:
			nz = a ^= asap->memory[pc++];
			break;
		case 74:
			c = a & 1;
			nz = a >>= 1;
			break;
		case 76:
			addr = asap->memory[pc++];
			pc = addr + (asap->memory[pc] << 8);
			break;
		case 77:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			nz = a ^= (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 78:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			c = nz & 1;
			nz >>= 1;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			break;
		case 80:
			if ((vdi & 64) == 0) {
				addr = (signed char) asap->memory[pc];
				pc++;
				addr += pc;
				if ((addr ^ pc) >> 8 != 0)
					asap->cycle++;
				asap->cycle++;
				pc = addr;
				break;
			}
			pc++;
			break;
		case 81:
			addr = asap->memory[pc++];
			addr = (asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8) + y) & 65535;
			if ((addr & 255) < y)
				asap->cycle++;
			nz = a ^= (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 85:
			addr = (asap->memory[pc++] + x) & 255;
			nz = a ^= asap->memory[addr];
			break;
		case 86:
			addr = (asap->memory[pc++] + x) & 255;
			nz = asap->memory[addr];
			c = nz & 1;
			nz >>= 1;
			asap->memory[addr] = nz;
			break;
		case 88:
			vdi &= 72;
			if ((vdi & 4) == 0 && asap->pokeys.irqst != 255) {
				asap->memory[256 + s] = pc >> 8;
				s = (s - 1) & 255;
				asap->memory[256 + s] = (unsigned char) pc;
				s = (s - 1) & 255;
				asap->memory[256 + s] = ((nz | (nz >> 1)) & 128) + vdi + ((nz & 255) == 0 ? 2 : 0) + c + 32;
				s = (s - 1) & 255;
				vdi |= 4;
				pc = asap->memory[65534] + (asap->memory[65535] << 8);
				asap->cycle += 7;
			}
			break;
		case 89:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + y) & 65535;
			if ((addr & 255) < y)
				asap->cycle++;
			nz = a ^= (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 93:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + x) & 65535;
			if ((addr & 255) < x)
				asap->cycle++;
			nz = a ^= (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 94:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + x) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			c = nz & 1;
			nz >>= 1;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			break;
		case 96:
			s = (s + 1) & 255;
			pc = asap->memory[256 + s];
			s = (s + 1) & 255;
			addr = asap->memory[256 + s];
			pc += (addr << 8) + 1;
			break;
		case 97:
			addr = (asap->memory[pc++] + x) & 255;
			addr = asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8);
			data = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			{
				int tmp = a + data + c;
				nz = tmp & 255;
				if ((vdi & 8) == 0) {
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					c = tmp >> 8;
					a = nz;
				}
				else {
					int al = (a & 15) + (data & 15) + c;
					if (al >= 10) {
						tmp += al < 26 ? 6 : -10;
						if (nz != 0)
							nz = (tmp & 128) + 1;
					}
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					if (tmp >= 160) {
						c = 1;
						a = (tmp + 96) & 255;
					}
					else {
						c = 0;
						a = tmp;
					}
				}
			}
			break;
		case 101:
			addr = asap->memory[pc++];
			data = asap->memory[addr];
			{
				int tmp = a + data + c;
				nz = tmp & 255;
				if ((vdi & 8) == 0) {
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					c = tmp >> 8;
					a = nz;
				}
				else {
					int al = (a & 15) + (data & 15) + c;
					if (al >= 10) {
						tmp += al < 26 ? 6 : -10;
						if (nz != 0)
							nz = (tmp & 128) + 1;
					}
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					if (tmp >= 160) {
						c = 1;
						a = (tmp + 96) & 255;
					}
					else {
						c = 0;
						a = tmp;
					}
				}
			}
			break;
		case 102:
			addr = asap->memory[pc++];
			nz = asap->memory[addr] + (c << 8);
			c = nz & 1;
			nz >>= 1;
			asap->memory[addr] = nz;
			break;
		case 104:
			s = (s + 1) & 255;
			a = asap->memory[256 + s];
			nz = a;
			break;
		case 105:
			data = asap->memory[pc++];
			{
				int tmp = a + data + c;
				nz = tmp & 255;
				if ((vdi & 8) == 0) {
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					c = tmp >> 8;
					a = nz;
				}
				else {
					int al = (a & 15) + (data & 15) + c;
					if (al >= 10) {
						tmp += al < 26 ? 6 : -10;
						if (nz != 0)
							nz = (tmp & 128) + 1;
					}
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					if (tmp >= 160) {
						c = 1;
						a = (tmp + 96) & 255;
					}
					else {
						c = 0;
						a = tmp;
					}
				}
			}
			break;
		case 106:
			nz = (c << 7) + (a >> 1);
			c = a & 1;
			a = nz;
			break;
		case 108:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			if ((addr & 255) == 255)
				pc = asap->memory[addr] + (asap->memory[addr - 255] << 8);
			else
				pc = asap->memory[addr] + (asap->memory[addr + 1] << 8);
			break;
		case 109:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			data = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			{
				int tmp = a + data + c;
				nz = tmp & 255;
				if ((vdi & 8) == 0) {
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					c = tmp >> 8;
					a = nz;
				}
				else {
					int al = (a & 15) + (data & 15) + c;
					if (al >= 10) {
						tmp += al < 26 ? 6 : -10;
						if (nz != 0)
							nz = (tmp & 128) + 1;
					}
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					if (tmp >= 160) {
						c = 1;
						a = (tmp + 96) & 255;
					}
					else {
						c = 0;
						a = tmp;
					}
				}
			}
			break;
		case 110:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz += c << 8;
			c = nz & 1;
			nz >>= 1;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			break;
		case 112:
			if ((vdi & 64) != 0) {
				addr = (signed char) asap->memory[pc];
				pc++;
				addr += pc;
				if ((addr ^ pc) >> 8 != 0)
					asap->cycle++;
				asap->cycle++;
				pc = addr;
				break;
			}
			pc++;
			break;
		case 113:
			addr = asap->memory[pc++];
			addr = (asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8) + y) & 65535;
			if ((addr & 255) < y)
				asap->cycle++;
			data = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			{
				int tmp = a + data + c;
				nz = tmp & 255;
				if ((vdi & 8) == 0) {
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					c = tmp >> 8;
					a = nz;
				}
				else {
					int al = (a & 15) + (data & 15) + c;
					if (al >= 10) {
						tmp += al < 26 ? 6 : -10;
						if (nz != 0)
							nz = (tmp & 128) + 1;
					}
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					if (tmp >= 160) {
						c = 1;
						a = (tmp + 96) & 255;
					}
					else {
						c = 0;
						a = tmp;
					}
				}
			}
			break;
		case 117:
			addr = (asap->memory[pc++] + x) & 255;
			data = asap->memory[addr];
			{
				int tmp = a + data + c;
				nz = tmp & 255;
				if ((vdi & 8) == 0) {
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					c = tmp >> 8;
					a = nz;
				}
				else {
					int al = (a & 15) + (data & 15) + c;
					if (al >= 10) {
						tmp += al < 26 ? 6 : -10;
						if (nz != 0)
							nz = (tmp & 128) + 1;
					}
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					if (tmp >= 160) {
						c = 1;
						a = (tmp + 96) & 255;
					}
					else {
						c = 0;
						a = tmp;
					}
				}
			}
			break;
		case 118:
			addr = (asap->memory[pc++] + x) & 255;
			nz = asap->memory[addr] + (c << 8);
			c = nz & 1;
			nz >>= 1;
			asap->memory[addr] = nz;
			break;
		case 120:
			vdi |= 4;
			break;
		case 121:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + y) & 65535;
			if ((addr & 255) < y)
				asap->cycle++;
			data = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			{
				int tmp = a + data + c;
				nz = tmp & 255;
				if ((vdi & 8) == 0) {
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					c = tmp >> 8;
					a = nz;
				}
				else {
					int al = (a & 15) + (data & 15) + c;
					if (al >= 10) {
						tmp += al < 26 ? 6 : -10;
						if (nz != 0)
							nz = (tmp & 128) + 1;
					}
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					if (tmp >= 160) {
						c = 1;
						a = (tmp + 96) & 255;
					}
					else {
						c = 0;
						a = tmp;
					}
				}
			}
			break;
		case 125:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + x) & 65535;
			if ((addr & 255) < x)
				asap->cycle++;
			data = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			{
				int tmp = a + data + c;
				nz = tmp & 255;
				if ((vdi & 8) == 0) {
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					c = tmp >> 8;
					a = nz;
				}
				else {
					int al = (a & 15) + (data & 15) + c;
					if (al >= 10) {
						tmp += al < 26 ? 6 : -10;
						if (nz != 0)
							nz = (tmp & 128) + 1;
					}
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					if (tmp >= 160) {
						c = 1;
						a = (tmp + 96) & 255;
					}
					else {
						c = 0;
						a = tmp;
					}
				}
			}
			break;
		case 126:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + x) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz += c << 8;
			c = nz & 1;
			nz >>= 1;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			break;
		case 129:
			addr = (asap->memory[pc++] + x) & 255;
			addr = asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8);
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, a);
			else
				asap->memory[addr] = a;
			break;
		case 132:
			addr = asap->memory[pc++];
			asap->memory[addr] = y;
			break;
		case 133:
			addr = asap->memory[pc++];
			asap->memory[addr] = a;
			break;
		case 134:
			addr = asap->memory[pc++];
			asap->memory[addr] = x;
			break;
		case 136:
			nz = y = (y - 1) & 255;
			break;
		case 138:
			nz = a = x;
			break;
		case 140:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, y);
			else
				asap->memory[addr] = y;
			break;
		case 141:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, a);
			else
				asap->memory[addr] = a;
			break;
		case 142:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, x);
			else
				asap->memory[addr] = x;
			break;
		case 144:
			if (c == 0) {
				addr = (signed char) asap->memory[pc];
				pc++;
				addr += pc;
				if ((addr ^ pc) >> 8 != 0)
					asap->cycle++;
				asap->cycle++;
				pc = addr;
				break;
			}
			pc++;
			break;
		case 145:
			addr = asap->memory[pc++];
			addr = (asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8) + y) & 65535;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, a);
			else
				asap->memory[addr] = a;
			break;
		case 148:
			addr = (asap->memory[pc++] + x) & 255;
			asap->memory[addr] = y;
			break;
		case 149:
			addr = (asap->memory[pc++] + x) & 255;
			asap->memory[addr] = a;
			break;
		case 150:
			addr = (asap->memory[pc++] + y) & 255;
			asap->memory[addr] = x;
			break;
		case 152:
			nz = a = y;
			break;
		case 153:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + y) & 65535;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, a);
			else
				asap->memory[addr] = a;
			break;
		case 154:
			s = x;
			break;
		case 157:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + x) & 65535;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, a);
			else
				asap->memory[addr] = a;
			break;
		case 160:
			nz = y = asap->memory[pc++];
			break;
		case 161:
			addr = (asap->memory[pc++] + x) & 255;
			addr = asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8);
			nz = a = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 162:
			nz = x = asap->memory[pc++];
			break;
		case 164:
			addr = asap->memory[pc++];
			nz = y = asap->memory[addr];
			break;
		case 165:
			addr = asap->memory[pc++];
			nz = a = asap->memory[addr];
			break;
		case 166:
			addr = asap->memory[pc++];
			nz = x = asap->memory[addr];
			break;
		case 168:
			nz = y = a;
			break;
		case 169:
			nz = a = asap->memory[pc++];
			break;
		case 170:
			nz = x = a;
			break;
		case 172:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			nz = y = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 173:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			nz = a = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 174:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			nz = x = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 176:
			if (c != 0) {
				addr = (signed char) asap->memory[pc];
				pc++;
				addr += pc;
				if ((addr ^ pc) >> 8 != 0)
					asap->cycle++;
				asap->cycle++;
				pc = addr;
				break;
			}
			pc++;
			break;
		case 177:
			addr = asap->memory[pc++];
			addr = (asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8) + y) & 65535;
			if ((addr & 255) < y)
				asap->cycle++;
			nz = a = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 180:
			addr = (asap->memory[pc++] + x) & 255;
			nz = y = asap->memory[addr];
			break;
		case 181:
			addr = (asap->memory[pc++] + x) & 255;
			nz = a = asap->memory[addr];
			break;
		case 182:
			addr = (asap->memory[pc++] + y) & 255;
			nz = x = asap->memory[addr];
			break;
		case 184:
			vdi &= 12;
			break;
		case 185:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + y) & 65535;
			if ((addr & 255) < y)
				asap->cycle++;
			nz = a = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 186:
			nz = x = s;
			break;
		case 188:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + x) & 65535;
			if ((addr & 255) < x)
				asap->cycle++;
			nz = y = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 189:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + x) & 65535;
			if ((addr & 255) < x)
				asap->cycle++;
			nz = a = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 190:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + y) & 65535;
			if ((addr & 255) < y)
				asap->cycle++;
			nz = x = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 192:
			nz = asap->memory[pc++];
			c = y >= nz ? 1 : 0;
			nz = (y - nz) & 255;
			break;
		case 193:
			addr = (asap->memory[pc++] + x) & 255;
			addr = asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8);
			nz = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			c = a >= nz ? 1 : 0;
			nz = (a - nz) & 255;
			break;
		case 196:
			addr = asap->memory[pc++];
			nz = asap->memory[addr];
			c = y >= nz ? 1 : 0;
			nz = (y - nz) & 255;
			break;
		case 197:
			addr = asap->memory[pc++];
			nz = asap->memory[addr];
			c = a >= nz ? 1 : 0;
			nz = (a - nz) & 255;
			break;
		case 198:
			addr = asap->memory[pc++];
			nz = asap->memory[addr];
			nz = (nz - 1) & 255;
			asap->memory[addr] = nz;
			break;
		case 200:
			nz = y = (y + 1) & 255;
			break;
		case 201:
			nz = asap->memory[pc++];
			c = a >= nz ? 1 : 0;
			nz = (a - nz) & 255;
			break;
		case 202:
			nz = x = (x - 1) & 255;
			break;
		case 204:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			nz = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			c = y >= nz ? 1 : 0;
			nz = (y - nz) & 255;
			break;
		case 205:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			nz = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			c = a >= nz ? 1 : 0;
			nz = (a - nz) & 255;
			break;
		case 206:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz = (nz - 1) & 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			break;
		case 208:
			if ((nz & 255) != 0) {
				addr = (signed char) asap->memory[pc];
				pc++;
				addr += pc;
				if ((addr ^ pc) >> 8 != 0)
					asap->cycle++;
				asap->cycle++;
				pc = addr;
				break;
			}
			pc++;
			break;
		case 209:
			addr = asap->memory[pc++];
			addr = (asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8) + y) & 65535;
			if ((addr & 255) < y)
				asap->cycle++;
			nz = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			c = a >= nz ? 1 : 0;
			nz = (a - nz) & 255;
			break;
		case 213:
			addr = (asap->memory[pc++] + x) & 255;
			nz = asap->memory[addr];
			c = a >= nz ? 1 : 0;
			nz = (a - nz) & 255;
			break;
		case 214:
			addr = (asap->memory[pc++] + x) & 255;
			nz = asap->memory[addr];
			nz = (nz - 1) & 255;
			asap->memory[addr] = nz;
			break;
		case 216:
			vdi &= 68;
			break;
		case 217:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + y) & 65535;
			if ((addr & 255) < y)
				asap->cycle++;
			nz = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			c = a >= nz ? 1 : 0;
			nz = (a - nz) & 255;
			break;
		case 221:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + x) & 65535;
			if ((addr & 255) < x)
				asap->cycle++;
			nz = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			c = a >= nz ? 1 : 0;
			nz = (a - nz) & 255;
			break;
		case 222:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + x) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz = (nz - 1) & 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			break;
		case 224:
			nz = asap->memory[pc++];
			c = x >= nz ? 1 : 0;
			nz = (x - nz) & 255;
			break;
		case 225:
			addr = (asap->memory[pc++] + x) & 255;
			addr = asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8);
			data = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			{
				int tmp = a - data - 1 + c;
				int al = (a & 15) - (data & 15) - 1 + c;
				vdi = (vdi & 12) + ((((data ^ a) & (a ^ tmp)) >> 1) & 64);
				c = tmp >= 0 ? 1 : 0;
				nz = a = tmp & 255;
				if ((vdi & 8) != 0) {
					if (al < 0)
						a += al < -10 ? 10 : -6;
					if (c == 0)
						a = (a - 96) & 255;
				}
			}
			break;
		case 228:
			addr = asap->memory[pc++];
			nz = asap->memory[addr];
			c = x >= nz ? 1 : 0;
			nz = (x - nz) & 255;
			break;
		case 229:
			addr = asap->memory[pc++];
			data = asap->memory[addr];
			{
				int tmp = a - data - 1 + c;
				int al = (a & 15) - (data & 15) - 1 + c;
				vdi = (vdi & 12) + ((((data ^ a) & (a ^ tmp)) >> 1) & 64);
				c = tmp >= 0 ? 1 : 0;
				nz = a = tmp & 255;
				if ((vdi & 8) != 0) {
					if (al < 0)
						a += al < -10 ? 10 : -6;
					if (c == 0)
						a = (a - 96) & 255;
				}
			}
			break;
		case 230:
			addr = asap->memory[pc++];
			nz = asap->memory[addr];
			nz = (nz + 1) & 255;
			asap->memory[addr] = nz;
			break;
		case 232:
			nz = x = (x + 1) & 255;
			break;
		case 233:
		case 235:
			data = asap->memory[pc++];
			{
				int tmp = a - data - 1 + c;
				int al = (a & 15) - (data & 15) - 1 + c;
				vdi = (vdi & 12) + ((((data ^ a) & (a ^ tmp)) >> 1) & 64);
				c = tmp >= 0 ? 1 : 0;
				nz = a = tmp & 255;
				if ((vdi & 8) != 0) {
					if (al < 0)
						a += al < -10 ? 10 : -6;
					if (c == 0)
						a = (a - 96) & 255;
				}
			}
			break;
		case 234:
		case 26:
		case 58:
		case 90:
		case 122:
		case 218:
		case 250:
			break;
		case 236:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			nz = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			c = x >= nz ? 1 : 0;
			nz = (x - nz) & 255;
			break;
		case 237:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			data = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			{
				int tmp = a - data - 1 + c;
				int al = (a & 15) - (data & 15) - 1 + c;
				vdi = (vdi & 12) + ((((data ^ a) & (a ^ tmp)) >> 1) & 64);
				c = tmp >= 0 ? 1 : 0;
				nz = a = tmp & 255;
				if ((vdi & 8) != 0) {
					if (al < 0)
						a += al < -10 ? 10 : -6;
					if (c == 0)
						a = (a - 96) & 255;
				}
			}
			break;
		case 238:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz = (nz + 1) & 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			break;
		case 240:
			if ((nz & 255) == 0) {
				addr = (signed char) asap->memory[pc];
				pc++;
				addr += pc;
				if ((addr ^ pc) >> 8 != 0)
					asap->cycle++;
				asap->cycle++;
				pc = addr;
				break;
			}
			pc++;
			break;
		case 241:
			addr = asap->memory[pc++];
			addr = (asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8) + y) & 65535;
			if ((addr & 255) < y)
				asap->cycle++;
			data = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			{
				int tmp = a - data - 1 + c;
				int al = (a & 15) - (data & 15) - 1 + c;
				vdi = (vdi & 12) + ((((data ^ a) & (a ^ tmp)) >> 1) & 64);
				c = tmp >= 0 ? 1 : 0;
				nz = a = tmp & 255;
				if ((vdi & 8) != 0) {
					if (al < 0)
						a += al < -10 ? 10 : -6;
					if (c == 0)
						a = (a - 96) & 255;
				}
			}
			break;
		case 245:
			addr = (asap->memory[pc++] + x) & 255;
			data = asap->memory[addr];
			{
				int tmp = a - data - 1 + c;
				int al = (a & 15) - (data & 15) - 1 + c;
				vdi = (vdi & 12) + ((((data ^ a) & (a ^ tmp)) >> 1) & 64);
				c = tmp >= 0 ? 1 : 0;
				nz = a = tmp & 255;
				if ((vdi & 8) != 0) {
					if (al < 0)
						a += al < -10 ? 10 : -6;
					if (c == 0)
						a = (a - 96) & 255;
				}
			}
			break;
		case 246:
			addr = (asap->memory[pc++] + x) & 255;
			nz = asap->memory[addr];
			nz = (nz + 1) & 255;
			asap->memory[addr] = nz;
			break;
		case 248:
			vdi |= 8;
			break;
		case 249:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + y) & 65535;
			if ((addr & 255) < y)
				asap->cycle++;
			data = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			{
				int tmp = a - data - 1 + c;
				int al = (a & 15) - (data & 15) - 1 + c;
				vdi = (vdi & 12) + ((((data ^ a) & (a ^ tmp)) >> 1) & 64);
				c = tmp >= 0 ? 1 : 0;
				nz = a = tmp & 255;
				if ((vdi & 8) != 0) {
					if (al < 0)
						a += al < -10 ? 10 : -6;
					if (c == 0)
						a = (a - 96) & 255;
				}
			}
			break;
		case 253:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + x) & 65535;
			if ((addr & 255) < x)
				asap->cycle++;
			data = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			{
				int tmp = a - data - 1 + c;
				int al = (a & 15) - (data & 15) - 1 + c;
				vdi = (vdi & 12) + ((((data ^ a) & (a ^ tmp)) >> 1) & 64);
				c = tmp >= 0 ? 1 : 0;
				nz = a = tmp & 255;
				if ((vdi & 8) != 0) {
					if (al < 0)
						a += al < -10 ? 10 : -6;
					if (c == 0)
						a = (a - 96) & 255;
				}
			}
			break;
		case 254:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + x) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz = (nz + 1) & 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			break;
		case 3:
			addr = (asap->memory[pc++] + x) & 255;
			addr = asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8);
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			c = nz >> 7;
			nz = (nz << 1) & 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			nz = a |= nz;
			break;
		case 4:
		case 68:
		case 100:
		case 20:
		case 52:
		case 84:
		case 116:
		case 212:
		case 244:
		case 128:
		case 130:
		case 137:
		case 194:
		case 226:
			pc++;
			break;
		case 7:
			addr = asap->memory[pc++];
			nz = asap->memory[addr];
			c = nz >> 7;
			nz = (nz << 1) & 255;
			asap->memory[addr] = nz;
			nz = a |= nz;
			break;
		case 11:
		case 43:
			nz = a &= asap->memory[pc++];
			c = nz >> 7;
			break;
		case 12:
			pc += 2;
			break;
		case 15:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			c = nz >> 7;
			nz = (nz << 1) & 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			nz = a |= nz;
			break;
		case 19:
			addr = asap->memory[pc++];
			addr = (asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8) + y) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			c = nz >> 7;
			nz = (nz << 1) & 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			nz = a |= nz;
			break;
		case 23:
			addr = (asap->memory[pc++] + x) & 255;
			nz = asap->memory[addr];
			c = nz >> 7;
			nz = (nz << 1) & 255;
			asap->memory[addr] = nz;
			nz = a |= nz;
			break;
		case 27:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + y) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			c = nz >> 7;
			nz = (nz << 1) & 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			nz = a |= nz;
			break;
		case 28:
		case 60:
		case 92:
		case 124:
		case 220:
		case 252:
			if (asap->memory[pc++] + x >= 256)
				asap->cycle++;
			pc++;
			break;
		case 31:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + x) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			c = nz >> 7;
			nz = (nz << 1) & 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			nz = a |= nz;
			break;
		case 35:
			addr = (asap->memory[pc++] + x) & 255;
			addr = asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8);
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz = (nz << 1) + c;
			c = nz >> 8;
			nz &= 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			nz = a &= nz;
			break;
		case 39:
			addr = asap->memory[pc++];
			nz = asap->memory[addr];
			nz = (nz << 1) + c;
			c = nz >> 8;
			nz &= 255;
			asap->memory[addr] = nz;
			nz = a &= nz;
			break;
		case 47:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz = (nz << 1) + c;
			c = nz >> 8;
			nz &= 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			nz = a &= nz;
			break;
		case 51:
			addr = asap->memory[pc++];
			addr = (asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8) + y) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz = (nz << 1) + c;
			c = nz >> 8;
			nz &= 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			nz = a &= nz;
			break;
		case 55:
			addr = (asap->memory[pc++] + x) & 255;
			nz = asap->memory[addr];
			nz = (nz << 1) + c;
			c = nz >> 8;
			nz &= 255;
			asap->memory[addr] = nz;
			nz = a &= nz;
			break;
		case 59:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + y) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz = (nz << 1) + c;
			c = nz >> 8;
			nz &= 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			nz = a &= nz;
			break;
		case 63:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + x) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz = (nz << 1) + c;
			c = nz >> 8;
			nz &= 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			nz = a &= nz;
			break;
		case 67:
			addr = (asap->memory[pc++] + x) & 255;
			addr = asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8);
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			c = nz & 1;
			nz >>= 1;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			nz = a ^= nz;
			break;
		case 71:
			addr = asap->memory[pc++];
			nz = asap->memory[addr];
			c = nz & 1;
			nz >>= 1;
			asap->memory[addr] = nz;
			nz = a ^= nz;
			break;
		case 75:
			a &= asap->memory[pc++];
			c = a & 1;
			nz = a >>= 1;
			break;
		case 79:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			c = nz & 1;
			nz >>= 1;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			nz = a ^= nz;
			break;
		case 83:
			addr = asap->memory[pc++];
			addr = (asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8) + y) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			c = nz & 1;
			nz >>= 1;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			nz = a ^= nz;
			break;
		case 87:
			addr = (asap->memory[pc++] + x) & 255;
			nz = asap->memory[addr];
			c = nz & 1;
			nz >>= 1;
			asap->memory[addr] = nz;
			nz = a ^= nz;
			break;
		case 91:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + y) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			c = nz & 1;
			nz >>= 1;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			nz = a ^= nz;
			break;
		case 95:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + x) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			c = nz & 1;
			nz >>= 1;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			nz = a ^= nz;
			break;
		case 99:
			addr = (asap->memory[pc++] + x) & 255;
			addr = asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8);
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz += c << 8;
			c = nz & 1;
			nz >>= 1;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			data = nz;
			{
				int tmp = a + data + c;
				nz = tmp & 255;
				if ((vdi & 8) == 0) {
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					c = tmp >> 8;
					a = nz;
				}
				else {
					int al = (a & 15) + (data & 15) + c;
					if (al >= 10) {
						tmp += al < 26 ? 6 : -10;
						if (nz != 0)
							nz = (tmp & 128) + 1;
					}
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					if (tmp >= 160) {
						c = 1;
						a = (tmp + 96) & 255;
					}
					else {
						c = 0;
						a = tmp;
					}
				}
			}
			break;
		case 103:
			addr = asap->memory[pc++];
			nz = asap->memory[addr] + (c << 8);
			c = nz & 1;
			nz >>= 1;
			asap->memory[addr] = nz;
			data = nz;
			{
				int tmp = a + data + c;
				nz = tmp & 255;
				if ((vdi & 8) == 0) {
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					c = tmp >> 8;
					a = nz;
				}
				else {
					int al = (a & 15) + (data & 15) + c;
					if (al >= 10) {
						tmp += al < 26 ? 6 : -10;
						if (nz != 0)
							nz = (tmp & 128) + 1;
					}
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					if (tmp >= 160) {
						c = 1;
						a = (tmp + 96) & 255;
					}
					else {
						c = 0;
						a = tmp;
					}
				}
			}
			break;
		case 107:
			data = a & asap->memory[pc++];
			nz = a = (data >> 1) + (c << 7);
			vdi = (vdi & 12) + ((a ^ data) & 64);
			if ((vdi & 8) == 0)
				c = data >> 7;
			else {
				if ((data & 15) >= 5)
					a = (a & 240) + ((a + 6) & 15);
				if (data >= 80) {
					a = (a + 96) & 255;
					c = 1;
				}
				else
					c = 0;
			}
			break;
		case 111:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz += c << 8;
			c = nz & 1;
			nz >>= 1;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			data = nz;
			{
				int tmp = a + data + c;
				nz = tmp & 255;
				if ((vdi & 8) == 0) {
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					c = tmp >> 8;
					a = nz;
				}
				else {
					int al = (a & 15) + (data & 15) + c;
					if (al >= 10) {
						tmp += al < 26 ? 6 : -10;
						if (nz != 0)
							nz = (tmp & 128) + 1;
					}
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					if (tmp >= 160) {
						c = 1;
						a = (tmp + 96) & 255;
					}
					else {
						c = 0;
						a = tmp;
					}
				}
			}
			break;
		case 115:
			addr = asap->memory[pc++];
			addr = (asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8) + y) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz += c << 8;
			c = nz & 1;
			nz >>= 1;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			data = nz;
			{
				int tmp = a + data + c;
				nz = tmp & 255;
				if ((vdi & 8) == 0) {
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					c = tmp >> 8;
					a = nz;
				}
				else {
					int al = (a & 15) + (data & 15) + c;
					if (al >= 10) {
						tmp += al < 26 ? 6 : -10;
						if (nz != 0)
							nz = (tmp & 128) + 1;
					}
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					if (tmp >= 160) {
						c = 1;
						a = (tmp + 96) & 255;
					}
					else {
						c = 0;
						a = tmp;
					}
				}
			}
			break;
		case 119:
			addr = (asap->memory[pc++] + x) & 255;
			nz = asap->memory[addr] + (c << 8);
			c = nz & 1;
			nz >>= 1;
			asap->memory[addr] = nz;
			data = nz;
			{
				int tmp = a + data + c;
				nz = tmp & 255;
				if ((vdi & 8) == 0) {
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					c = tmp >> 8;
					a = nz;
				}
				else {
					int al = (a & 15) + (data & 15) + c;
					if (al >= 10) {
						tmp += al < 26 ? 6 : -10;
						if (nz != 0)
							nz = (tmp & 128) + 1;
					}
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					if (tmp >= 160) {
						c = 1;
						a = (tmp + 96) & 255;
					}
					else {
						c = 0;
						a = tmp;
					}
				}
			}
			break;
		case 123:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + y) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz += c << 8;
			c = nz & 1;
			nz >>= 1;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			data = nz;
			{
				int tmp = a + data + c;
				nz = tmp & 255;
				if ((vdi & 8) == 0) {
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					c = tmp >> 8;
					a = nz;
				}
				else {
					int al = (a & 15) + (data & 15) + c;
					if (al >= 10) {
						tmp += al < 26 ? 6 : -10;
						if (nz != 0)
							nz = (tmp & 128) + 1;
					}
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					if (tmp >= 160) {
						c = 1;
						a = (tmp + 96) & 255;
					}
					else {
						c = 0;
						a = tmp;
					}
				}
			}
			break;
		case 127:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + x) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz += c << 8;
			c = nz & 1;
			nz >>= 1;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			data = nz;
			{
				int tmp = a + data + c;
				nz = tmp & 255;
				if ((vdi & 8) == 0) {
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					c = tmp >> 8;
					a = nz;
				}
				else {
					int al = (a & 15) + (data & 15) + c;
					if (al >= 10) {
						tmp += al < 26 ? 6 : -10;
						if (nz != 0)
							nz = (tmp & 128) + 1;
					}
					vdi = (vdi & 12) + (((~(data ^ a) & (a ^ tmp)) >> 1) & 64);
					if (tmp >= 160) {
						c = 1;
						a = (tmp + 96) & 255;
					}
					else {
						c = 0;
						a = tmp;
					}
				}
			}
			break;
		case 131:
			addr = (asap->memory[pc++] + x) & 255;
			addr = asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8);
			data = a & x;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, data);
			else
				asap->memory[addr] = data;
			break;
		case 135:
			addr = asap->memory[pc++];
			data = a & x;
			asap->memory[addr] = data;
			break;
		case 139:
			data = asap->memory[pc++];
			a &= (data | 239) & x;
			nz = a & data;
			break;
		case 143:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			data = a & x;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, data);
			else
				asap->memory[addr] = data;
			break;
		case 147:
			{
				int hi;
				addr = asap->memory[pc++];
				hi = asap->memory[(addr + 1) & 255];
				addr = asap->memory[addr];
				data = (hi + 1) & a & x;
				addr += y;
				if (addr >= 256)
					hi = data - 1;
				addr += hi << 8;
				if ((addr & 63744) == 53248)
					ASAP_PokeHardware(asap, addr, data);
				else
					asap->memory[addr] = data;
			}
			break;
		case 151:
			addr = (asap->memory[pc++] + y) & 255;
			data = a & x;
			asap->memory[addr] = data;
			break;
		case 155:
			s = a & x;
			{
				int hi;
				addr = asap->memory[pc++];
				hi = asap->memory[pc++];
				data = (hi + 1) & s;
				addr += y;
				if (addr >= 256)
					hi = data - 1;
				addr += hi << 8;
				if ((addr & 63744) == 53248)
					ASAP_PokeHardware(asap, addr, data);
				else
					asap->memory[addr] = data;
			}
			break;
		case 156:
			{
				int hi;
				addr = asap->memory[pc++];
				hi = asap->memory[pc++];
				data = (hi + 1) & y;
				addr += x;
				if (addr >= 256)
					hi = data - 1;
				addr += hi << 8;
				if ((addr & 63744) == 53248)
					ASAP_PokeHardware(asap, addr, data);
				else
					asap->memory[addr] = data;
			}
			break;
		case 158:
			{
				int hi;
				addr = asap->memory[pc++];
				hi = asap->memory[pc++];
				data = (hi + 1) & x;
				addr += y;
				if (addr >= 256)
					hi = data - 1;
				addr += hi << 8;
				if ((addr & 63744) == 53248)
					ASAP_PokeHardware(asap, addr, data);
				else
					asap->memory[addr] = data;
			}
			break;
		case 159:
			{
				int hi;
				addr = asap->memory[pc++];
				hi = asap->memory[pc++];
				data = (hi + 1) & a & x;
				addr += y;
				if (addr >= 256)
					hi = data - 1;
				addr += hi << 8;
				if ((addr & 63744) == 53248)
					ASAP_PokeHardware(asap, addr, data);
				else
					asap->memory[addr] = data;
			}
			break;
		case 163:
			addr = (asap->memory[pc++] + x) & 255;
			addr = asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8);
			nz = x = a = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 167:
			addr = asap->memory[pc++];
			nz = x = a = asap->memory[addr];
			break;
		case 171:
			nz = x = a &= asap->memory[pc++];
			break;
		case 175:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			nz = x = a = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 179:
			addr = asap->memory[pc++];
			addr = (asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8) + y) & 65535;
			if ((addr & 255) < y)
				asap->cycle++;
			nz = x = a = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 183:
			addr = (asap->memory[pc++] + y) & 255;
			nz = x = a = asap->memory[addr];
			break;
		case 187:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + y) & 65535;
			if ((addr & 255) < y)
				asap->cycle++;
			nz = x = a = s &= (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 191:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + y) & 65535;
			if ((addr & 255) < y)
				asap->cycle++;
			nz = x = a = (addr & 63744) == 53248 ? ASAP_PeekHardware(asap, addr) : asap->memory[addr];
			break;
		case 195:
			addr = (asap->memory[pc++] + x) & 255;
			addr = asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8);
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz = (nz - 1) & 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			c = a >= nz ? 1 : 0;
			nz = (a - nz) & 255;
			break;
		case 199:
			addr = asap->memory[pc++];
			nz = asap->memory[addr];
			nz = (nz - 1) & 255;
			asap->memory[addr] = nz;
			c = a >= nz ? 1 : 0;
			nz = (a - nz) & 255;
			break;
		case 203:
			nz = asap->memory[pc++];
			x &= a;
			c = x >= nz ? 1 : 0;
			nz = x = (x - nz) & 255;
			break;
		case 207:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz = (nz - 1) & 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			c = a >= nz ? 1 : 0;
			nz = (a - nz) & 255;
			break;
		case 211:
			addr = asap->memory[pc++];
			addr = (asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8) + y) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz = (nz - 1) & 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			c = a >= nz ? 1 : 0;
			nz = (a - nz) & 255;
			break;
		case 215:
			addr = (asap->memory[pc++] + x) & 255;
			nz = asap->memory[addr];
			nz = (nz - 1) & 255;
			asap->memory[addr] = nz;
			c = a >= nz ? 1 : 0;
			nz = (a - nz) & 255;
			break;
		case 219:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + y) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz = (nz - 1) & 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			c = a >= nz ? 1 : 0;
			nz = (a - nz) & 255;
			break;
		case 223:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + x) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz = (nz - 1) & 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			c = a >= nz ? 1 : 0;
			nz = (a - nz) & 255;
			break;
		case 227:
			addr = (asap->memory[pc++] + x) & 255;
			addr = asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8);
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz = (nz + 1) & 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			data = nz;
			{
				int tmp = a - data - 1 + c;
				int al = (a & 15) - (data & 15) - 1 + c;
				vdi = (vdi & 12) + ((((data ^ a) & (a ^ tmp)) >> 1) & 64);
				c = tmp >= 0 ? 1 : 0;
				nz = a = tmp & 255;
				if ((vdi & 8) != 0) {
					if (al < 0)
						a += al < -10 ? 10 : -6;
					if (c == 0)
						a = (a - 96) & 255;
				}
			}
			break;
		case 231:
			addr = asap->memory[pc++];
			nz = asap->memory[addr];
			nz = (nz + 1) & 255;
			asap->memory[addr] = nz;
			data = nz;
			{
				int tmp = a - data - 1 + c;
				int al = (a & 15) - (data & 15) - 1 + c;
				vdi = (vdi & 12) + ((((data ^ a) & (a ^ tmp)) >> 1) & 64);
				c = tmp >= 0 ? 1 : 0;
				nz = a = tmp & 255;
				if ((vdi & 8) != 0) {
					if (al < 0)
						a += al < -10 ? 10 : -6;
					if (c == 0)
						a = (a - 96) & 255;
				}
			}
			break;
		case 239:
			addr = asap->memory[pc++];
			addr += asap->memory[pc++] << 8;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz = (nz + 1) & 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			data = nz;
			{
				int tmp = a - data - 1 + c;
				int al = (a & 15) - (data & 15) - 1 + c;
				vdi = (vdi & 12) + ((((data ^ a) & (a ^ tmp)) >> 1) & 64);
				c = tmp >= 0 ? 1 : 0;
				nz = a = tmp & 255;
				if ((vdi & 8) != 0) {
					if (al < 0)
						a += al < -10 ? 10 : -6;
					if (c == 0)
						a = (a - 96) & 255;
				}
			}
			break;
		case 243:
			addr = asap->memory[pc++];
			addr = (asap->memory[addr] + (asap->memory[(addr + 1) & 255] << 8) + y) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz = (nz + 1) & 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			data = nz;
			{
				int tmp = a - data - 1 + c;
				int al = (a & 15) - (data & 15) - 1 + c;
				vdi = (vdi & 12) + ((((data ^ a) & (a ^ tmp)) >> 1) & 64);
				c = tmp >= 0 ? 1 : 0;
				nz = a = tmp & 255;
				if ((vdi & 8) != 0) {
					if (al < 0)
						a += al < -10 ? 10 : -6;
					if (c == 0)
						a = (a - 96) & 255;
				}
			}
			break;
		case 247:
			addr = (asap->memory[pc++] + x) & 255;
			nz = asap->memory[addr];
			nz = (nz + 1) & 255;
			asap->memory[addr] = nz;
			data = nz;
			{
				int tmp = a - data - 1 + c;
				int al = (a & 15) - (data & 15) - 1 + c;
				vdi = (vdi & 12) + ((((data ^ a) & (a ^ tmp)) >> 1) & 64);
				c = tmp >= 0 ? 1 : 0;
				nz = a = tmp & 255;
				if ((vdi & 8) != 0) {
					if (al < 0)
						a += al < -10 ? 10 : -6;
					if (c == 0)
						a = (a - 96) & 255;
				}
			}
			break;
		case 251:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + y) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz = (nz + 1) & 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			data = nz;
			{
				int tmp = a - data - 1 + c;
				int al = (a & 15) - (data & 15) - 1 + c;
				vdi = (vdi & 12) + ((((data ^ a) & (a ^ tmp)) >> 1) & 64);
				c = tmp >= 0 ? 1 : 0;
				nz = a = tmp & 255;
				if ((vdi & 8) != 0) {
					if (al < 0)
						a += al < -10 ? 10 : -6;
					if (c == 0)
						a = (a - 96) & 255;
				}
			}
			break;
		case 255:
			addr = asap->memory[pc++];
			addr = (addr + (asap->memory[pc++] << 8) + x) & 65535;
			if (addr >> 8 == 210) {
				asap->cycle--;
				nz = ASAP_PeekHardware(asap, addr);
				ASAP_PokeHardware(asap, addr, nz);
				asap->cycle++;
			}
			else
				nz = asap->memory[addr];
			nz = (nz + 1) & 255;
			if ((addr & 63744) == 53248)
				ASAP_PokeHardware(asap, addr, nz);
			else
				asap->memory[addr] = nz;
			data = nz;
			{
				int tmp = a - data - 1 + c;
				int al = (a & 15) - (data & 15) - 1 + c;
				vdi = (vdi & 12) + ((((data ^ a) & (a ^ tmp)) >> 1) & 64);
				c = tmp >= 0 ? 1 : 0;
				nz = a = tmp & 255;
				if ((vdi & 8) != 0) {
					if (al < 0)
						a += al < -10 ? 10 : -6;
					if (c == 0)
						a = (a - 96) & 255;
				}
			}
			break;
		}
	}
	self->pc = pc;
	self->nz = nz;
	self->a = a;
	self->x = x;
	self->y = y;
	self->c = c;
	self->s = s;
	self->vdi = vdi;
}

static void FlashPack_Construct(FlashPack *self)
{
	{
		int i;
		for (i = 0; i < 65536; i++)
			self->memory[i] = -1;
	}
	self->loadState = FlashPackLoadState_START_LOW_BYTE;
}

static cibool FlashPack_Compress(FlashPack *self, ByteWriter w)
{
	int runAddress;
	int depackerEndAddress;
	int depackerStartAddress;
	int compressedStartAddress;
	if (self->memory[252] >= 0 || self->memory[253] >= 0 || self->memory[254] >= 0 || self->memory[255] >= 0)
		return FALSE;
	runAddress = self->memory[736] + (self->memory[737] << 8);
	self->memory[736] = self->memory[737] = -1;
	if ((depackerEndAddress = FlashPack_FindHole(self)) == -1)
		return FALSE;
	self->compressedLength = 0;
	self->itemsCount = 0;
	FlashPack_PutPoke(self, 54286, 0);
	FlashPack_PutPoke(self, 53774, 0);
	FlashPack_PutPoke(self, 54272, 0);
	FlashPack_PutPoke(self, 54017, 254);
	FlashPack_PutPoke(self, 580, 255);
	FlashPack_CompressMemoryArea(self, depackerEndAddress, 65535);
	FlashPack_CompressMemoryArea(self, 0, depackerEndAddress);
	FlashPack_PutItem(self, FlashPackItemType_END_OF_STREAM, 0);
	FlashPack_PutItems(self);
	depackerStartAddress = depackerEndAddress - 87;
	compressedStartAddress = depackerStartAddress - self->compressedLength;
	if (compressedStartAddress < 8192)
		return FALSE;
	w.func(w.obj, 255);
	w.func(w.obj, 255);
	ASAPWriter_WriteWord(w, 54017);
	ASAPWriter_WriteWord(w, 54017);
	w.func(w.obj, 255);
	ASAPWriter_WriteWord(w, compressedStartAddress);
	ASAPWriter_WriteWord(w, depackerEndAddress);
	ASAPWriter_WriteBytes(w, self->compressed, 0, self->compressedLength);
	w.func(w.obj, 173);
	ASAPWriter_WriteWord(w, compressedStartAddress);
	w.func(w.obj, 238);
	ASAPWriter_WriteWord(w, depackerStartAddress + 1);
	w.func(w.obj, 208);
	w.func(w.obj, 3);
	w.func(w.obj, 238);
	ASAPWriter_WriteWord(w, depackerStartAddress + 2);
	w.func(w.obj, 96);
	w.func(w.obj, 76);
	ASAPWriter_WriteWord(w, runAddress);
	w.func(w.obj, 133);
	w.func(w.obj, 254);
	w.func(w.obj, 138);
	w.func(w.obj, 42);
	w.func(w.obj, 170);
	w.func(w.obj, 240);
	w.func(w.obj, 246);
	w.func(w.obj, 177);
	w.func(w.obj, 254);
	w.func(w.obj, 153);
	w.func(w.obj, 128);
	w.func(w.obj, 128);
	w.func(w.obj, 200);
	w.func(w.obj, 208);
	w.func(w.obj, 9);
	w.func(w.obj, 152);
	w.func(w.obj, 56);
	w.func(w.obj, 101);
	w.func(w.obj, 255);
	w.func(w.obj, 133);
	w.func(w.obj, 255);
	w.func(w.obj, 141);
	ASAPWriter_WriteWord(w, depackerStartAddress + 26);
	w.func(w.obj, 202);
	w.func(w.obj, 208);
	w.func(w.obj, 236);
	w.func(w.obj, 6);
	w.func(w.obj, 253);
	w.func(w.obj, 208);
	w.func(w.obj, 21);
	w.func(w.obj, 6);
	w.func(w.obj, 252);
	w.func(w.obj, 208);
	w.func(w.obj, 7);
	w.func(w.obj, 56);
	w.func(w.obj, 32);
	ASAPWriter_WriteWord(w, depackerStartAddress);
	w.func(w.obj, 42);
	w.func(w.obj, 133);
	w.func(w.obj, 252);
	w.func(w.obj, 169);
	w.func(w.obj, 1);
	w.func(w.obj, 144);
	w.func(w.obj, 4);
	w.func(w.obj, 32);
	ASAPWriter_WriteWord(w, depackerStartAddress);
	w.func(w.obj, 42);
	w.func(w.obj, 133);
	w.func(w.obj, 253);
	w.func(w.obj, 32);
	ASAPWriter_WriteWord(w, depackerStartAddress);
	w.func(w.obj, 162);
	w.func(w.obj, 1);
	w.func(w.obj, 144);
	w.func(w.obj, 206);
	w.func(w.obj, 74);
	w.func(w.obj, 208);
	w.func(w.obj, 194);
	w.func(w.obj, 32);
	ASAPWriter_WriteWord(w, depackerStartAddress);
	w.func(w.obj, 176);
	w.func(w.obj, 193);
	w.func(w.obj, 168);
	w.func(w.obj, 32);
	ASAPWriter_WriteWord(w, depackerStartAddress);
	w.func(w.obj, 144);
	w.func(w.obj, 202);
	ASAPWriter_WriteWord(w, 736);
	ASAPWriter_WriteWord(w, 737);
	ASAPWriter_WriteWord(w, depackerStartAddress + 50);
	return TRUE;
}

static void FlashPack_CompressMemoryArea(FlashPack *self, int startAddress, int endAddress)
{
	int lastDistance = -1;
	{
		int address;
		for (address = startAddress; address <= endAddress;) {
			while (self->memory[address] < 0)
				if (++address > endAddress)
					return;
			FlashPack_PutItem(self, FlashPackItemType_SET_ADDRESS, address);
			while (address <= endAddress && self->memory[address] >= 0) {
				int bestMatch = 0;
				int bestDistance = -1;
				{
					int backAddress;
					for (backAddress = address - 1; backAddress >= startAddress && address - backAddress < 128; backAddress--) {
						int match;
						for (match = 0; address + match <= endAddress; match++) {
							int data = self->memory[address + match];
							if (data < 0 || data != self->memory[backAddress + match])
								break;
						}
						if (bestMatch < match) {
							bestMatch = match;
							bestDistance = address - backAddress;
						}
						else if (bestMatch == match && address - backAddress == lastDistance)
							bestDistance = lastDistance;
					}
				}
				switch (bestMatch) {
					int length;
				case 0:
				case 1:
					FlashPack_PutItem(self, FlashPackItemType_LITERAL, self->memory[address++]);
					continue;
				case 2:
					FlashPack_PutItem(self, FlashPackItemType_COPY_TWO_BYTES, bestDistance);
					break;
				case 3:
					FlashPack_PutItem(self, FlashPackItemType_COPY_THREE_BYTES, bestDistance);
					break;
				case 4:
					if (bestDistance == lastDistance)
						FlashPack_PutItem(self, FlashPackItemType_COPY_MANY_BYTES, 4);
					else if (FlashPack_IsLiteralPreferred(self)) {
						FlashPack_PutItem(self, FlashPackItemType_LITERAL, self->memory[address]);
						FlashPack_PutItem(self, FlashPackItemType_COPY_THREE_BYTES, bestDistance);
					}
					else {
						FlashPack_PutItem(self, FlashPackItemType_COPY_THREE_BYTES, bestDistance);
						FlashPack_PutItem(self, FlashPackItemType_LITERAL, self->memory[address + 3]);
					}
					break;
				case 5:
					if (bestDistance == lastDistance)
						FlashPack_PutItem(self, FlashPackItemType_COPY_MANY_BYTES, 5);
					else {
						FlashPack_PutItem(self, FlashPackItemType_COPY_THREE_BYTES, bestDistance);
						FlashPack_PutItem(self, FlashPackItemType_COPY_TWO_BYTES, bestDistance);
					}
					break;
				case 6:
					if (bestDistance == lastDistance)
						FlashPack_PutItem(self, FlashPackItemType_COPY_MANY_BYTES, 6);
					else {
						FlashPack_PutItem(self, FlashPackItemType_COPY_THREE_BYTES, bestDistance);
						FlashPack_PutItem(self, FlashPackItemType_COPY_THREE_BYTES, bestDistance);
					}
					break;
				default:
					length = bestMatch;
					if (bestDistance != lastDistance) {
						if (FlashPack_IsLiteralPreferred(self) && length % 255 == 4) {
							FlashPack_PutItem(self, FlashPackItemType_LITERAL, self->memory[address]);
							length--;
						}
						FlashPack_PutItem(self, FlashPackItemType_COPY_THREE_BYTES, bestDistance);
						length -= 3;
					}
					else if (FlashPack_IsLiteralPreferred(self) && length % 255 == 1) {
						FlashPack_PutItem(self, FlashPackItemType_LITERAL, self->memory[address]);
						length--;
					}
					for (; length > 255; length -= 255)
						FlashPack_PutItem(self, FlashPackItemType_COPY_MANY_BYTES, 255);
					switch (length) {
					case 0:
						break;
					case 1:
						FlashPack_PutItem(self, FlashPackItemType_LITERAL, self->memory[address + bestMatch - 1]);
						break;
					case 2:
						FlashPack_PutItem(self, FlashPackItemType_COPY_TWO_BYTES, bestDistance);
						break;
					case 3:
						FlashPack_PutItem(self, FlashPackItemType_COPY_THREE_BYTES, bestDistance);
						break;
					default:
						FlashPack_PutItem(self, FlashPackItemType_COPY_MANY_BYTES, length);
						break;
					}
					break;
				}
				address += bestMatch;
				lastDistance = bestDistance;
			}
		}
	}
}

static int FlashPack_FindHole(FlashPack const *self)
{
	int end = 48159;
	for (;;) {
		int start;
		while (self->memory[end] >= 0)
			if (--end < 9216)
				return -1;
		start = end;
		while (self->memory[--start] < 0)
			if (end - start >= 1023)
				return end;
		end = start;
	}
}

static int FlashPack_GetInnerFlags(FlashPack const *self, int index)
{
	int flags = 1;
	do {
		flags <<= 1;
		if (index < self->itemsCount && self->items[index++].type != FlashPackItemType_LITERAL)
			flags++;
	}
	while (flags < 256);
	return flags & 255;
}

static cibool FlashPack_IsLiteralPreferred(FlashPack const *self)
{
	return (self->itemsCount & 7) == 7 && FlashPack_GetInnerFlags(self, self->itemsCount - 7) == 0;
}

static void FlashPack_LoadByte(FlashPack *self, int data)
{
	switch (self->loadState) {
	case FlashPackLoadState_START_LOW_BYTE:
		self->loadAddress = data;
		self->loadState = FlashPackLoadState_START_HIGH_BYTE;
		break;
	case FlashPackLoadState_START_HIGH_BYTE:
		self->loadAddress += data << 8;
		self->loadState = self->loadAddress == 65535 ? FlashPackLoadState_START_LOW_BYTE : FlashPackLoadState_END_LOW_BYTE;
		break;
	case FlashPackLoadState_END_LOW_BYTE:
		self->loadEndAddress = data;
		self->loadState = FlashPackLoadState_END_HIGH_BYTE;
		break;
	case FlashPackLoadState_END_HIGH_BYTE:
		self->loadEndAddress += data << 8;
		self->loadState = FlashPackLoadState_CONTENT;
		break;
	case FlashPackLoadState_CONTENT:
		self->memory[self->loadAddress] = data;
		if (self->loadAddress == self->loadEndAddress)
			self->loadState = FlashPackLoadState_START_LOW_BYTE;
		else
			self->loadAddress = (self->loadAddress + 1) & 65535;
		break;
	}
}

static void FlashPack_PutItem(FlashPack *self, FlashPackItemType type, int value)
{
	if (self->itemsCount >= 64) {
		FlashPack_PutItems(self);
		self->itemsCount = 0;
	}
	self->items[self->itemsCount].type = type;
	self->items[self->itemsCount].value = value;
	self->itemsCount++;
}

static void FlashPack_PutItems(FlashPack *self)
{
	int outerFlags = 0;
	{
		int i;
		for (i = 0; i < self->itemsCount; i += 8) {
			if (FlashPack_GetInnerFlags(self, i) != 0)
				outerFlags |= 128 >> (i >> 3);
		}
	}
	self->compressed[self->compressedLength++] = outerFlags;
	{
		int i;
		for (i = 0; i < self->itemsCount; i++) {
			if ((i & 7) == 0) {
				int flags = FlashPack_GetInnerFlags(self, i);
				if (flags != 0)
					self->compressed[self->compressedLength++] = flags;
			}
			self->compressedLength += FlashPackItem_WriteValueTo(&self->items[i], self->compressed, self->compressedLength);
		}
	}
}

static void FlashPack_PutPoke(FlashPack *self, int address, int value)
{
	FlashPack_PutItem(self, FlashPackItemType_SET_ADDRESS, address);
	FlashPack_PutItem(self, FlashPackItemType_LITERAL, value);
}

static int FlashPackItem_WriteValueTo(FlashPackItem const *self, unsigned char *buffer, int index)
{
	switch (self->type) {
		int value;
	case FlashPackItemType_LITERAL:
		buffer[index] = self->value;
		return 1;
	case FlashPackItemType_COPY_TWO_BYTES:
		buffer[index] = (128 - self->value) << 1;
		return 1;
	case FlashPackItemType_COPY_THREE_BYTES:
		buffer[index] = ((128 - self->value) << 1) + 1;
		return 1;
	case FlashPackItemType_COPY_MANY_BYTES:
		buffer[index] = 1;
		buffer[index + 1] = self->value;
		return 2;
	case FlashPackItemType_SET_ADDRESS:
		value = self->value - 128;
		buffer[index] = 0;
		buffer[index + 1] = (unsigned char) value;
		buffer[index + 2] = value >> 8;
		return 3;
	default:
		buffer[index] = 1;
		buffer[index + 1] = 0;
		return 2;
	}
}

static void Pokey_AddDelta(Pokey *self, PokeyPair const *pokeys, int cycle, int delta)
{
	int i = cycle * pokeys->sampleFactor + pokeys->sampleOffset;
	int delta2 = (delta >> 16) * ((i >> 4) & 65535);
	i >>= 20;
	self->deltaBuffer[i] += delta - delta2;
	self->deltaBuffer[i + 1] += delta2;
}

static void Pokey_EndFrame(Pokey *self, PokeyPair const *pokeys, int cycle)
{
	int m;
	Pokey_GenerateUntilCycle(self, pokeys, cycle);
	self->polyIndex += cycle;
	m = (self->audctl & 128) != 0 ? 237615 : 60948015;
	if (self->polyIndex >= 2 * m)
		self->polyIndex -= m;
	if (self->tickCycle1 != 8388608)
		self->tickCycle1 -= cycle;
	if (self->tickCycle2 != 8388608)
		self->tickCycle2 -= cycle;
	if (self->tickCycle3 != 8388608)
		self->tickCycle3 -= cycle;
	if (self->tickCycle4 != 8388608)
		self->tickCycle4 -= cycle;
}

static void Pokey_GenerateUntilCycle(Pokey *self, PokeyPair const *pokeys, int cycleLimit)
{
	for (;;) {
		int cycle = cycleLimit;
		static const unsigned char poly4Lookup[15] = { 0, 0, 0, 0, 1, 1, 1, 0, 1, 1, 0, 0, 1, 0, 1 };
		static const unsigned char poly5Lookup[31] = { 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 1, 0, 0, 0, 1, 0,
			1, 0, 1, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 1, 1 };
		if (cycle > self->tickCycle1)
			cycle = self->tickCycle1;
		if (cycle > self->tickCycle2)
			cycle = self->tickCycle2;
		if (cycle > self->tickCycle3)
			cycle = self->tickCycle3;
		if (cycle > self->tickCycle4)
			cycle = self->tickCycle4;
		if (cycle == cycleLimit)
			break;
		if (cycle == self->tickCycle3) {
			self->tickCycle3 += self->periodCycles3;
			if ((self->audctl & 4) != 0 && self->delta1 > 0 && self->mute1 == 0) {
				self->delta1 = -self->delta1;
				Pokey_AddDelta(self, pokeys, cycle, self->delta1);
			}
			if (self->init) {
				switch (self->audc3 >> 4) {
				case 10:
				case 14:
					self->out3 ^= 1;
					self->delta3 = -self->delta3;
					Pokey_AddDelta(self, pokeys, cycle, self->delta3);
					break;
				default:
					break;
				}
			}
			else {
				int poly = cycle + self->polyIndex - 2;
				int newOut = self->out3;
				switch (self->audc3 >> 4) {
				case 0:
					if (poly5Lookup[poly % 31] != 0) {
						if ((self->audctl & 128) != 0)
							newOut = pokeys->poly9Lookup[poly % 511] & 1;
						else {
							poly %= 131071;
							newOut = (pokeys->poly17Lookup[poly >> 3] >> (poly & 7)) & 1;
						}
					}
					break;
				case 2:
				case 6:
					newOut ^= poly5Lookup[poly % 31];
					break;
				case 4:
					if (poly5Lookup[poly % 31] != 0)
						newOut = poly4Lookup[poly % 15];
					break;
				case 8:
					if ((self->audctl & 128) != 0)
						newOut = pokeys->poly9Lookup[poly % 511] & 1;
					else {
						poly %= 131071;
						newOut = (pokeys->poly17Lookup[poly >> 3] >> (poly & 7)) & 1;
					}
					break;
				case 10:
				case 14:
					newOut ^= 1;
					break;
				case 12:
					newOut = poly4Lookup[poly % 15];
					break;
				default:
					break;
				}
				if (newOut != self->out3) {
					self->out3 = newOut;
					self->delta3 = -self->delta3;
					Pokey_AddDelta(self, pokeys, cycle, self->delta3);
				}
			}
		}
		if (cycle == self->tickCycle4) {
			self->tickCycle4 += self->periodCycles4;
			if ((self->audctl & 8) != 0)
				self->tickCycle3 = cycle + self->reloadCycles3;
			if ((self->audctl & 2) != 0 && self->delta2 > 0 && self->mute2 == 0) {
				self->delta2 = -self->delta2;
				Pokey_AddDelta(self, pokeys, cycle, self->delta2);
			}
			if (self->init) {
				switch (self->audc4 >> 4) {
				case 10:
				case 14:
					self->out4 ^= 1;
					self->delta4 = -self->delta4;
					Pokey_AddDelta(self, pokeys, cycle, self->delta4);
					break;
				default:
					break;
				}
			}
			else {
				int poly = cycle + self->polyIndex - 3;
				int newOut = self->out4;
				switch (self->audc4 >> 4) {
				case 0:
					if (poly5Lookup[poly % 31] != 0) {
						if ((self->audctl & 128) != 0)
							newOut = pokeys->poly9Lookup[poly % 511] & 1;
						else {
							poly %= 131071;
							newOut = (pokeys->poly17Lookup[poly >> 3] >> (poly & 7)) & 1;
						}
					}
					break;
				case 2:
				case 6:
					newOut ^= poly5Lookup[poly % 31];
					break;
				case 4:
					if (poly5Lookup[poly % 31] != 0)
						newOut = poly4Lookup[poly % 15];
					break;
				case 8:
					if ((self->audctl & 128) != 0)
						newOut = pokeys->poly9Lookup[poly % 511] & 1;
					else {
						poly %= 131071;
						newOut = (pokeys->poly17Lookup[poly >> 3] >> (poly & 7)) & 1;
					}
					break;
				case 10:
				case 14:
					newOut ^= 1;
					break;
				case 12:
					newOut = poly4Lookup[poly % 15];
					break;
				default:
					break;
				}
				if (newOut != self->out4) {
					self->out4 = newOut;
					self->delta4 = -self->delta4;
					Pokey_AddDelta(self, pokeys, cycle, self->delta4);
				}
			}
		}
		if (cycle == self->tickCycle1) {
			self->tickCycle1 += self->periodCycles1;
			if ((self->skctl & 136) == 8)
				self->tickCycle2 = cycle + self->periodCycles2;
			if (self->init) {
				switch (self->audc1 >> 4) {
				case 10:
				case 14:
					self->out1 ^= 1;
					self->delta1 = -self->delta1;
					Pokey_AddDelta(self, pokeys, cycle, self->delta1);
					break;
				default:
					break;
				}
			}
			else {
				int poly = cycle + self->polyIndex - 0;
				int newOut = self->out1;
				switch (self->audc1 >> 4) {
				case 0:
					if (poly5Lookup[poly % 31] != 0) {
						if ((self->audctl & 128) != 0)
							newOut = pokeys->poly9Lookup[poly % 511] & 1;
						else {
							poly %= 131071;
							newOut = (pokeys->poly17Lookup[poly >> 3] >> (poly & 7)) & 1;
						}
					}
					break;
				case 2:
				case 6:
					newOut ^= poly5Lookup[poly % 31];
					break;
				case 4:
					if (poly5Lookup[poly % 31] != 0)
						newOut = poly4Lookup[poly % 15];
					break;
				case 8:
					if ((self->audctl & 128) != 0)
						newOut = pokeys->poly9Lookup[poly % 511] & 1;
					else {
						poly %= 131071;
						newOut = (pokeys->poly17Lookup[poly >> 3] >> (poly & 7)) & 1;
					}
					break;
				case 10:
				case 14:
					newOut ^= 1;
					break;
				case 12:
					newOut = poly4Lookup[poly % 15];
					break;
				default:
					break;
				}
				if (newOut != self->out1) {
					self->out1 = newOut;
					self->delta1 = -self->delta1;
					Pokey_AddDelta(self, pokeys, cycle, self->delta1);
				}
			}
		}
		if (cycle == self->tickCycle2) {
			self->tickCycle2 += self->periodCycles2;
			if ((self->audctl & 16) != 0)
				self->tickCycle1 = cycle + self->reloadCycles1;
			else if ((self->skctl & 8) != 0)
				self->tickCycle1 = cycle + self->periodCycles1;
			if (self->init) {
				switch (self->audc2 >> 4) {
				case 10:
				case 14:
					self->out2 ^= 1;
					self->delta2 = -self->delta2;
					Pokey_AddDelta(self, pokeys, cycle, self->delta2);
					break;
				default:
					break;
				}
			}
			else {
				int poly = cycle + self->polyIndex - 1;
				int newOut = self->out2;
				switch (self->audc2 >> 4) {
				case 0:
					if (poly5Lookup[poly % 31] != 0) {
						if ((self->audctl & 128) != 0)
							newOut = pokeys->poly9Lookup[poly % 511] & 1;
						else {
							poly %= 131071;
							newOut = (pokeys->poly17Lookup[poly >> 3] >> (poly & 7)) & 1;
						}
					}
					break;
				case 2:
				case 6:
					newOut ^= poly5Lookup[poly % 31];
					break;
				case 4:
					if (poly5Lookup[poly % 31] != 0)
						newOut = poly4Lookup[poly % 15];
					break;
				case 8:
					if ((self->audctl & 128) != 0)
						newOut = pokeys->poly9Lookup[poly % 511] & 1;
					else {
						poly %= 131071;
						newOut = (pokeys->poly17Lookup[poly >> 3] >> (poly & 7)) & 1;
					}
					break;
				case 10:
				case 14:
					newOut ^= 1;
					break;
				case 12:
					newOut = poly4Lookup[poly % 15];
					break;
				default:
					break;
				}
				if (newOut != self->out2) {
					self->out2 = newOut;
					self->delta2 = -self->delta2;
					Pokey_AddDelta(self, pokeys, cycle, self->delta2);
				}
			}
		}
	}
}

static void Pokey_Initialize(Pokey *self)
{
	self->audf1 = 0;
	self->audf2 = 0;
	self->audf3 = 0;
	self->audf4 = 0;
	self->audc1 = 0;
	self->audc2 = 0;
	self->audc3 = 0;
	self->audc4 = 0;
	self->audctl = 0;
	self->skctl = 3;
	self->init = FALSE;
	self->divCycles = 28;
	self->periodCycles1 = 28;
	self->periodCycles2 = 28;
	self->periodCycles3 = 28;
	self->periodCycles4 = 28;
	self->reloadCycles1 = 28;
	self->reloadCycles3 = 28;
	self->polyIndex = 60948015;
	self->tickCycle1 = 8388608;
	self->tickCycle2 = 8388608;
	self->tickCycle3 = 8388608;
	self->tickCycle4 = 8388608;
	self->mute1 = 1;
	self->mute2 = 1;
	self->mute3 = 1;
	self->mute4 = 1;
	self->out1 = 0;
	self->out2 = 0;
	self->out3 = 0;
	self->out4 = 0;
	self->delta1 = 0;
	self->delta2 = 0;
	self->delta3 = 0;
	self->delta4 = 0;
	memset(self->deltaBuffer, 0, sizeof(self->deltaBuffer));
}

static cibool Pokey_IsSilent(Pokey const *self)
{
	return ((self->audc1 | self->audc2 | self->audc3 | self->audc4) & 15) == 0;
}

static void Pokey_Mute(Pokey *self, int mask)
{
	if ((mask & 1) != 0) {
		self->mute1 |= 4;
		self->tickCycle1 = 8388608;
	}
	else {
		self->mute1 &= ~4;
		if (self->tickCycle1 == 8388608 && self->mute1 == 0)
			self->tickCycle1 = 0;
	}
	if ((mask & 2) != 0) {
		self->mute2 |= 4;
		self->tickCycle2 = 8388608;
	}
	else {
		self->mute2 &= ~4;
		if (self->tickCycle2 == 8388608 && self->mute2 == 0)
			self->tickCycle2 = 0;
	}
	if ((mask & 4) != 0) {
		self->mute3 |= 4;
		self->tickCycle3 = 8388608;
	}
	else {
		self->mute3 &= ~4;
		if (self->tickCycle3 == 8388608 && self->mute3 == 0)
			self->tickCycle3 = 0;
	}
	if ((mask & 8) != 0) {
		self->mute4 |= 4;
		self->tickCycle4 = 8388608;
	}
	else {
		self->mute4 &= ~4;
		if (self->tickCycle4 == 8388608 && self->mute4 == 0)
			self->tickCycle4 = 0;
	}
}

static void PokeyPair_Construct(PokeyPair *self)
{
	int reg = 511;
	{
		int i;
		for (i = 0; i < 511; i++) {
			reg = ((((reg >> 5) ^ reg) & 1) << 8) + (reg >> 1);
			self->poly9Lookup[i] = (unsigned char) reg;
		}
	}
	reg = 131071;
	{
		int i;
		for (i = 0; i < 16385; i++) {
			reg = ((((reg >> 5) ^ reg) & 255) << 9) + (reg >> 8);
			self->poly17Lookup[i] = (unsigned char) (reg >> 1);
		}
	}
}

static int PokeyPair_EndFrame(PokeyPair *self, int cycle)
{
	Pokey_EndFrame(&self->basePokey, self, cycle);
	if (self->extraPokeyMask != 0)
		Pokey_EndFrame(&self->extraPokey, self, cycle);
	self->sampleOffset += cycle * self->sampleFactor;
	self->readySamplesStart = 0;
	self->readySamplesEnd = self->sampleOffset >> 20;
	self->sampleOffset &= 1048575;
	return self->readySamplesEnd;
}

static int PokeyPair_Generate(PokeyPair *self, unsigned char *buffer, int bufferOffset, int blocks, ASAPSampleFormat format)
{
	int i = self->readySamplesStart;
	int samplesEnd = self->readySamplesEnd;
	int accLeft;
	int accRight;
	if (blocks < samplesEnd - i)
		samplesEnd = i + blocks;
	else
		blocks = samplesEnd - i;
	accLeft = self->iirAccLeft;
	accRight = self->iirAccRight;
	for (; i < samplesEnd; i++) {
		int sample;
		accLeft += self->basePokey.deltaBuffer[i] - (accLeft * 3 >> 10);
		sample = accLeft >> 10;
		if (sample < -32767)
			sample = -32767;
		else if (sample > 32767)
			sample = 32767;
		switch (format) {
		case ASAPSampleFormat_U8:
			buffer[bufferOffset++] = (sample >> 8) + 128;
			break;
		case ASAPSampleFormat_S16_L_E:
			buffer[bufferOffset++] = (unsigned char) sample;
			buffer[bufferOffset++] = (unsigned char) (sample >> 8);
			break;
		case ASAPSampleFormat_S16_B_E:
			buffer[bufferOffset++] = (unsigned char) (sample >> 8);
			buffer[bufferOffset++] = (unsigned char) sample;
			break;
		}
		if (self->extraPokeyMask != 0) {
			accRight += self->extraPokey.deltaBuffer[i] - (accRight * 3 >> 10);
			sample = accRight >> 10;
			if (sample < -32767)
				sample = -32767;
			else if (sample > 32767)
				sample = 32767;
			switch (format) {
			case ASAPSampleFormat_U8:
				buffer[bufferOffset++] = (sample >> 8) + 128;
				break;
			case ASAPSampleFormat_S16_L_E:
				buffer[bufferOffset++] = (unsigned char) sample;
				buffer[bufferOffset++] = (unsigned char) (sample >> 8);
				break;
			case ASAPSampleFormat_S16_B_E:
				buffer[bufferOffset++] = (unsigned char) (sample >> 8);
				buffer[bufferOffset++] = (unsigned char) sample;
				break;
			}
		}
	}
	if (i == self->readySamplesEnd) {
		accLeft += self->basePokey.deltaBuffer[i] + self->basePokey.deltaBuffer[i + 1];
		accRight += self->extraPokey.deltaBuffer[i] + self->extraPokey.deltaBuffer[i + 1];
	}
	self->readySamplesStart = i;
	self->iirAccLeft = accLeft;
	self->iirAccRight = accRight;
	return blocks;
}

static int PokeyPair_GetRandom(PokeyPair const *self, int addr, int cycle)
{
	Pokey const *pokey = (addr & self->extraPokeyMask) != 0 ? &self->extraPokey : &self->basePokey;
	int i;
	int j;
	if (pokey->init)
		return 255;
	i = cycle + pokey->polyIndex;
	if ((pokey->audctl & 128) != 0)
		return self->poly9Lookup[i % 511];
	i %= 131071;
	j = i >> 3;
	i &= 7;
	return ((self->poly17Lookup[j] >> i) + (self->poly17Lookup[j + 1] << (8 - i))) & 255;
}

static void PokeyPair_Initialize(PokeyPair *self, cibool ntsc, cibool stereo)
{
	self->extraPokeyMask = stereo ? 16 : 0;
	self->timer1Cycle = 8388608;
	self->timer2Cycle = 8388608;
	self->timer4Cycle = 8388608;
	self->irqst = 255;
	Pokey_Initialize(&self->basePokey);
	Pokey_Initialize(&self->extraPokey);
	self->sampleFactor = ntsc ? 25837 : 26075;
	self->sampleOffset = 0;
	self->readySamplesStart = 0;
	self->readySamplesEnd = 0;
	self->iirAccLeft = 0;
	self->iirAccRight = 0;
}

static cibool PokeyPair_IsSilent(PokeyPair const *self)
{
	return Pokey_IsSilent(&self->basePokey) && Pokey_IsSilent(&self->extraPokey);
}

static void PokeyPair_Poke(PokeyPair *self, int addr, int data, int cycle)
{
	Pokey *pokey = (addr & self->extraPokeyMask) != 0 ? &self->extraPokey : &self->basePokey;
	switch (addr & 15) {
		cibool init;
	case 0:
		if (data == pokey->audf1)
			break;
		Pokey_GenerateUntilCycle(pokey, self, cycle);
		pokey->audf1 = data;
		switch (pokey->audctl & 80) {
		case 0:
			pokey->periodCycles1 = pokey->divCycles * (data + 1);
			break;
		case 16:
			pokey->periodCycles2 = pokey->divCycles * (data + (pokey->audf2 << 8) + 1);
			pokey->reloadCycles1 = pokey->divCycles * (data + 1);
			if (pokey->periodCycles2 <= 112 && (pokey->audc2 >> 4 == 10 || pokey->audc2 >> 4 == 14)) {
				pokey->mute2 |= 1;
				pokey->tickCycle2 = 8388608;
			}
			else {
				pokey->mute2 &= ~1;
				if (pokey->tickCycle2 == 8388608 && pokey->mute2 == 0)
					pokey->tickCycle2 = cycle;
			}
			break;
		case 64:
			pokey->periodCycles1 = data + 4;
			break;
		case 80:
			pokey->periodCycles2 = data + (pokey->audf2 << 8) + 7;
			pokey->reloadCycles1 = data + 4;
			if (pokey->periodCycles2 <= 112 && (pokey->audc2 >> 4 == 10 || pokey->audc2 >> 4 == 14)) {
				pokey->mute2 |= 1;
				pokey->tickCycle2 = 8388608;
			}
			else {
				pokey->mute2 &= ~1;
				if (pokey->tickCycle2 == 8388608 && pokey->mute2 == 0)
					pokey->tickCycle2 = cycle;
			}
			break;
		}
		if (pokey->periodCycles1 <= 112 && (pokey->audc1 >> 4 == 10 || pokey->audc1 >> 4 == 14)) {
			pokey->mute1 |= 1;
			pokey->tickCycle1 = 8388608;
		}
		else {
			pokey->mute1 &= ~1;
			if (pokey->tickCycle1 == 8388608 && pokey->mute1 == 0)
				pokey->tickCycle1 = cycle;
		}
		break;
	case 1:
		if (data == pokey->audc1)
			break;
		Pokey_GenerateUntilCycle(pokey, self, cycle);
		pokey->audc1 = data;
		if ((data & 16) != 0) {
			data = (data & 15) << 20;
			if ((pokey->mute1 & 4) == 0)
				Pokey_AddDelta(pokey, self, cycle, pokey->delta1 > 0 ? data - pokey->delta1 : data);
			pokey->delta1 = data;
		}
		else {
			data = (data & 15) << 20;
			if (pokey->periodCycles1 <= 112 && (pokey->audc1 >> 4 == 10 || pokey->audc1 >> 4 == 14)) {
				pokey->mute1 |= 1;
				pokey->tickCycle1 = 8388608;
			}
			else {
				pokey->mute1 &= ~1;
				if (pokey->tickCycle1 == 8388608 && pokey->mute1 == 0)
					pokey->tickCycle1 = cycle;
			}
			if (pokey->delta1 > 0) {
				if ((pokey->mute1 & 4) == 0)
					Pokey_AddDelta(pokey, self, cycle, data - pokey->delta1);
				pokey->delta1 = data;
			}
			else
				pokey->delta1 = -data;
		}
		break;
	case 2:
		if (data == pokey->audf2)
			break;
		Pokey_GenerateUntilCycle(pokey, self, cycle);
		pokey->audf2 = data;
		switch (pokey->audctl & 80) {
		case 0:
		case 64:
			pokey->periodCycles2 = pokey->divCycles * (data + 1);
			break;
		case 16:
			pokey->periodCycles2 = pokey->divCycles * (pokey->audf1 + (data << 8) + 1);
			break;
		case 80:
			pokey->periodCycles2 = pokey->audf1 + (data << 8) + 7;
			break;
		}
		if (pokey->periodCycles2 <= 112 && (pokey->audc2 >> 4 == 10 || pokey->audc2 >> 4 == 14)) {
			pokey->mute2 |= 1;
			pokey->tickCycle2 = 8388608;
		}
		else {
			pokey->mute2 &= ~1;
			if (pokey->tickCycle2 == 8388608 && pokey->mute2 == 0)
				pokey->tickCycle2 = cycle;
		}
		break;
	case 3:
		if (data == pokey->audc2)
			break;
		Pokey_GenerateUntilCycle(pokey, self, cycle);
		pokey->audc2 = data;
		if ((data & 16) != 0) {
			data = (data & 15) << 20;
			if ((pokey->mute2 & 4) == 0)
				Pokey_AddDelta(pokey, self, cycle, pokey->delta2 > 0 ? data - pokey->delta2 : data);
			pokey->delta2 = data;
		}
		else {
			data = (data & 15) << 20;
			if (pokey->periodCycles2 <= 112 && (pokey->audc2 >> 4 == 10 || pokey->audc2 >> 4 == 14)) {
				pokey->mute2 |= 1;
				pokey->tickCycle2 = 8388608;
			}
			else {
				pokey->mute2 &= ~1;
				if (pokey->tickCycle2 == 8388608 && pokey->mute2 == 0)
					pokey->tickCycle2 = cycle;
			}
			if (pokey->delta2 > 0) {
				if ((pokey->mute2 & 4) == 0)
					Pokey_AddDelta(pokey, self, cycle, data - pokey->delta2);
				pokey->delta2 = data;
			}
			else
				pokey->delta2 = -data;
		}
		break;
	case 4:
		if (data == pokey->audf3)
			break;
		Pokey_GenerateUntilCycle(pokey, self, cycle);
		pokey->audf3 = data;
		switch (pokey->audctl & 40) {
		case 0:
			pokey->periodCycles3 = pokey->divCycles * (data + 1);
			break;
		case 8:
			pokey->periodCycles4 = pokey->divCycles * (data + (pokey->audf4 << 8) + 1);
			pokey->reloadCycles3 = pokey->divCycles * (data + 1);
			if (pokey->periodCycles4 <= 112 && (pokey->audc4 >> 4 == 10 || pokey->audc4 >> 4 == 14)) {
				pokey->mute4 |= 1;
				pokey->tickCycle4 = 8388608;
			}
			else {
				pokey->mute4 &= ~1;
				if (pokey->tickCycle4 == 8388608 && pokey->mute4 == 0)
					pokey->tickCycle4 = cycle;
			}
			break;
		case 32:
			pokey->periodCycles3 = data + 4;
			break;
		case 40:
			pokey->periodCycles4 = data + (pokey->audf4 << 8) + 7;
			pokey->reloadCycles3 = data + 4;
			if (pokey->periodCycles4 <= 112 && (pokey->audc4 >> 4 == 10 || pokey->audc4 >> 4 == 14)) {
				pokey->mute4 |= 1;
				pokey->tickCycle4 = 8388608;
			}
			else {
				pokey->mute4 &= ~1;
				if (pokey->tickCycle4 == 8388608 && pokey->mute4 == 0)
					pokey->tickCycle4 = cycle;
			}
			break;
		}
		if (pokey->periodCycles3 <= 112 && (pokey->audc3 >> 4 == 10 || pokey->audc3 >> 4 == 14)) {
			pokey->mute3 |= 1;
			pokey->tickCycle3 = 8388608;
		}
		else {
			pokey->mute3 &= ~1;
			if (pokey->tickCycle3 == 8388608 && pokey->mute3 == 0)
				pokey->tickCycle3 = cycle;
		}
		break;
	case 5:
		if (data == pokey->audc3)
			break;
		Pokey_GenerateUntilCycle(pokey, self, cycle);
		pokey->audc3 = data;
		if ((data & 16) != 0) {
			data = (data & 15) << 20;
			if ((pokey->mute3 & 4) == 0)
				Pokey_AddDelta(pokey, self, cycle, pokey->delta3 > 0 ? data - pokey->delta3 : data);
			pokey->delta3 = data;
		}
		else {
			data = (data & 15) << 20;
			if (pokey->periodCycles3 <= 112 && (pokey->audc3 >> 4 == 10 || pokey->audc3 >> 4 == 14)) {
				pokey->mute3 |= 1;
				pokey->tickCycle3 = 8388608;
			}
			else {
				pokey->mute3 &= ~1;
				if (pokey->tickCycle3 == 8388608 && pokey->mute3 == 0)
					pokey->tickCycle3 = cycle;
			}
			if (pokey->delta3 > 0) {
				if ((pokey->mute3 & 4) == 0)
					Pokey_AddDelta(pokey, self, cycle, data - pokey->delta3);
				pokey->delta3 = data;
			}
			else
				pokey->delta3 = -data;
		}
		break;
	case 6:
		if (data == pokey->audf4)
			break;
		Pokey_GenerateUntilCycle(pokey, self, cycle);
		pokey->audf4 = data;
		switch (pokey->audctl & 40) {
		case 0:
		case 32:
			pokey->periodCycles4 = pokey->divCycles * (data + 1);
			break;
		case 8:
			pokey->periodCycles4 = pokey->divCycles * (pokey->audf3 + (data << 8) + 1);
			break;
		case 40:
			pokey->periodCycles4 = pokey->audf3 + (data << 8) + 7;
			break;
		}
		if (pokey->periodCycles4 <= 112 && (pokey->audc4 >> 4 == 10 || pokey->audc4 >> 4 == 14)) {
			pokey->mute4 |= 1;
			pokey->tickCycle4 = 8388608;
		}
		else {
			pokey->mute4 &= ~1;
			if (pokey->tickCycle4 == 8388608 && pokey->mute4 == 0)
				pokey->tickCycle4 = cycle;
		}
		break;
	case 7:
		if (data == pokey->audc4)
			break;
		Pokey_GenerateUntilCycle(pokey, self, cycle);
		pokey->audc4 = data;
		if ((data & 16) != 0) {
			data = (data & 15) << 20;
			if ((pokey->mute4 & 4) == 0)
				Pokey_AddDelta(pokey, self, cycle, pokey->delta4 > 0 ? data - pokey->delta4 : data);
			pokey->delta4 = data;
		}
		else {
			data = (data & 15) << 20;
			if (pokey->periodCycles4 <= 112 && (pokey->audc4 >> 4 == 10 || pokey->audc4 >> 4 == 14)) {
				pokey->mute4 |= 1;
				pokey->tickCycle4 = 8388608;
			}
			else {
				pokey->mute4 &= ~1;
				if (pokey->tickCycle4 == 8388608 && pokey->mute4 == 0)
					pokey->tickCycle4 = cycle;
			}
			if (pokey->delta4 > 0) {
				if ((pokey->mute4 & 4) == 0)
					Pokey_AddDelta(pokey, self, cycle, data - pokey->delta4);
				pokey->delta4 = data;
			}
			else
				pokey->delta4 = -data;
		}
		break;
	case 8:
		if (data == pokey->audctl)
			break;
		Pokey_GenerateUntilCycle(pokey, self, cycle);
		pokey->audctl = data;
		pokey->divCycles = (data & 1) != 0 ? 114 : 28;
		switch (data & 80) {
		case 0:
			pokey->periodCycles1 = pokey->divCycles * (pokey->audf1 + 1);
			pokey->periodCycles2 = pokey->divCycles * (pokey->audf2 + 1);
			break;
		case 16:
			pokey->periodCycles1 = pokey->divCycles << 8;
			pokey->periodCycles2 = pokey->divCycles * (pokey->audf1 + (pokey->audf2 << 8) + 1);
			pokey->reloadCycles1 = pokey->divCycles * (pokey->audf1 + 1);
			break;
		case 64:
			pokey->periodCycles1 = pokey->audf1 + 4;
			pokey->periodCycles2 = pokey->divCycles * (pokey->audf2 + 1);
			break;
		case 80:
			pokey->periodCycles1 = 256;
			pokey->periodCycles2 = pokey->audf1 + (pokey->audf2 << 8) + 7;
			pokey->reloadCycles1 = pokey->audf1 + 4;
			break;
		}
		if (pokey->periodCycles1 <= 112 && (pokey->audc1 >> 4 == 10 || pokey->audc1 >> 4 == 14)) {
			pokey->mute1 |= 1;
			pokey->tickCycle1 = 8388608;
		}
		else {
			pokey->mute1 &= ~1;
			if (pokey->tickCycle1 == 8388608 && pokey->mute1 == 0)
				pokey->tickCycle1 = cycle;
		}
		if (pokey->periodCycles2 <= 112 && (pokey->audc2 >> 4 == 10 || pokey->audc2 >> 4 == 14)) {
			pokey->mute2 |= 1;
			pokey->tickCycle2 = 8388608;
		}
		else {
			pokey->mute2 &= ~1;
			if (pokey->tickCycle2 == 8388608 && pokey->mute2 == 0)
				pokey->tickCycle2 = cycle;
		}
		switch (data & 40) {
		case 0:
			pokey->periodCycles3 = pokey->divCycles * (pokey->audf3 + 1);
			pokey->periodCycles4 = pokey->divCycles * (pokey->audf4 + 1);
			break;
		case 8:
			pokey->periodCycles3 = pokey->divCycles << 8;
			pokey->periodCycles4 = pokey->divCycles * (pokey->audf3 + (pokey->audf4 << 8) + 1);
			pokey->reloadCycles3 = pokey->divCycles * (pokey->audf3 + 1);
			break;
		case 32:
			pokey->periodCycles3 = pokey->audf3 + 4;
			pokey->periodCycles4 = pokey->divCycles * (pokey->audf4 + 1);
			break;
		case 40:
			pokey->periodCycles3 = 256;
			pokey->periodCycles4 = pokey->audf3 + (pokey->audf4 << 8) + 7;
			pokey->reloadCycles3 = pokey->audf3 + 4;
			break;
		}
		if (pokey->periodCycles3 <= 112 && (pokey->audc3 >> 4 == 10 || pokey->audc3 >> 4 == 14)) {
			pokey->mute3 |= 1;
			pokey->tickCycle3 = 8388608;
		}
		else {
			pokey->mute3 &= ~1;
			if (pokey->tickCycle3 == 8388608 && pokey->mute3 == 0)
				pokey->tickCycle3 = cycle;
		}
		if (pokey->periodCycles4 <= 112 && (pokey->audc4 >> 4 == 10 || pokey->audc4 >> 4 == 14)) {
			pokey->mute4 |= 1;
			pokey->tickCycle4 = 8388608;
		}
		else {
			pokey->mute4 &= ~1;
			if (pokey->tickCycle4 == 8388608 && pokey->mute4 == 0)
				pokey->tickCycle4 = cycle;
		}
		if (pokey->init && (data & 64) == 0) {
			pokey->mute1 |= 2;
			pokey->tickCycle1 = 8388608;
		}
		else {
			pokey->mute1 &= ~2;
			if (pokey->tickCycle1 == 8388608 && pokey->mute1 == 0)
				pokey->tickCycle1 = cycle;
		}
		if (pokey->init && (data & 80) != 80) {
			pokey->mute2 |= 2;
			pokey->tickCycle2 = 8388608;
		}
		else {
			pokey->mute2 &= ~2;
			if (pokey->tickCycle2 == 8388608 && pokey->mute2 == 0)
				pokey->tickCycle2 = cycle;
		}
		if (pokey->init && (data & 32) == 0) {
			pokey->mute3 |= 2;
			pokey->tickCycle3 = 8388608;
		}
		else {
			pokey->mute3 &= ~2;
			if (pokey->tickCycle3 == 8388608 && pokey->mute3 == 0)
				pokey->tickCycle3 = cycle;
		}
		if (pokey->init && (data & 40) != 40) {
			pokey->mute4 |= 2;
			pokey->tickCycle4 = 8388608;
		}
		else {
			pokey->mute4 &= ~2;
			if (pokey->tickCycle4 == 8388608 && pokey->mute4 == 0)
				pokey->tickCycle4 = cycle;
		}
		break;
	case 9:
		if (pokey->tickCycle1 != 8388608)
			pokey->tickCycle1 = cycle + pokey->periodCycles1;
		if (pokey->tickCycle2 != 8388608)
			pokey->tickCycle2 = cycle + pokey->periodCycles2;
		if (pokey->tickCycle3 != 8388608)
			pokey->tickCycle3 = cycle + pokey->periodCycles3;
		if (pokey->tickCycle4 != 8388608)
			pokey->tickCycle4 = cycle + pokey->periodCycles4;
		break;
	case 15:
		if (data == pokey->skctl)
			break;
		Pokey_GenerateUntilCycle(pokey, self, cycle);
		pokey->skctl = data;
		init = (data & 3) == 0;
		if (pokey->init && !init)
			pokey->polyIndex = ((pokey->audctl & 128) != 0 ? 237614 : 60948014) - cycle;
		pokey->init = init;
		if (pokey->init && (pokey->audctl & 64) == 0) {
			pokey->mute1 |= 2;
			pokey->tickCycle1 = 8388608;
		}
		else {
			pokey->mute1 &= ~2;
			if (pokey->tickCycle1 == 8388608 && pokey->mute1 == 0)
				pokey->tickCycle1 = cycle;
		}
		if (pokey->init && (pokey->audctl & 80) != 80) {
			pokey->mute2 |= 2;
			pokey->tickCycle2 = 8388608;
		}
		else {
			pokey->mute2 &= ~2;
			if (pokey->tickCycle2 == 8388608 && pokey->mute2 == 0)
				pokey->tickCycle2 = cycle;
		}
		if (pokey->init && (pokey->audctl & 32) == 0) {
			pokey->mute3 |= 2;
			pokey->tickCycle3 = 8388608;
		}
		else {
			pokey->mute3 &= ~2;
			if (pokey->tickCycle3 == 8388608 && pokey->mute3 == 0)
				pokey->tickCycle3 = cycle;
		}
		if (pokey->init && (pokey->audctl & 40) != 40) {
			pokey->mute4 |= 2;
			pokey->tickCycle4 = 8388608;
		}
		else {
			pokey->mute4 &= ~2;
			if (pokey->tickCycle4 == 8388608 && pokey->mute4 == 0)
				pokey->tickCycle4 = cycle;
		}
		if ((data & 16) != 0) {
			pokey->mute3 |= 8;
			pokey->tickCycle3 = 8388608;
		}
		else {
			pokey->mute3 &= ~8;
			if (pokey->tickCycle3 == 8388608 && pokey->mute3 == 0)
				pokey->tickCycle3 = cycle;
		}
		if ((data & 16) != 0) {
			pokey->mute4 |= 8;
			pokey->tickCycle4 = 8388608;
		}
		else {
			pokey->mute4 &= ~8;
			if (pokey->tickCycle4 == 8388608 && pokey->mute4 == 0)
				pokey->tickCycle4 = cycle;
		}
		break;
	default:
		break;
	}
}

static void PokeyPair_StartFrame(PokeyPair *self)
{
	memset(self->basePokey.deltaBuffer, 0, sizeof(self->basePokey.deltaBuffer));
	if (self->extraPokeyMask != 0)
		memset(self->extraPokey.deltaBuffer, 0, sizeof(self->extraPokey.deltaBuffer));
}
